19.4 Control Functions
======================

The initialization script compinit redefines all the widgets which
perform completion to call the supplied widget function _main_complete.
This function acts as a wrapper calling the so-called `completer'
functions that generate matches.  If _main_complete is called with
arguments, these are taken as the names of completer functions to be
called in the order given.  If no arguments are given, the set of
functions to try is taken from the completer style.  For example, to
use normal completion and correction if that doesn't generate any
matches:

     zstyle ':completion:*' completer _complete _correct

after calling compinit. The default value for this style is `_complete
_ignored', i.e. normally only ordinary completion is tried, first with
the effect of the ignored-patterns style and then without it.  The
_main_complete function uses the return value of the completer
functions to decide if other completers should be called.  If the return
value is zero, no other completers are tried and the _main_complete
function returns.

If the first argument to _main_complete is a single hyphen, the
arguments will not be taken as names of completers.  Instead, the
second argument gives a name to use in the COMPLETER field of the
context and the other arguments give a command name and arguments to
call to generate the matches.

The following completer functions are contained in the distribution,
although users may write their own.  Note that in contexts the leading
underscore is stripped, for example basic completion is performed in the
context `:completion::complete:...'.

_all_matches
     This completer can be used to add a string consisting of all other
     matches.  As it influences later completers it must appear as the
     first completer in the list.  The list of all matches is affected
     by the avoid-completer and old-matches styles described above.

     It may be useful to use the _generic function described below to
     bind _all_matches to its own keystroke, for example:

          zle -C all-matches complete-word _generic
          bindkey '^Xa' all-matches
          zstyle ':completion:all-matches:*' old-matches only
          zstyle ':completion:all-matches::::' completer _all_matches

_approximate
     This is similar to the basic _complete completer but allows the
     completions to undergo corrections.  The maximum number of errors
     can be specified by the max-errors style; see the description of
     approximate matching in Filename Generation for how errors
     are counted.  Normally this completer will only be tried after the
     normal _complete completer:

          zstyle ':completion:*' completer _complete _approximate

     This will give correcting completion if and only if normal
     completion yields no possible completions.  When corrected
     completions are found, the completer will normally start menu
     completion allowing you to cycle through these strings.

     This completer uses the tags corrections and original when
     generating the possible corrections and the original string.  The
     format style for the former may contain the additional sequences
     `%e' and `%o' which will be replaced by the number of errors
     accepted to generate the corrections and the original string,
     respectively.

     The completer progressively increases the number of errors allowed
     up to the limit by the max-errors style, hence if a completion is
     found with one error, no completions with two errors will be
     shown, and so on.  It modifies the completer name in the context
     to indicate the number of errors being tried: on the first try the
     completer field contains `approximate-1', on the second try
     `approximate-2', and so on.

     When _approximate is called from another function, the number of
     errors to accept may be passed with the -a option.  The argument
     is in the same format as the max-errors style, all in one string.

     Note that this completer (and the _correct completer mentioned
     below) can be quite expensive to call, especially when a large
     number of errors are allowed.  One way to avoid this is to set up
     the completer style using the -e option to zstyle so that some
     completers are only used when completion is attempted a second
     time on the same string, e.g.:

          zstyle -e ':completion:*' completer '
            if [[ $_last_try != "$HISTNO$BUFFER$CURSOR" ]]; then
              _last_try="$HISTNO$BUFFER$CURSOR"
              reply=(_complete _match _prefix)
            else
              reply=(_ignored _correct _approximate)
            fi'

     This uses the HISTNO parameter and the BUFFER and CURSOR special
     parameters that are available inside zle and completion widgets to
     find out if the command line hasn't changed since the last time
     completion was tried.  Only then are the _ignored, _correct and
     _approximate completers called.

_complete
     This completer generates all possible completions in a
     context-sensitive manner, i.e. using the settings defined with the
     compdef function explained above and the current settings of all
     special parameters.  This gives the normal completion behaviour.

     To complete arguments of commands, _complete uses the utility
     function _normal, which is in turn responsible for finding the
     particular function; it is described below.  Various contexts of
     the form -CONTEXT- are handled specifically. These are all
     mentioned above as possible arguments to the #compdef tag.

     Before trying to find a function for a specific context, _complete
     checks if the parameter `compcontext' is set. Setting
     `compcontext' allows the usual completion dispatching to be
     overridden which is useful in places such as a function that uses
     vared for input. If it is set to an array, the elements are taken
     to be the possible matches which will be completed using the tag
     `values' and the description `value'. If it is set to an
     associative array, the keys are used as the possible completions
     and the values (if non-empty) are used as descriptions for the
     matches.  If `compcontext' is set to a string containing colons,
     it should be of the form `TAG:DESCR:ACTION'.  In this case the TAG
     and DESCR give the tag and description to use and the ACTION
     indicates what should be completed in one of the forms accepted by
     the _arguments utility function described below.

     Finally, if `compcontext' is set to a string without colons, the
     value is taken as the name of the context to use and the function
     defined for that context will be called.  For this purpose, there
     is a special context named -command-line- that completes whole
     command lines (commands and their arguments).  This is not used by
     the completion system itself but is nonetheless handled when
     explicitly called.

_correct
     Generate corrections, but not completions, for the current word;
     this is similar to _approximate but will not allow any number of
     extra characters at the cursor as that completer does.  The effect
     is similar to spell-checking.  It is based on _approximate, but the
     completer field in the context name is correct.

     For example, with:

          zstyle ':completion:::::' completer _complete _correct _approximate
          zstyle ':completion:*:correct:::' max-errors 2 not-numeric
          zstyle ':completion:*:approximate:::' max-errors 3 numeric

     correction will accept up to two errors.  If a numeric argument is
     given, correction will not be performed, but correcting completion
     will be, and will accept as many errors as given by the numeric
     argument.  Without a numeric argument, first correction and then
     correcting completion will be tried, with the first one accepting
     two errors and the second one accepting three errors.

     When _correct is called as a function, the number of errors to
     accept may be given following the -a option.  The argument is in
     the same form a values to the accept style, all in one string.

     This completer function is intended to be used without the
     _approximate completer or, as in the example, just before it.
     Using it after the _approximate completer is useless since
     _approximate will at least generate the corrected strings
     generated by the _correct completer - and probably more.

_expand
     This completer function does not really perform completion, but
     instead checks if the word on the command line is eligible for
     expansion and, if it is, gives detailed control over how this
     expansion is done.  For this to happen, the completion system
     needs to be invoked with complete-word, not expand-or-complete
     (the default binding for TAB), as otherwise the string will be
     expanded by the shell's internal mechanism before the completion
     system is started.  Note also this completer should be called
     before the _complete completer function.

     The tags used when generating expansions are all-expansions for the
     string containing all possible expansions, expansions when adding
     the possible expansions as single matches and original when adding
     the original string from the line.  The order in which these
     strings are generated, if at all, can be controlled by the
     group-order and tag-order styles, as usual.

     The format string for all-expansions and for expansions may
     contain the sequence `%o' which will be replaced by the original
     string from the line.

     The kind of expansion to be tried is controlled by the substitute,
     glob and subst-globs-only styles.

     It is also possible to call _expand as a function, in which case
     the different modes may be selected with options: -s for
     substitute, -g for glob and -o for subst-globs-only.

_expand_alias
     If the word the cursor is on is an alias, it is expanded and no
     other completers are called.  The types of aliases which are to be
     expanded can be controlled with the styles regular, global and
     disabled.

     This function is also a bindable command, see Bindable Commands.

_history
     Complete words from the shell's command  history.  This completer
     can be controlled by the remove-all-dups, and sort styles as for
     the _history_complete_word bindable command, see Bindable Commands
     and Completion System Configuration.

_ignored
     The ignored-patterns style can be set to a list of patterns which
     are compared against possible completions; matching ones are
     removed.  With this completer those matches can be reinstated, as
     if no ignored-patterns style were set.  The completer actually
     generates its own list of matches; which completers are invoked is
     determined in the same way as for the _prefix completer.  The
     single-ignored style is also available as described above.

_list
     This completer allows the insertion of matches to be delayed until
     completion is attempted a second time without the word on the line
     being changed.  On the first attempt, only the list of matches
     will be shown.  It is affected by the styles condition and word,
     see Completion System Configuration.

_match
     This completer is intended to be used after the _complete
     completer.  It behaves similarly but the string on the command
     line may be a pattern to match against trial completions.  This
     gives the effect of the GLOB_COMPLETE option.

     Normally completion will be performed by taking the pattern from
     the line, inserting a `*' at the cursor position and comparing the
     resulting pattern with the possible completions generated.  This
     can be modified with the match-original style described above.

     The generated matches will be offered in a menu completion unless
     the insert-unambiguous style is set to `true'; see the description
     above for other options for this style.

     Note that matcher specifications defined globally or used by the
     completion functions (the styles matcher-list and matcher) will
     not be used.

_menu
     This completer was written as simple example function to show how
     menu completion can be enabled in shell code. However, it has the
     notable effect of disabling menu selection which can be useful with
     _generic based widgets. It should be used as the first completer in
     the list.  Note that this is independent of the setting of the
     MENU_COMPLETE option and does not work with the other menu
     completion widgets such as reverse-menu-complete, or
     accept-and-menu-complete.

_oldlist
     This completer controls how the standard completion widgets behave
     when there is an existing list of completions which may have been
     generated by a special completion (i.e. a separately-bound
     completion command).  It allows the ordinary completion keys to
     continue to use the list of completions thus generated, instead of
     producing a new list of ordinary contextual completions.  It
     should appear in the list of completers before any of the widgets
     which generate matches.  It uses two styles: old-list and
     old-menu, see Completion System Configuration.

_prefix
     This completer can be used to try completion with the suffix
     (everything after the cursor) ignored.  In other words, the suffix
     will not be considered to be part of the word to complete.  The
     effect is similar to the expand-or-complete-prefix command.

     The completer style is used to decide which other completers are to
     be called to generate matches.  If this style is unset, the list of
     completers set for the current context is used - except, of
     course, the _prefix completer itself.  Furthermore, if this
     completer appears more than once in the list of completers only
     those completers not already tried by the last invocation of
     _prefix will be called.

     For example, consider this global completer style:

          zstyle ':completion:*' completer \
              _complete _prefix _correct _prefix:foo

     Here, the _prefix completer tries normal completion but ignoring
     the suffix.  If that doesn't generate any matches, and neither does
     the call to the _correct completer after it, _prefix will be
     called a second time and, now only trying correction with the
     suffix ignored.  On the second invocation the completer part of the
     context appears as `foo'.

     To use _prefix as the last resort and try only normal completion
     when it is invoked:

          zstyle ':completion:*' completer _complete ... _prefix
          zstyle ':completion::prefix:*' completer _complete

     The add-space style is also respected.  If it is set to `true' then
     _prefix will insert a space between the matches generated (if any)
     and the suffix.

     Note that this completer is only useful if the COMPLETE_IN_WORD
     option is set; otherwise, the cursor will be moved to the end of
     the current word before the completion code is called and hence
     there will be no suffix.

bashcompinit
     This function provides compatibility with bash's programmable
     completion system.  When run it will define the functions, compgen
     and complete which correspond to the bash builtins with the same
     names.  It will then be possible to use completion specifications
     and functions written for bash.

19.5 Bindable Commands
======================

In addition to the context-dependent completions provided, which are
expected to work in an intuitively obvious way, there are a few widgets
implementing special behaviour which can be bound separately to keys.
The following is a list of these and their default bindings.

_bash_completions
     This function is used by two widgets, _bash_complete-word and
     _bash_list-choices.  It exists to provide compatibility with
     completion bindings in bash.  The last character of the binding
     determines what is completed: `!', command names; `$', environment
     variables; `@', host names; `/', file names; `~' user names.  In
     bash, the binding preceded by `\e' gives completion, and preceded
     by `^X' lists options.  As some of these bindings clash with
     standard zsh bindings, only `\e~' and `^X~' are bound by default.
     To add the rest, the following should be added to .zshrc after
     compinit has been run:

          for key in '!' '$' '@' '/' '~'; do
            bindkey "\e$key" _bash_complete-word
            bindkey "^X$key" _bash_list-choices
          done

     This includes the bindings for `~' in case they were already bound
     to something else; the completion code does not override user
     bindings.

_correct_filename (^XC)
     Correct the filename path at the cursor position.  Allows up to
     six errors in the name.  Can also be called with an argument to
     correct a filename path, independently of zle; the correction is
     printed on standard output.

_correct_word (^Xc)
     Performs correction of the current argument using the usual
     contextual completions as possible choices. This stores the string
     `correct-word' in the FUNCTION field of the context name and then
     calls the _correct completer.

_expand_alias (^Xa)
     This function can be used as a completer and as a bindable command.
     It expands the word the cursor is on if it is an alias.  The types
     of alias expanded can be controlled with the styles regular, global
     and disabled.

     When used as a bindable command there is one additional feature
     that can be selected by setting the complete style to `true'.  In
     this case, if the word is not the name of an alias, _expand_alias
     tries to complete the word to a full alias name without expanding
     it.  It leaves the cursor directly after the completed word so
     that invoking _expand_alias once more will expand the now-complete
     alias name.

_expand_word (^Xe)
     Performs expansion on the current word:  equivalent to the standard
     expand-word command, but using the _expand completer.  Before
     calling it, the FUNCTION field of the context is set to
     `expand-word'.

_generic
     This function is not defined as a widget and not bound by default.
     However, it can be used to define a widget and will then store
     the name of the widget in the FUNCTION field of the context and
     call the completion system.  This allows custom completion widgets
     with their own set of style settings to be defined easily.  For
     example, to define a widget that performs normal completion and
     starts menu selection:

          zle -C foo complete-word _generic
          bindkey '...' foo
          zstyle ':completion:foo:*' menu yes select=1

_history_complete_word (\e/)
     Complete words from the shell's command history. This uses the
     list, remove-all-dups, sort, and stop styles.

_most_recent_file (^Xm)
     Complete the name of the most recently modified file matching the
     pattern on the command line (which may be blank).  If given a
     numeric argument N, complete the Nth most recently modified file.
     Note the completion, if any, is always unique.

_next_tags (^Xn)
     This command alters the set of matches used to that for the next
     tag, or set of tags, either as given by the tag-order style or as
     set by default; these matches would otherwise not be available.
     Successive invocations of the command cycle through all possible
     sets of tags.

_read_comp (^X^R)
     Prompt the user for a string, and use that to perform completion
     on the current word.  There are two possibilities for the string.
     First, it can be a set of words beginning `_', for example `_files
     -/', in which case the function with any arguments will be called
     to generate the completions.  Unambiguous parts of the function
     name will be completed automatically (normal completion is not
     available at this point) until a space is typed.

     Second, any other string will be passed as a set of arguments to
     compadd and should hence be an expression specifying what should
     be completed.

     A very restricted set of editing commands is available when
     reading the string:  `DEL' and `^H' delete the last character;
     `^U' deletes the line, and `^C' and `^G' abort the function, while
     `RET' accepts the completion.  Note the string is used verbatim as
     a command line, so arguments must be quoted in accordance with
     standard shell rules.

     Once a string has been read, the next call to _read_comp will use
     the existing string instead of reading a new one.  To force a new
     string to be read, call _read_comp with a numeric argument.

_complete_debug (^X?)
     This widget performs ordinary completion, but captures in a
     temporary file a trace of the shell commands executed by the
     completion system.  Each completion attempt gets its own file.  A
     command to view each of these files is pushed onto the editor
     buffer stack.

_complete_help (^Xh)
     This widget displays information about the context names, the
     tags, and the completion functions used when completing at the
     current cursor position. If given a numeric argument other than 1
     (as in `ESC-2 ^Xh'), then the styles used and the contexts for
     which they are used will be shown, too.

     Note that the information about styles may be incomplete; it
     depends on the information available from the completion functions
     called, which in turn is determined by the user's own styles and
     other settings.

_complete_tag (^Xt)
     This widget completes symbol tags created by the etags or ctags
     programmes (note there is no connection with the completion
     system's tags) stored in a file TAGS, in the format used by etags,
     or tags, in the format created by ctags.  It will look back up the
     path hierarchy for the first occurrence of either file; if both
     exist, the file TAGS is preferred.  You can specify the full path
     to a TAGS or tags file by setting the parameter $TAGSFILE or
     $tagsfile respectively.  The corresponding completion tags used
     are etags and vtags, after emacs and vi respectively.

19.6 Utility Functions
======================

Descriptions follow for utility functions that may be useful when
writing completion functions.  If functions are installed in
subdirectories, most of these reside in the Base subdirectory.  Like
the example functions for commands in the distribution, the utility
functions generating matches all follow the convention of returning
zero if they generated completions and non-zero if no matching
completions could be added.

Two more features are offered by the _main_complete function.  The
arrays compprefuncs and comppostfuncs may contain names of functions
that are to be called immediately before or after completion has been
tried.  A function will only be called once unless it explicitly
reinserts itself into the array.

_all_labels [ -x ] [ -12VJ ] TAG NAME DESCR [ COMMAND ARGS ... ]
     This is a convenient interface to the _next_label function below,
     implementing the loop shown in the _next_label example.  The
     COMMAND and its arguments are called to generate the matches.  The
     options stored in the parameter NAME will automatically be inserted
     into the ARGS passed to the COMMAND.  Normally, they are put
     directly after the COMMAND, but if one of the ARGS is a single
     hyphen, they are inserted directly before that.  If the hyphen is
     the last argument, it will be removed from the argument list
     before the COMMAND is called.  This allows _all_labels to be used
     in almost all cases where the matches can be generated by a single
     call to the compadd builtin command or by a call to one of the
     utility functions.

     For example:

          local expl
          ...
          if _requested foo; then
            ...
            _all_labels foo expl '...' compadd ... - $matches
          fi

     Will complete the strings from the matches parameter, using
     compadd with additional options which will take precedence over
     those generated by _all_labels.

_alternative [ -C NAME ] SPEC ...
     This function is useful in simple cases where multiple tags are
     available.  Essentially it implements a loop like the one
     described for the _tags function below.

     The tags to use and the action to perform if a tag is requested are
     described using the SPECs which are of the form:
     `TAG:DESCR:ACTION'.  The TAGs are offered using _tags and if the
     tag is requested, the ACTION is executed with the given
     description DESCR.  The ACTIONs are those accepted by the
     _arguments function (described below), excluding the `->STATE' and
     `=...' forms.

     For example, the ACTION may be a simple function call:

          _alternative \
              'users:user:_users' \
              'hosts:host:_hosts'

     offers usernames and hostnames as possible matches, generated by
     the _users and _hosts functions respectively.

     Like _arguments, this functions uses _all_labels to execute the
     actions, which will loop over all sets of tags.  Special handling
     is only required if there is an additional valid tag, for example
     inside a function called from _alternative.

     Like _tags this function supports the -C option to give a
     different name for the argument context field.

_arguments [ -swWACRS ] [ -O NAME ] [ -M MATCHSPEC ] [ : ] SPEC ...
     This function can be used to give a complete specification for
     completion for a command whose arguments follow standard UNIX
     option and argument conventions.  The following forms specify
     individual sets of options and arguments; to avoid ambiguity,
     these may be separated from the options to _arguments itself by a
     single colon.

    N:MESSAGE:ACTION
    N::MESSAGE:ACTION
          This describes the N'th normal argument.  The MESSAGE will be
          printed above the matches generated and the ACTION indicates
          what can be completed in this position (see below).  If there
          are two colons before the MESSAGE the argument is optional.
          If the MESSAGE contains only white space, nothing will be
          printed above the matches unless the action adds an
          explanation string itself.

    :MESSAGE:ACTION
    ::MESSAGE:ACTION
          Similar, but describes the _next_ argument, whatever number
          that happens to be.  If all arguments are specified in this
          form in the correct order the numbers are unnecessary.

    *:MESSAGE:ACTION
    *::MESSAGE:ACTION
    *:::MESSAGE:ACTION
          This describes how arguments (usually non-option arguments,
          those not beginning with - or +) are to be completed when
          neither of the first two forms was provided.  Any number of
          arguments can be completed in this fashion.

          With two colons before the MESSAGE, the words special array
          and the CURRENT special parameter are modified to refer only
          to the normal arguments when the ACTION is executed or
          evaluated.  With three colons before the MESSAGE they are
          modified to refer only to the normal arguments covered by
          this description.

    OPTSPEC
    OPTSPEC:...
          This describes an option.  The colon indicates handling for
          one or more arguments to the option; if it is not present,
          the option is assumed to take no arguments.

          By default, options are multi-character name, one `-WORD' per
          option.  With -s, options may be single characters, with more
          than one option per word, although words starting with two
          hyphens, such as `--prefix', are still considered complete
          option names.  This is suitable for standard GNU options.

          The combination of -s with -w allows single-letter options to
          be combined in a single word even if one or more of the
          options take arguments.  For example, if -a takes an
          argument, with no -s `-ab' is considered as a single
          (unhandled) option; with -s -ab is an option with the
          argument `b'; with both -s and -w, -ab may be the option -a
          and the option(-b) with arguments still to come.

          The option -W takes this a stage further:  it is possible to
          complete single-letter options even after an argument that
          occurs in the same word.  However, it depends on the action
          performed whether options will really be completed at this
          point.  For more control, use a utility function like _guard
          as part of the action.

          The following forms are available for the initial OPTSPEC,
          whether or not the option has arguments.

         *OPTSPEC
               Here OPTSPEC is one of the remaining forms below.  This
               indicates the following OPTSPEC may be repeated.
               Otherwise if the corresponding option is already present
               on the command line to the left of the cursor it will
               not be offered again.

         -OPTNAME
         +OPTNAME
               In the simplest form the OPTSPEC is just the option name
               beginning with a minus or a plus sign, such as `-foo'.
               The first argument for the option (if any) must follow
               as a _separate_ word directly after the option.

               Either of `-+OPTNAME' and `+-OPTNAME' can be used to
               specify that -OPTNAME and +OPTNAME are both valid.

               In all the remaining forms, the leading `-' may be
               replaced by or paired with `+' in this way.

         -OPTNAME-
               The first argument of the option must come directly
               after the option name _in the same word_.  For example,
               `-foo-:...' specifies that the completed option and
               argument will look like `-fooARG'.

         -OPTNAME+
               The first argument may appear immediately after OPTNAME
               in the same word, or may appear as a separate word after
               the option.  For example, `-foo+:...' specifies that the
               completed option and argument will look like either
               `-fooARG' or `-foo ARG'.

         -OPTNAME=
               The argument may appear as the next word, or in same
               word as the option name provided that it is separated
               from it by an equals sign, for example `-foo=ARG' or
               `-foo ARG'.

         -OPTNAME=-
               The argument to the option must appear after an equals
               sign in the same word, and may not be given in the next
               argument.

         OPTSPEC[EXPLANATION]
               An explanation string may be appended to any of the
               preceding forms of OPTSPEC by enclosing it in brackets,
               as in `-q[query operation]'.

               The verbose style is used to decide whether the
               explanation strings are displayed with the option in a
               completion listing.

               If no bracketed explanation string is given but the
               auto-description style is set and only one argument is
               described for this OPTSPEC, the value of the style is
               displayed, with any appearance of the sequence `%d' in
               it replaced by the MESSAGE of the first OPTARG that
               follows the OPTSPEC; see below.

          It is possible for options with a literal `+' or `=' to
          appear, but that character must be quoted, for example `-\+'.

          Each OPTARG following an OPTSPEC must take one of the
          following forms:

         :MESSAGE:ACTION
         ::MESSAGE:ACTION
               An argument to the option; MESSAGE and ACTION are
               treated as for ordinary arguments.  In the first form,
               the argument is mandatory, and in the second form it is
               optional.

               This group may be repeated for options which take
               multiple arguments.  In other words,
               :MESSAGE1:ACTION1:MESSAGE2:ACTION2 specifies that the
               option takes two arguments.

         :*PATTERN:MESSAGE:ACTION
         :*PATTERN::MESSAGE:ACTION
         :*PATTERN:::MESSAGE:ACTION
               This describes multiple arguments.  Only the last OPTARG
               for an option taking multiple arguments may be given in
               this form.  If the PATTERN is empty (i.e., :*:), all the
               remaining words on the line are to be completed as
               described by the ACTION; otherwise, all the words up to
               a word matching the PATTERN are to be completed using
               the ACTION.

               Multiple colons are treated as for the `*:...' forms for
               ordinary arguments:  when the MESSAGE is preceded by two
               colons, the words special array and the CURRENT special
               parameter are modified during the execution or
               evaluation of the ACTION to refer only to the words
               after the option.  When preceded by three colons, they
               are modified to refer only to the words covered by this
               description.

     Any literal colon in an OPTNAME, MESSAGE, or ACTION must be
     preceded by a backslash, `\:'.

     Each of the forms above may be preceded by a list in parentheses
     of option names and argument numbers.  If the given option is on
     the command line, the options and arguments indicated in
     parentheses will not be offered.  For example, `(-two -three
     1)-one:...' completes the option `-one'; if this appears on the
     command line, the options -two and -three and the first ordinary
     argument will not be completed after it.  `(-foo):...' specifies
     an ordinary argument completion; -foo will not be completed if
     that argument is already present.

     Other items may appear in the list of excluded options to indicate
     various other items that should not be applied when the current
     specification is matched: a single star (*) for the rest arguments
     (i.e. a specification of the form `*:...'); a colon (:) for all
     normal (non-option-) arguments; and a hyphen (-) for all options.
     For example, if `(*)' appears before an option and the option
     appears on the command line, the list of remaining arguments
     (those shown in the above table beginning with `*:') will not be
     completed.

     To aid in reuse of specifications, it is possible to precede any
     of the forms above with `!'; then the form will no longer be
     completed, although if the option or argument appears on the
     command line they will be skipped as normal.  The main use for
     this is when the arguments are given by an array, and _arguments
     is called repeatedly for more specific contexts: on the first call
     `_arguments $global_options' is used, and on subsequent calls
     `_arguments !$^global_options'.

     In each of the forms above the ACTION determines how completions
     should be generated.  Except for the `->STRING' form below, the
     ACTION will be executed by calling the _all_labels function to
     process all tag labels.  No special handling of tags is needed
     unless a function call introduces a new one.

     The forms for ACTION are as follows.

      (single unquoted space)
          This is useful where an argument is required but it is not
          possible or desirable to generate matches for it.  The
          MESSAGE will be displayed but no completions listed.  Note
          that even in this case the colon at the end of the MESSAGE is
          needed; it may only be omitted when neither a MESSAGE nor an
          ACTION is given.

    (ITEM1 ITEM2 ...)
          One of a list of possible matches, for example:

               :foo:(foo bar baz)

    ((ITEM1\:DESC1 ...))
          Similar to the above, but with descriptions for each possible
          match.  Note the backslash before the colon.  For example,

               :foo:((a\:bar b\:baz))

          The matches will be listed together with their descriptions
          if the description style is set with the values tag in the
          context.

    ->STRING
          In this form, _arguments processes the arguments and options
          and then returns control to the calling function with
          parameters set to indicate the state of processing; the
          calling function then makes its own arrangements for
          generating completions.  For example, functions that
          implement a state machine can use this type of action.

          Where _arguments encounters a `->STRING', it will strip all
          leading and trailing whitespace from STRING and set the array
          state to the set of all STRINGSs for which an action is to be
          performed.

          By default and in common with all other well behaved
          completion functions, _arguments returns zero if it was able
          to add matches and non-zero otherwise. However, if the -R
          option is given, _arguments will instead return a status of
          300 to indicate that $state is to be handled.

          In addition to $state, _arguments also sets the global
          parameters `context', `line' and `opt_args' as described
          below, and does not reset any changes made to the special
          parameters such as PREFIX and words.  This gives the calling
          function the choice of resetting these parameters or
          propagating changes in them.

          A function calling _arguments with at least one action
          containing a `->STRING' therefore must declare appropriate
          local parameters:

               local context state line
               typeset -A opt_args

          to avoid _arguments from altering the global environment.

    {EVAL-STRING}
          A string in braces is evaluated as shell code to generate
          matches.  If the EVAL-STRING itself does not begin with an
          opening parenthesis or brace it is split into separate words
          before execution.

    = ACTION
          If the ACTION starts with `= ' (an equals sign followed by a
          space), _arguments will insert the contents of the ARGUMENT
          field of the current context as the new first element in the
          words special array and increment the value of the CURRENT
          special parameter.  This has the effect of inserting a dummy
          word onto the completion command line while not changing the
          point at which completion is taking place.

          This is most useful with one of the specifiers that restrict
          the words on the command line on which the ACTION is to
          operate (the two- and three-colon forms above).  One
          particular use is when an ACTION itself causes _arguments on
          a restricted range; it is necessary to use this trick to
          insert an appropriate command name into the range for the
          second call to _arguments to be able to parse the line.

    WORD...
    WORD...
          This covers all forms other than those above.  If the ACTION
          starts with a space, the remaining list of words will be
          invoked unchanged.

          Otherwise it will be invoked with some extra strings placed
          after the first word; these are to be passed down as options
          to the compadd builtin.  They ensure that the state specified
          by _arguments, in particular the descriptions of options and
          arguments, is correctly passed to the completion command.
          These additional arguments are taken from the array parameter
          `expl'; this will be set up before executing the ACTION and
          hence may be referred to inside it, typically in an expansion
          of the form `$expl[@]' which preserves empty elements of the
          array.

     During the performance of the action the array `line' will be set
     to the command name and normal arguments from the command line,
     i.e. the words from the command line excluding all options and
     their arguments.  Options are stored in the associative array
     `opt_args' with option names as keys and their arguments as the
     values.  For options that have more than one argument these are
     given as one string, separated by colons.  All colons in the
     original arguments are preceded with backslashes.

     The parameter `context' is set when returning to the calling
     function to perform an action of the form `->STRING'.  It is set
     to an array of elements corresponding to the elements of $state.
     Each element is a suitable name for the argument field of the
     context: either a string of the form `option-OPT-N' for the N'th
     argument of the option -OPT, or a string of the form `argument-N'
     for the N'th argument.  For `rest' arguments, that is those in the
     list at the end not handled by position, N is the string `rest'.
     For example, when completing the argument of the -o option, the
     name is `option-o-1', while for the second normal (non-option-)
     argument it is `argument-2'.

     Furthermore, during the evaluation of the ACTION the context name
     in the curcontext parameter is altered to append the same string
     that is stored in the context parameter.

     It is possible to specify multiple sets of options and arguments
     with the sets separated by single hyphens.  The specifications
     before the first hyphen (if any) are shared by all the remaining
     sets.  The first word in every other set provides a name for the
     set which may appear in exclusion lists in specifications, either
     alone or before one of the possible values described above.  In
     the second case a `-' should appear between this name and the
     remainder.

     For example:

          _arguments \
              -a \
            - set1 \
              -c \
            - set2 \
              -d \
              ':arg:(x2 y2)'

     This defines two sets.  When the command line contains the option
     `-c', the `-d' option and the argument will not be considered
     possible completions.  When it contains `-d' or an argument, the
     option `-c' will not be considered.  However, after `-a' both sets
     will still be considered valid.

     If the name given for one of the mutually exclusive sets is of the
     form `(NAME)' then only one value from each set will ever be
     completed; more formally, all specifications are mutually
     exclusive to all other specifications in the same set.  This is
     useful for defining multiple sets of options which are mutually
     exclusive and in which the options are aliases for each other.  For
     example:

          _arguments \
              -a -b \
            - '(compress)' \
              {-c,--compress}'[compress]' \
            - '(uncompress)' \
              {-d,--decompress}'[decompress]'

     As the completion code has to parse the command line separately
     for each set this form of argument is slow and should only be used
     when necessary.  A useful alternative is often an option
     specification with rest-arguments (as in `-foo:*:...'); here the
     option -foo swallows up all remaining arguments as described by
     the OPTARG definitions.

     The options -S and -A are available to simplify the specifications
     for commands with standard option parsing.  With -S, no option
     will be completed after a `--' appearing on its own on the line;
     this argument will otherwise be ignored; hence in the line

          foobar -a -- -b

     the `-a' is considered an option but the `-b' is considered an
     argument, while the `--' is considered to be neither.

     With -A, no options will be completed after the first non-option
     argument on the line.  The -A must be followed by a pattern
     matching all strings which are not to be taken as arguments.  For
     example, to make _arguments stop completing options after the
     first normal argument, but ignoring all strings starting with a
     hyphen even if they are not described by one of the OPTSPECs, the
     form is `-A "-*"'.

     The option `-O NAME' specifies the name of an array whose elements
     will be passed as arguments to functions called to execute ACTIONS.
     For example, this can be used to pass the same set of options for
     the compadd builtin to all ACTIONs.

     The option `-M SPEC' sets a match specification to use to
     completion option names and values.  It must appear before the
     first argument specification.  The default is `r:|[_-]=* r:|=*':
     this allows partial word completion after `_' and `-', for example
     `-f-b' can be completed to `-foo-bar'.

     The option -C tells _arguments to modify the curcontext parameter
     for an action of the form `->STATE'.  This is the standard
     parameter used to keep track of the current context.  Here it (and
     not the context array) should be made local to the calling function
     to avoid passing back the modified value and should be initialised
     to the current value at the start of the function:

          local curcontext="$curcontext"

     This is useful where it is not possible for multiple states to be
     valid together.

     The option `-' allows _arguments to work out the names of long
     options that support the `--help' option which is standard in many
     GNU commands.  The command word is called with the argument
     `--help' and the output examined for option names.  Clearly, it can
     be dangerous to pass this to commands which may not support this
     option as the behaviour of the command is unspecified.

     In addition to options, `_arguments --' will try to deduce the
     types of arguments available for options when the form `--OPT=VAL'
     is valid.  It is also possible to provide hints by examining the
     help text of the command and adding specifiers of the form
     `PATTERN:MESSAGE:ACTION'; note that normal _arguments specifiers
     are not used.  The PATTERN is matched against the help text for an
     option, and if it matches the MESSAGE and ACTION are used as for
     other argument specifiers.  For example:

          _arguments -- '*\*:toggle:(yes no)' \
                        '*=FILE*:file:_files' \
                        '*=DIR*:directory:_files -/' \
                        '*=PATH*:directory:_files -/'

     Here, `yes' and `no' will be completed as the argument of options
     whose description ends in a star; file names will be completed for
     options that contain the substring `=FILE' in the description; and
     directories will be completed for options whose description
     contains `=DIR' or `=PATH'.  The last three are in fact the
     default and so need not be given explicitly, although it is
     possible to override the use of these patterns.  A typical help
     text which uses this feature is:

            -C, --directory=DIR          change to directory DIR

     so that the above specifications will cause directories to be
     completed after `-directory', though not after `-C'.

     Note also that _arguments tries to find out automatically if the
     argument for an option is optional.  This can be specified
     explicitly by doubling the colon before the MESSAGE.

     If the PATTERN ends in `(-)', this will removed from the pattern
     and the ACTION will be used only directly after the `=', not in
     the next word.  This is the behaviour of a normal specification
     defined with the form `=-'.

     The `_arguments --' can be followed by the option `-i PATTERNS' to
     give patterns for options which are not to be completed.  The
     patterns can be given as the name of an array parameter or as a
     literal list in parentheses.  For example,

          _arguments -- -i \
              "(--(en|dis)able-FEATURE*)"

     will cause completion to ignore the options `--enable-FEATURE' and
     `--disable-FEATURE' (this example is useful with GNU configure).

     The `_arguments --' form can also be followed by the option `-s
     PAIR' to describe option aliases.  Each PAIR consists of a pattern
     and a replacement.  For example, some configure-scripts describe
     options only as `--enable-foo', but also accept `--disable-foo'.
     To allow completion of the second form:

          _arguments -- -s "(#--enable- --disable-)"

     Here is a more general example of the use of _arguments:

          _arguments '-l+:left border:' \
                     '-format:paper size:(letter A4)' \
                     '*-copy:output file:_files::resolution:(300 600)' \
                     ':postscript file:_files -g \*.\(ps\|eps\)' \
                     '*:page number:'

     This describes three options: `-l', `-format', and `-copy'.  The
     first takes one argument described as `LEFT BORDER' for which no
     completion will be offered because of the empty action.  Its
     argument may come directly after the `-l' or it may be given as
     the next word on the line.

     The `-format' option takes one argument in the next word,
     described as `PAPER SIZE' for which only the strings `letter' and
     `A4' will be completed.

     The `-copy' option may appear more than once on the command line
     and takes two arguments.  The first is mandatory and will be
     completed as a filename.  The second is optional (because of the
     second colon before the description `RESOLUTION') and will be
     completed from the strings `300' and `600'.

     The last two descriptions say what should be completed as
     arguments.  The first describes the first argument as a
     `POSTSCRIPT FILE' and makes files ending in `ps' or `eps' be
     completed.  The last description gives all other arguments the
     description `PAGE NUMBERS' but does not offer completions.

_cache_invalid CACHE_IDENTIFIER
     This function returns status zero if the completions cache
     corresponding to the given cache identifier needs rebuilding.  It
     determines this by looking up the cache-policy style for the
     current context.  This should provide a function name which is run
     with the full path to the relevant cache file as the only argument.

     Example:

          _example_caching_policy () {
              # rebuild if cache is more than a week old
              oldp=( "$1"(Nmw+1) )
              (( $#oldp ))
          }

_call_function RETURN NAME [ ARGS ... ]
     If a function NAME exists, it is called with the arguments ARGS.
     The RETURN argument gives the name of a parameter in which the
     return status from the function NAME; if RETURN is empty or a
     single hyphen it is ignored.

     The return value of _call_function itself is zero if the function
     NAME exists and was called and non-zero otherwise.

_call_program TAG STRING ...
     This function provides a mechanism for the user to override the
     use of an external command.  It looks up the command style with
     the supplied TAG.  If the style is set, its value is used as the
     command to execute.  The STRINGs from the call to _call_program,
     or from the style if set, are concatenated with spaces between
     them and the resulting string is evaluated.  The return value is
     the return value of the command called.

_combination [ -s PATTERN ] TAG STYLE SPEC ... FIELD OPTS ...
     This function is used to complete combinations of values,  for
     example pairs of hostnames and usernames.  The STYLE argument
     gives the style which defines the pairs; it is looked up in a
     context with the TAG specified.

     The style name consists of field names separated by hyphens, for
     example `users-hosts-ports'.  For each field for a value is
     already known, a SPEC of the form `FIELD=PATTERN' is given.  For
     example, if the command line so far specifies a user `pws', the
     argument `users=pws' should appear.

     The next argument with no equals sign is taken as the name of the
     field for which completions should be generated (presumably not
     one of the FIELDs for which the value is known).

     The matches generated will be taken from the value of the style.
     These should contain the possible values for the combinations in
     the appropriate order (users, hosts, ports in the example above).
     The different fields the values for the different fields are
     separated by colons.  This can be altered with the option -s to
     _combination which specifies a pattern.  Typically this is a
     character class, as for example `-s "[:@]"' in the case of the
     users-hosts style.    Each `FIELD=PATTERN' specification restricts
     the completions which apply to elements of the style with
     appropriately matching fields.

     If no style with the given name is defined for the given tag, or
     if none of the strings in style's value match, but a function name
     of the required field preceded by an underscore is defined, that
     function will be called to generate the matches.  For example, if
     there is no `users-hosts-ports' or no matching hostname when a
     host is required, the function `_hosts' will automatically be
     called.

     If the same name is used for more than one field, in both the
     `FIELD=PATTERN' and the argument that gives the name of the field
     to be completed, the number of the field (starting with one) may
     be given after the fieldname, separated from it by a colon.

     All arguments after the required field name are passed to compadd
     when generating matches from the style value, or to the functions
     for the fields if they are called.

_describe [ -oO | -t TAG ] DESCR NAME1 [ NAME2 ] OPTS ... -- ...
     This function associates completions with descriptions.  Multiple
     groups separated by -- can be supplied, potentially with different
     completion options OPTS.

     The DESCR is taken as a string to display above the matches if the
     format style for the descriptions tag is set.  This is followed by
     one or two names of arrays followed by options to pass to compadd.
     The first array contains the possible completions with their
     descriptions in the form `COMPLETION:DESCRIPTION'.  If a second
     array is given, it should have the same number of elements as the
     first; in this case the corresponding elements are added as
     possible completions instead of the COMPLETION strings from the
     first array.  The completion list will retain the descriptions
     from the first array.  Finally, a set of completion options can
     appear.

     If the option `-o' appears before the first argument, the matches
     added will be treated as names of command options (N.B. not shell
     options), typically following a `-', `--' or `+' on the command
     line.  In this case _describe uses the prefix-hidden,
     prefix-needed and verbose styles to find out if the strings should
     be added as completions and if the descriptions should be shown.
     Without the `-o' option, only the verbose style is used to decide
     how descriptions are shown.  If `-O' is used instead of `-O',
     command options are completed as above but _describe will not
     handle the prefix-needed style.

     With the -t option a TAG can be specified.  The default is
     `values' or, if the -o option is given, `options'.

     If selected by the list-grouped style, strings with the same
     description will appear together in the list.

     _describe uses the _all_labels function to generate the matches, so
     it does not need to appear inside a loop over tag labels.

_description [ -x ] [ -12VJ ] TAG NAME DESCR [ SPEC ... ]
     This function is not to be confused with the previous one; it is
     used as a helper function for creating options to compadd.  It is
     buried inside many of the higher level completion functions and so
     often does not need to be called directly.

     The styles listed below are tested in the current context using the
     given TAG.  The resulting options for compadd are put into the
     array named NAME (this is traditionally `expl', but this
     convention is not enforced).  The description for the
     corresponding set of matches is passed to the function in DESCR.

     The styles tested are: format, hidden, matcher, ignored-patterns
     and group-name.  The format style is first tested for the given
     TAG and then for the descriptions tag if no value was found, while
     the remainder are only tested for the tag given as the first
     argument.  The function also calls _setup which tests some more
     styles.

     The string returned by the format style (if any) will be modified
     so that the sequence `%d' is replaced by the DESCR given as the
     third argument without any leading or trailing white space.  If,
     after removing the white space, the DESCR is the empty string, the
     format style will not be used and the options put into the NAME
     array will not contain an explanation string to be displayed above
     the matches.

     If _description is called with more than three arguments, the
     additional SPECs should be of the form `CHAR:STR'.  These supply
     escape sequence replacements for the format style: every
     appearance of `%CHAR' will be replaced by STRING.

     If the -x option is given, the description will be passed to
     compadd using the -x option instead of the default -X.  This means
     that the description will be displayed even if there are no
     corresponding matches.

     The options placed in the array NAME take account of the
     group-name style, so matches are placed in a separate group where
     necessary.  The group normally has its elements sorted (by passing
     the option -J to compadd), but if an option starting with `-V',
     `-J', `-1', or `-2' is passed to _description, that option will be
     included in the array.  Hence it is possible for the completion
     group to be unsorted by giving the option `-V', `-1V', or `-2V'.

     In most cases, the function will be used like this:

          local expl
          _description files expl file
          compadd "$expl[@]" - "$files[@]"

     Note the use of the parameter expl, the hyphen, and the list of
     matches.  Almost all calls to compadd within the completion system
     use a similar format; this ensures that user-specified styles are
     correctly passed down to the builtins which implement the
     internals of completion.

_dispatch CONTEXT STRING ...
     This sets the current context to CONTEXT and looks for completion
     functions to handle this context by hunting through the list of
     command names or special contexts (as described above for compdef)
     given as STRING ....  The first completion function to be defined
     for one of the contexts in the list is used to generate matches.
     Typically, the last STRING is -default- to cause the function for
     default completion to be used as a fallback.

     The function sets the parameter $service to the STRING being
     tried, and sets the CONTEXT/COMMAND field (the fourth) of the
     $curcontext parameter to the CONTEXT given as the first argument.

_files
     The function _files calls _path_files with all the arguments it
     was passed except for -g and -/.  The use of these two options
     depends on the setting of the  file-patterns style.

     This function accepts the full set of options allowed by
     _path_files, described below.

_gnu_generic
     This function is a simple wrapper around the _arguments function
     described above.  It can be used to determine automatically the
     long options understood by commands that produce a list when
     passed the option `--help'.  It is intended to be used as a
     top-level completion function in its own right.  For example, to
     enable option completion for the commands foo and bar, use

          compdef _gnu_generic foo bar

     after the call to compinit.

     The completion system as supplied is conservative in its use of
     this function, since it is important to be sure the command
     understands the option `-'-help'.

_guard [ OPTIONS ] PATTERN DESCR
     This function is intended to be used in the ACTION for the
     specifications passed to _arguments and similar functions.  It
     returns immediately with a non-zero return value if the string to
     be completed does not match the PATTERN.  If the pattern matches,
     the DESCR is displayed; the function then returns zero if the word
     to complete is not empty, non-zero otherwise.

     The PATTERN may be preceded by any of the options understood by
     compadd that are passed down from _description, namely -M, -J, -V,
     -1, -2, -n, -F and -X.  All of these options will be ignored.
     This fits in conveniently with the argument-passing conventions of
     actions for _arguments.

     As an example, consider a command taking the options -n and -none,
     where -n must be followed by a numeric value in the same word.  By
     using:

          _arguments '-n-: :_guard "[0-9]#" "numeric value"' '-none'

     _arguments can be made to both display the message `numeric value'
     and complete options after `-n<TAB>'.  If the `-n' is already
     followed by one or more digits (the pattern passed to _guard) only
     the message will be displayed; if the `-n' is followed by another
     character, only options are completed.

_message [ -r12 ] [ -VJ GROUP ] DESCR
_message -e [ TAG ] DESCR
     The DESCR is used in the same way as the third argument to the
     _description function, except that the resulting string will
     always be shown whether or not matches were generated.  This is
     useful for displaying a help message in places where no
     completions can be generated.

     The format style is examined with the messages tag to find a
     message; the usual tag, descriptions, is used only if the style is
     not set with the former.

     If the -r option is given, no style is used; the DESCR is taken
     literally as the string to display.  This is most useful when the
     DESCR comes from a pre-processed argument list which already
     contains an expanded description.

     The -12VJ options and the GROUP are passed to compadd and hence
     determine the group the message string is added to.

     The second form gives a description for completions with the tag
     TAG to be shown even if there are no matches for that tag.  The tag
     can be omitted and if so the tag is taken from the parameter
     $curtag; this is maintained by the completion system and so is
     usually correct.

_multi_parts SEP ARRAY
     The argument SEP is a separator character.  The ARRAY may be
     either the name of an array parameter or a literal array in the
     form `(foo bar)', a parenthesised list of words separated by
     whitespace.  The possible completions are the strings from the
     array.  However, each chunk delimited by SEP will be completed
     separately.  For example, the _tar function uses `_multi_parts /
     PATHARRAY' to complete partial file paths from the given array of
     complete file paths.

     The -i option causes _multi_parts to insert a unique match even if
     that requires multiple separators to be inserted.  This is not
     usually the expected behaviour with filenames, but certain other
     types of completion, for example those with a fixed set of
     possibilities, may be more suited to this form.

     Like other utility functions, this function accepts the `-V',
     `-J', `-1', `-2', `-n', `-f', `-X', `-M', `-P', `-S', `-r', `-R',
     and `-q' options and passes them to the compadd builtin.

_next_label [ -x ] [ -12VJ ] TAG NAME DESCR [ OPTIONS ... ]
     This function is used to implement the loop over different tag
     labels for a particular tag as described above for the tag-order
     style.  On each call it checks to see if there are any more tag
     labels; if there is it returns status zero, otherwise non-zero.
     As this function requires a current tag to be set, it must always
     follow a call to _tags or _requested.

     The -x12VJ options and the first three arguments are passed to the
     _description function.  Where appropriate the TAG will be replaced
     by a tag label in this call.  Any description given in the
     tag-order style is preferred to the DESCR passed to _next_label.

     The OPTIONS given after the DESCR are set in the parameter given
     by NAME, and hence are to be passed to compadd or whatever
     function is called to add the matches.

     Here is a typical use of this function for the tag foo.  The call
     to _requested determines if tag foo is required at all; the loop
     over _next_label handles any labels defined for the tag in the
     tag-order style.

          local expl ret=1
          ...
          if _requested foo; then
            ...
            while _next_label foo expl '...'; do
              compadd "$expl[@]" ... && ret=0
            done
            ...
          fi
          return ret

_normal
     This is the standard function called to handle completion outside
     any special -CONTEXT-.  It is called both to complete the command
     word and also the arguments for a command.  In the second case,
     _normal looks for a special completion for that command, and if
     there is none it uses the completion for the -default- context.

     A second use is to reexamine the command line specified by the
     $words array and the $CURRENT parameter after those have been
     modified.  For example, the function _precommand, which completes
     after pre-command specifiers such as nohup, removes the first word
     from the words array, decrements the CURRENT parameter, then calls
     _normal again.  The effect is that `nohup CMD ...'  is treated in
     the same way as `CMD ...'.

     If the command name matches one of the patterns given by one of the
     options -p or -P to compdef, the corresponding completion function
     is called and then the parameter _compskip is checked.  If it is
     set completion is terminated at that point even if no matches have
     been found.  This is the same effect as in the -first- context.

_options
     This can be used to complete the names of shell options.  It
     provides a matcher specification that ignores a leading `no',
     ignores underscores and allows upper-case letters to match their
     lower-case counterparts (for example, `glob', `noglob', `NO_GLOB'
     are all completed).  Any arguments are propagated to the compadd
     builtin.

_options_set and _options_unset
     These functions complete only set or unset options, with the same
     matching specification used in the _options function.

     Note that you need to uncomment a few lines in the _main_complete
     function for these functions to work properly.  The lines in
     question are used to store the option settings in effect before
     the completion widget locally sets the options it needs.  Hence
     these functions are not generally used by the completion system.

_parameters
     This is used to complete the names of shell parameters.

     The option `-g PATTERN' limits the completion to parameters whose
     type matches the PATTERN.  The type of a parameter is that shown
     by `print ${(t)PARAM}', hence judicious use of `*' in PATTERN is
     probably necessary.

     All other arguments are passed to the compadd builtin.

_path_files
     This function is used throughout the completion system to complete
     filenames.  It allows completion of partial paths.  For example,
     the string `/u/i/s/sig' may be completed to
     `/usr/include/sys/signal.h'.

     The options accepted by both _path_files and _files are:

    -f
          Complete all filenames.  This is the default.

    -/
          Specifies that only directories should be completed.

    -g PATTERN
          Specifies that only files matching the PATTERN should be
          completed.

    -W PATHS
          Specifies path prefixes that are to be prepended to the
          string from the command line to generate the filenames but
          that should not be inserted as completions nor shown in
          completion listings.  Here, PATHS may be the name of an array
          parameter, a literal list of paths enclosed in parentheses or
          an absolute pathname.

    -F IGNORED-FILES
          This behaves as for the corresponding option to the compadd
          builtin.  It gives direct control over which filenames should
          be ignored.  If the option is not present, the
          ignored-patterns style is used.

     Both _path_files and _files also accept the following options
     which are passed to compadd: `-J', `-V', `-1', `-2', `-n', `-X',
     `-M', `-P', `-S', `-q', `-r', and `-R'.

     Finally, the _path_files function  uses the styles expand,
     ambiguous, special-dirs, list-suffixes and file-sort described
     above.

_pick_variant [ -c COMMAND ] [ -r NAME ] LABEL=PATTERN ... LABEL [ ARGS ... ]
     This function is used to resolve situations where a single command
     name requires more than one type of handling, either because it
     has more than one variant or because there is a name clash between
     two different commands.

     The command to run is taken from the first element of the array
     words unless this is overridden by the option -c.  This command is
     run and its output is compared with a series of patterns.
     Arguments to be passed to the command can be specified at the end
     after all the other arguments.  The patterns to try in order are
     given by the arguments LABEL=PATTERN; if the output of `COMMAND
     ARGS ...' contains PATTERN, then label is selected as the label
     for the command variant.  If none of the patterns match, the final
     command label is selected and status 1 is returned.

     If the `-r NAME' is given, the LABEL picked is stored in the
     parameter named NAME.

     The results are also cached in the _CMD_VARIANT associative array
     indexed by the name of the command run.

_regex_arguments NAME SPEC ...
     This function generates a completion function NAME which matches
     the specifications SPEC ..., a set of regular expressions as
     described below.  After running _regex_arguments, the function
     NAME should be called at the appropriate point.  The pattern to be
     matched is given by the contents of the words array up to the
     current cursor position joined together with null characters; no
     quotation is applied.

     The arguments are grouped as sets of alternatives separated by `|',
     which are tried one after the other until one matches.  Each
     alternative consists of a one or more specifications which are
     tried left to right, with each pattern matched being stripped in
     turn from the command line being tested, until all of the group
     succeeds or until one fails; in the latter case, the next
     alternative is tried.  This structure can be repeated to arbitrary
     depth by using parentheses; matching proceeds from inside to
     outside.

     A special procedure is applied if no test succeeds but the
     remaining command line string contains no null character (implying
     the remaining word is the one for which completions are to be
     generated).  The completion target is restricted to the remaining
     word and any ACTIONs for the corresponding patterns are executed.
     In this case, nothing is stripped from the command line string.
     The order of evaluation of the ACTIONs can be determined by the
     tag-order style; the various formats supported by _alternative can
     be used in ACTION.  The DESCR is used for setting up the array
     parameter expl.

     Specification arguments take one of following forms, in which
     metacharacters such as `(', `)', `#' and `|' should be quoted.

    /PATTERN/ [%LOOKAHEAD%] [-GUARD] [:TAG:DESCR:ACTION]
          This is a single primitive component.  The function tests
          whether the combined pattern `(#b)((#B)PATTERN)LOOKAHEAD*'
          matches the command line string.  If so, `GUARD' is evaluated
          and its return status is examined to determine if the test
          has succeeded.  The PATTERN string `[]' is guaranteed never
          to match.  The LOOKAHEAD is not stripped from the command
          line before the next pattern is examined.

    /PATTERN/+ [%LOOKAHEAD%] [-GUARD] [:TAG:DESCR:ACTION]
          This is similar to `/PATTERN/ ...' but the left part of the
          command line string (i.e. the part already matched by
          previous patterns) is also considered part of the completion
          target.

    /PATTERN/- [%LOOKAHEAD%] [-GUARD] [:TAG:DESCR:ACTION]
          This is similar to `/PATTERN/ ...' but the ACTIONs of the
          current and previously matched patterns are ignored even if
          the following `PATTERN' matches the empty string.

    ( SPEC )
          Parentheses may be used to groups SPECs; note each parenthesis
          is a single argument to _regex_arguments.

    SPEC #
          This allows any number of repetitions of SPEC.

    SPEC SPEC
          The two SPECs are to be matched one after the other as
          described above.

    SPEC | SPEC
          Either of the two SPECs can be matched.

_requested [ -x ] [ -12VJ ] TAG [ NAME DESCR [ COMMAND ARGS ... ] ]
     This function is called to decide whether a tag already registered
     by a call to _tags (see below) has been requested by the user and
     hence completion should be performed for it.  It returns status
     zero if the tag is requested and non-zero otherwise.  The function
     is typically used as part of a loop over different tags as follows:

          _tags foo bar baz
          while _tags; do
            if _requested foo; then
              ... # perform completion for foo
            fi
            ... # test the tags bar and baz in the same way
            ... # exit loop if matches were generated
          done

     Note that the test for whether matches were generated is not
     performed until the end of the _tags loop.  This is so that the
     user can set the tag-order style to specify a set of tags to be
     completed at the same time.

     If NAME and DESCR are given, _requested calls the _description
     function with these arguments together with the options passed to
     _requested.

     If COMMAND is given, the _all_labels function will be called
     immediately with the same arguments.  In simple cases this makes it
     possible to perform the test for the tag and the matching in one
     go.  For example:

          local expl ret=1
          _tags foo bar baz
          while _tags; do
            _requested foo expl 'description' \
                compadd foobar foobaz && ret=0
            ...
            (( ret )) || break
          done

     If the COMMAND is not compadd, it must nevertheless be prepared to
     handle the same options.

_retrieve_cache CACHE_IDENTIFIER
     This function retrieves completion information from the file given
     by CACHE_IDENTIFIER, stored in a directory specified by the
     cache-path style which defaults to ~/.zcompcache.  The return value
     is zero if retrieval was successful.  It will only attempt
     retrieval if the use-cache style is set, so you can call this
     function without worrying about whether the user wanted to use the
     caching layer.

     See _store_cache below for more details.

_sep_parts
     This function is passed alternating arrays and separators as
     arguments.  The arrays specify completions for parts of strings to
     be separated by the separators.  The arrays may be the names of
     array parameters or a quoted list of words in parentheses.  For
     example, with the array `hosts=(ftp news)' the call `_sep_parts
     '(foo bar)' @ hosts' will complete the string  `f' to `foo' and
     the string `b@n' to `bar@news'.

     This function accepts the compadd options `-V', `-J', `-1', `-2',
     `-n', `-X', `-M', `-P', `-S', `-r', `-R', and `-q' and passes them
     on to the compadd builtin used to add the matches.

_setup TAG [ GROUP ]
     This function sets up the special parameters used by the
     completion system appropriately for the TAG given as the first
     argument.  It uses the styles list-colors, list-packed,
     list-rows-first, last-prompt, accept-exact, menu and force-list.

     The optional GROUP supplies the name of the group in which the
     matches will be placed.  If it is not given, the TAG is used as
     the group name.

     This function is called automatically from _description and hence
     is not normally called explicitly.

_store_cache CACHE_IDENTIFIER PARAMS ...
     This function, together with _retrieve_cache and _cache_invalid,
     implements a caching layer which can be used in any completion
     function.  Data obtained by costly operations are stored in
     parameters; this function then dumps the values of those
     parameters to a file.  The data can then be retrieved quickly from
     that file via _retrieve_cache, even in different instances of the
     shell.

     The CACHE_IDENTIFIER specifies the file which the data should be
     dumped to.  The file is stored in a directory specified by the
     cache-path style which defaults to ~/.zcompcache.  The remaining
     PARAMS arguments are the parameters to dump to the file.

     The return value is zero if storage was successful.  The function
     will only attempt storage if the use-cache style is set, so you can
     call this function without worrying about whether the user wanted
     to use the caching layer.

     The completion function may avoid calling _retrieve_cache when it
     already has the completion data available as parameters.  However,
     in that case it should call _cache_invalid to check whether the
     data in the parameters and in the cache are still valid.

     See the _perl_modules completion function for a simple example of
     the usage of the caching layer.

_tags [ [ -C NAME ] TAGS ... ]
     If called with arguments, these are taken to be the names of tags
     valid for completions in the current context.  These tags are
     stored internally and sorted by using the tag-order style.

     Next, _tags is called repeatedly without arguments from the same
     completion function.  This successively selects the first, second,
     etc. set of tags requested by the user.  The return value is zero
     if at least one of the tags is requested and non-zero otherwise.
     To test if a particular tag is to be tried, the _requested
     function should be called (see above).

     If `-C NAME' is given, NAME is temporarily stored in the argument
     field (the fifth) of the context in the curcontext parameter
     during the call to _tags; the field is restored on exit.  This
     allows _tags to use a more specific context without having to
     change and reset the curcontext parameter (which has the same
     effect).

_values [ -O NAME ] [ -s SEP ] [ -S SEP ] [ -wC ] DESC SPEC ...
     This is used to complete arbitrary keywords (values) and their
     arguments, or lists of such combinations.

     If the first argument is the option `-O NAME', it will be used in
     the same way as by the _arguments function.  In other words, the
     elements of the NAME array will be passed to compadd when
     executing an action.

     If the first argument (or the first argument after `-O NAME') is
     `-s', the next argument is used as the character that separates
     multiple values.  This character is automatically added after each
     value in an auto-removable fashion (see below); all values
     completed by `_values -s' appear in the same word on the command
     line, unlike completion using _arguments.  If this option is not
     present, only a single value will be completed per word.

     Normally, _values will only use the current word to determine
     which values are already present on the command line and hence are
     not to be completed again.  If the -w option is given, other
     arguments are examined as well.

     The first non-option argument is used as a string to print as a
     description before listing the values.

     All other arguments describe the possible values and their
     arguments in the same format used for the description of options by
     the _arguments function (see above).  The only differences are that
     no minus or plus sign is required at the beginning, values can
     have only one argument, and the forms of action beginning with an
     equal sign are not supported.

     The character separating a value from its argument can be set
     using the option -S (like -s, followed by the character to use as
     the separator in the next argument).  By default the equals sign
     will be used as the separator between values and arguments.

     Example:

          _values -s , 'description' \
                  '*foo[bar]' \
                  '(two)*one[number]:first count:' \
                  'two[another number]::second count:(1 2 3)'

     This describes three possible values: `foo', `one', and `two'.
     The first is described as `bar', takes no argument and may appear
     more than once.  The second is described as `number', may appear
     more than once, and takes one mandatory argument described as
     `first count'; no action is specified, so it will not be
     completed.  The `(two)' at the beginning says that if the value
     `one' is on the line, the value `two' will no longer be considered
     a possible completion.  Finally, the last value (`two') is
     described as `another number' and takes an optional argument
     described as `second count' for which the completions (to appear
     after an `=') are `1', `2', and `3'.  The _values function will
     complete lists of these values separated by commas.

     Like _arguments, this function temporarily adds another context
     name component to the arguments element (the fifth) of the current
     context while executing the ACTION.  Here this name is just the
     name of the value for which the argument is completed.

     The style verbose is used to decide if the descriptions for the
     values (but not those for the arguments) should be printed.

     The associative array val_args is used to report values and their
     arguments; this works similarly to the opt_args associative array
     used by _arguments.  Hence the function calling _values should
     declare the local parameters state, line, context and val_args:

          local context state line
          typeset -A val_args

     when using an action of the form `->STRING'.  With this function
     the context parameter will be set to the name of the value whose
     argument is to be completed.

     Note also that _values normally adds the character used as the
     separator between values as an auto-removable suffix (similar to a
     `/' after a directory).  However, this is not possible for a
     `->STRING' action as the matches for the argument are generated by
     the calling function.  To get the usual behaviour, the the calling
     function can add the separator X as a suffix by passing the
     options `-qS X' either directly or indirectly to compadd.

     The option -C is treated in the same way as it is by _arguments.
     In that case the parameter curcontext should be made local instead
     of context (as described above).

_wanted [ -x ] [ -C NAME ]  [ -12VJ ] TAG NAME DESCR COMMAND ARGS ...
     In many contexts, completion can only generate one particular set
     of matches, usually corresponding to a single tag.  However, it is
     still necessary to decide whether the user requires matches of
     this type.  This function is useful in such a case.

     The arguments to _wanted are the same as those to _requested, i.e.
     arguments to be passed to _description.  However, in this case the
     COMMAND is not optional;  all the processing of tags, including
     the loop over both tags and tag labels and the generation of
     matches, is carried out automatically by _wanted.

     Hence to offer only one tag and immediately add the corresponding
     matches with the given description:

          _wanted tag expl 'description' \
              compadd matches...

     Note that, as for _requested, the COMMAND must be able to accept
     options to be passed down to compadd.

     Like _tags this function supports the -C option to give a
     different name for the argument context field.  The -x option has
     the same meaning as for _description.

19.7 Completion Directories
===========================

In the source distribution, the files are contained in various
subdirectories of the Completion directory.  They may have been
installed in the same structure, or into one single function directory.
The following is a description of the files found in the original
directory structure.  If you wish to alter an installed file, you will
need to copy it to some directory which appears earlier in your fpath
than the standard directory where it appears.

Base
     The core functions and special completion widgets automatically
     bound to keys.  You will certainly need most of these, though will
     probably not need to alter them.  Many of these are documented
     above.

Zsh
     Functions for completing arguments of shell builtin commands and
     utility functions for this.  Some of these are also used by
     functions from the Unix directory.

Unix
     Functions for completing arguments of external commands and suites
     of commands.  They may need modifying for your system, although in
     many cases some attempt is made to decide which version of a
     command is present.  For example, completion for the mount command
     tries to determine the system it is running on, while completion
     for many other utilities try to decide whether the GNU version of
     the command is in use, and hence whether the -help option is
     supported.

X, AIX, BSD, ...
     Completion and utility function for commands available only on
     some systems.  These are not arranged hierarchically, so, for
     example, both the Linux and Debian directories, as well as the X
     directory, may be useful on your system.

20 Completion Using compctl
***************************

20.1 Types of completion
========================

This version of zsh has two ways of performing completion of words on
the command line.  New users of the shell may prefer to use the newer
and more powerful system based on shell functions; this is described in
Completion System, and the basic shell mechanisms which support
it are described in Completion Widgets.  This chapter describes
the older compctl command.

20.2 Description
================

compctl [ -CDT ] OPTIONS [ COMMAND ... ]

compctl [ -CDT ] OPTIONS [ -x PATTERN OPTIONS - ... - ] [ + OPTIONS [ -x ... - ] ... [+] ] [ COMMAND ... ]

compctl -M MATCH-SPECS ...

compctl -L [ -CDTM ] [ COMMAND ... ]

compctl + COMMAND ...

Control the editor's completion behavior according to the supplied set
of OPTIONS.  Various editing commands, notably expand-or-complete-word,
usually bound to tab, will attempt to complete a word typed by the
user, while others, notably delete-char-or-list, usually bound to ^D in
EMACS editing mode, list the possibilities; compctl controls what those
possibilities are.  They may for example be filenames (the most common
case, and hence the default), shell variables, or words from a
user-specified list.

20.3 Command Flags
==================

Completion of the arguments of a command may be different for each
command or may use the default.  The behavior when completing the
command word itself may also be separately specified.  These correspond
to the following flags and arguments, all of which (except for -L) may
be combined with any combination of the OPTIONS described subsequently
in Option Flags:

COMMAND ...
     controls completion for the named commands, which must be listed
     last on the command line.  If completion is attempted for a
     command with a pathname containing slashes and no completion
     definition is found, the search is retried with the last pathname
     component. If the command starts with a =, completion is tried
     with the pathname of the command.

     Any of the COMMAND strings may be patterns of the form normally
     used for filename generation.  These should be be quoted to
     protect them from immediate expansion; for example the command
     string 'foo*' arranges for completion of the words of any command
     beginning with foo.  When completion is attempted, all pattern
     completions are tried in the reverse order of their definition
     until one matches.  By default, completion then proceeds as
     normal, i.e. the shell will try to generate more matches for the
     specific command on the command line; this can be overridden by
     including -tn in the flags for the pattern completion.

     Note that aliases are expanded before the command name is
     determined unless the COMPLETE_ALIASES option is set.  Commands
     may not be combined with the -C, -D or -T flags.

-C
     controls completion when the command word itself is being
     completed.  If no compctl -C command has been issued,  the names
     of any executable command (whether in the path or specific to the
     shell, such as aliases or functions) are completed.

-D
     controls default completion behavior for the arguments of commands
     not assigned any special behavior.  If no compctl -D command has
     been issued, filenames are completed.

-T
     supplies completion flags to be used before any other processing is
     done, even before processing for compctls defined for specific
     commands.  This is especially useful when combined with extended
     completion (the -x flag, see Extended Completion below).
     Using this flag you can define default behavior which will apply
     to all commands without exception, or you can alter the standard
     behavior for all commands.  For example, if your access to the
     user database is too slow and/or it contains too many users (so
     that completion after `~' is too slow to be usable), you can use

          compctl -T -x 's[~] C[0,[^/]#]' -k friends -S/ -tn

     to complete the strings in the array friends after a `~'.  The
     C[...] argument is necessary so that this form of ~-completion is
     not tried after the directory name is finished.

-L
     lists the existing completion behavior in a manner suitable for
     putting into a start-up script; the existing behavior is not
     changed.  Any combination of the above forms, or the -M flag
     (which must follow the -L flag), may be specified, otherwise all
     defined completions are listed.  Any other flags supplied are
     ignored.

_no argument_
     If no argument is given, compctl lists all defined completions in
     an abbreviated form;  with a list of OPTIONS, all completions with
     those flags set (not counting extended completion) are listed.

If the + flag is alone and followed immediately by the COMMAND list,
the completion behavior for all the commands in the list is reset to
the default.  In other words, completion will subsequently use the
options specified by the -D flag.

The form with -M as the first and only option defines global matching
specifications (see Matching Control). The match specifications
given will be used for every completion attempt (only when using
compctl, not with the new completion system) and are tried in the order
in which they are defined until one generates at least one match. E.g.:

     compctl -M '' 'm:{a-zA-Z}={A-Za-z}'

This will first try completion without any global match specifications
(the empty string) and, if that generates no matches, will try case
insensitive completion.

20.4 Option Flags
=================

[ -fcFBdeaRGovNAIOPZEnbjrzu/12 ]

[ -k ARRAY ] [ -g GLOBSTRING ] [ -s SUBSTSTRING ]

[ -K FUNCTION ]

[ -Q ] [ -P PREFIX ] [ -S SUFFIX ]

[ -W FILE-PREFIX ] [ -H NUM PATTERN ]

[ -q ] [ -X EXPLANATION ] [ -Y EXPLANATION ]

[ -y FUNC-OR-VAR ] [ -l CMD ] [ -h CMD ] [ -U ]

[ -t CONTINUE ] [ -J NAME ] [ -V NAME ]

[ -M MATCH-SPEC ]

The remaining OPTIONS specify the type of command arguments to look for
during completion.  Any combination of these flags may be specified;
the result is a sorted list of all the possibilities.  The options are
as follows.

20.4.1 Simple Flags
-------------------

These produce completion lists made up by the shell itself:

-f
     Filenames and filesystem paths.

-/
     Just filesystem paths.

-c
     Command names, including aliases, shell functions, builtins and
     reserved words.

-F
     Function names.

-B
     Names of builtin commands.

-m
     Names of external commands.

-w
     Reserved words.

-a
     Alias names.

-R
     Names of regular (non-global) aliases.

-G
     Names of global aliases.

-d
     This can be combined with -F, -B, -w, -a, -R and -G to get names
     of disabled functions, builtins, reserved words or aliases.

-e
     This option (to show enabled commands) is in effect by default, but
     may be combined with -d; -de in combination with -F, -B, -w, -a,
     -R and -G will complete names of functions, builtins, reserved
     words or aliases whether or not they are disabled.

-o
     Names of shell options (see Options).

-v
     Names of any variable defined in the shell.

-N
     Names of scalar (non-array) parameters.

-A
     Array names.

-I
     Names of integer variables.

-O
     Names of read-only variables.

-p
     Names of parameters used by the shell (including special
     parameters).

-Z
     Names of shell special parameters.

-E
     Names of environment variables.

-n
     Named directories.

-b
     Key binding names.

-j
     Job names:  the first word of the job leader's command line.  This
     is useful with the kill builtin.

-r
     Names of running jobs.

-z
     Names of suspended jobs.

-u
     User names.

20.4.2 Flags with Arguments
---------------------------

These have user supplied arguments to determine how the list of
completions is to be made up:

-k ARRAY
     Names taken from the elements of $ARRAY (note that the `$' does
     not appear on the command line).  Alternatively, the argument
     ARRAY itself may be a set of space- or comma-separated values in
     parentheses, in which any delimiter may be escaped with a
     backslash; in this case the argument should be quoted.  For
     example,

          compctl -k "(cputime filesize datasize stacksize
          	       coredumpsize resident descriptors)" limit

-g GLOBSTRING
     The GLOBSTRING is expanded using filename globbing; it should be
     quoted to protect it from immediate expansion. The resulting
     filenames are taken as the possible completions.  Use `*(/)'
     instead of `*/' for directories.  The fignore special parameter is
     not applied to the resulting files.  More than one pattern may be
     given separated by blanks. (Note that brace expansion is _not_
     part of globbing.  Use the syntax `(either|or)' to match
     alternatives.)

-s SUBSTSTRING
     The SUBSTSTRING is split into words and these words are than
     expanded using all shell expansion mechanisms (see
     Expansion).  The resulting words are taken as possible
     completions.  The fignore special parameter is not applied to the
     resulting files.  Note that -g is faster for filenames.

-K FUNCTION
     Call the given function to get the completions.  Unless the name
     starts with an underscore, the function is passed two arguments:
     the prefix and the suffix of the word on which completion is to be
     attempted, in other words those characters before the cursor
     position, and those from the cursor position onwards.  The whole
     command line can be accessed with the -c and -l flags of the read
     builtin. The function should set the variable reply to an array
     containing the completions (one completion per element); note that
     reply should not be made local to the function.  From such a
     function the command line can be accessed with the -c and -l flags
     to the read builtin.  For example,

          function whoson { reply=(`users`); }
          compctl -K whoson talk

     completes only logged-on users after `talk'.  Note that `whoson'
     must return an array, so `reply=`users`' would be incorrect.

-H NUM PATTERN
     The possible completions are taken from the last NUM history
     lines.  Only words matching PATTERN are taken.  If NUM is zero or
     negative the whole history is searched and if PATTERN is the empty
     string all words are taken (as with `*').  A typical use is

          compctl -D -f + -H 0 ''

     which forces completion to look back in the history list for a
     word if no filename matches.

20.4.3 Control Flags
--------------------

These do not directly specify types of name to be completed, but
manipulate the options that do:

-Q
     This instructs the shell not to quote any metacharacters in the
     possible completions.  Normally the results of a completion are
     inserted into the command line with any metacharacters quoted so
     that they are interpreted as normal characters.  This is
     appropriate for filenames and ordinary strings.  However, for
     special effects, such as inserting a backquoted expression from a
     completion array (-k) so that the expression will not be evaluated
     until the complete line is executed, this option must be used.

-P PREFIX
     The PREFIX is inserted just before the completed string; any
     initial part already typed will be completed and the whole PREFIX
     ignored for completion purposes.  For example,

          compctl -j -P "%" kill

     inserts a `%' after the kill command and then completes job names.

-S SUFFIX
     When a completion is found the SUFFIX is inserted after the
     completed string.  In the case of menu completion the suffix is
     inserted immediately, but it is still possible to cycle through the
     list of completions by repeatedly hitting the same key.

-W FILE-PREFIX
     With directory FILE-PREFIX:  for command, file, directory and
     globbing completion (options -c, -f, -/, -g), the file prefix is
     implicitly added in front of the completion.  For example,

          compctl -/ -W ~/Mail maildirs

     completes any subdirectories to any depth beneath the directory
     ~/Mail, although that prefix does not appear on the command line.
     The FILE-PREFIX may also be of the form accepted by the -k flag,
     i.e. the name of an array or a literal list in parenthesis. In
     this case all the directories in the list will be searched for
     possible completions.

-q
     If used with a suffix as specified by the -S option, this causes
     the suffix to be removed if the next character typed is a blank or
     does not insert anything or if the suffix consists of only one
     character and the next character typed is the same character; this
     the same rule used for the AUTO_REMOVE_SLASH option.  The option
     is most useful for list separators (comma, colon, etc.).

-l CMD
     This option restricts the range of command line words that are
     considered to be arguments.  If combined with one of the extended
     completion patterns `p[...]', `r[...]', or `R[...]'  (see
     Extended Completion below) the range is restricted to the range
     of arguments specified in the brackets.  Completion is then
     performed as if these had been given as arguments to the CMD
     supplied with the option. If the CMD string is empty the first
     word in the range is instead taken as the command name, and
     command name completion performed on the first word in the range.
     For example,

          compctl -x 'r[-exec,;]' -l '' -- find

     completes arguments between `-exec' and the following `;' (or the
     end of the command line if there is no such string) as if they were
     a separate command line.

-h CMD
     Normally zsh completes quoted strings as a whole. With this option,
     completion can be done separately on different parts of such
     strings. It works like the -l option but makes the completion code
     work on the parts of the current word that are separated by
     spaces. These parts are completed as if they were arguments to the
     given CMD. If CMD is the empty string, the first part is completed
     as a command name, as with -l.

-U
     Use the whole list of possible completions, whether or not they
     actually match the word on the command line.  The word typed so far
     will be deleted.  This is most useful with a function (given by the
     -K option) which can examine the word components passed to it (or
     via the read builtin's -c and -l flags) and use its own criteria
     to decide what matches.  If there is no completion, the original
     word is retained.  Since the produced possible completions seldom
     have interesting common prefixes and suffixes, menu completion is
     started immediately if AUTO_MENU is set and this flag is used.

-y FUNC-OR-VAR
     The list provided by FUNC-OR-VAR is displayed instead of the list
     of completions whenever a listing is required; the actual
     completions to be inserted are not affected.  It can be provided
     in two ways. Firstly, if FUNC-OR-VAR begins with a $ it defines a
     variable, or if it begins with a left parenthesis a literal array,
     which contains the list.  A variable may have been set by a call
     to a function using the -K option.  Otherwise it contains the name
     of a function which will be executed to create the list.  The
     function will be passed as an argument list all matching
     completions, including prefixes and suffixes expanded in full, and
     should set the array reply to the result.  In both cases, the
     display list will only be retrieved after a complete list of
     matches has been created.

     Note that the returned list does not have to correspond, even in
     length, to the original set of matches, and may be passed as a
     scalar instead of an array.  No special formatting of characters is
     performed on the output in this case; in particular, newlines are
     printed literally and if they appear output in columns is
     suppressed.

-X EXPLANATION
     Print EXPLANATION when trying completion on the current set of
     options. A `%n' in this string is replaced by the number of
     matches that were added for this explanation string.  The
     explanation only appears if completion was tried and there was no
     unique match, or when listing completions. Explanation strings
     will be listed together with the matches of the group specified
     together with the -X option (using the -J or -V option). If the
     same explanation string is given to multiple -X options, the
     string appears only once (for each group) and the number of
     matches shown for the `%n' is the total number of all matches for
     each of these uses. In any case, the explanation string will only
     be shown if there was at least one match added for the explanation
     string.

     The sequences %B, %b, %S, %s, %U, and %u specify output attributes
     (bold, standout, and underline) and %{...%} can be used to include
     literal escape sequences as in prompts.

-Y EXPLANATION
     Identical to -X, except that the EXPLANATION first undergoes
     expansion following the usual rules for strings in double quotes.
     The expansion will be carried out after any functions are called
     for the -K or -y options, allowing them to set variables.

-t CONTINUE
     The CONTINUE-string contains a character that specifies which set
     of completion flags should be used next.  It is useful:

     (i) With -T, or when trying a list of pattern completions, when
     compctl would usually continue with ordinary processing after
     finding matches; this can be suppressed with `-tn'.

     (ii) With a list of alternatives separated by +, when compctl
     would normally stop when one of the alternatives generates
     matches.  It can be forced to consider the next set of completions
     by adding `-t+' to the flags of the alternative before the `+'.

     (iii) In an extended completion list (see below), when compctl
     would normally continue until a set of conditions succeeded, then
     use only the immediately following flags.  With `-t-', compctl will
     continue trying extended completions after the next `-'; with
     `-tx' it will attempt completion with the default flags, in other
     words those before the `-x'.

-J NAME
     This gives the name of the group the matches should be placed in.
     Groups are listed and sorted separately; likewise, menu completion
     will offer the matches in the groups in the order in which the
     groups were defined. If no group name is explicitly given, the
     matches are stored in a group named DEFAULT. The first time a
     group name is encountered, a group with that name is created.
     After that all matches with the same group name are stored in that
     group.

     This can be useful with non-exclusive alternative completions.  For
     example, in

          compctl -f -J files -t+ + -v -J variables foo

     both files and variables are possible completions, as the -t+
     forces both sets of alternatives before and after the + to be
     considered at once.  Because of the -J options, however, all files
     are listed before all variables.

-V NAME
     Like -J, but matches within the group will not be sorted in
     listings nor in menu completion. These unsorted groups are in a
     different name space from the sorted ones, so groups defined as -J
     files and -V files are distinct.

-1
     If given together with the -V option, makes only consecutive
     duplicates in the group be removed. Note that groups with and
     without this flag are in different name spaces.

-2
     If given together with the -J or -V option, makes all duplicates
     be kept. Again, groups with and without this flag are in different
     name spaces.

-M MATCH-SPEC
     This defines additional matching control specifications that
     should be used only when testing words for the list of flags this
     flag appears in. The format of the MATCH-SPEC string is described
     in Matching Control.

20.5 Alternative Completion
===========================

compctl [ -CDT ] OPTIONS + OPTIONS [ + ... ] [ + ] COMMAND ...

The form with `+' specifies alternative options. Completion is tried
with the options before the first `+'. If this produces no matches
completion is tried with the flags after the `+' and so on. If there
are no flags after the last `+' and a match has not been found up to
that point, default completion is tried.  If the list of flags contains
a -t with a + character, the next list of flags is used even if the
current list produced matches.

20.6 Extended Completion
========================

compctl [ -CDT ] OPTIONS -x PATTERN OPTIONS - ... -
     [ COMMAND ... ]

compctl [ -CDT ] OPTIONS [ -x PATTERN OPTIONS - ... - ]
     [ + OPTIONS [ -x ... - ] ... [+] ] [ COMMAND ... ]

The form with `-x' specifies extended completion for the commands
given; as shown, it may be combined with alternative completion using
`+'.  Each PATTERN is examined in turn; when a match is found, the
corresponding OPTIONS, as described in Option Flags above, are
used to generate possible completions.  If no PATTERN matches, the
OPTIONS given before the -x are used.

Note that each pattern should be supplied as a single argument and
should be quoted to prevent expansion of metacharacters by the shell.

A PATTERN is built of sub-patterns separated by commas; it matches if
at least one of these sub-patterns matches (they are `or'ed). These
sub-patterns are in turn composed of other sub-patterns separated by
white spaces which match if all of the sub-patterns match (they are
`and'ed).  An element of the sub-patterns is of the form `C[...][...]',
where the pairs of brackets may be repeated as often as necessary, and
matches if any of the sets of brackets match (an `or').  The example
below makes this clearer.

The elements may be any of the following:

s[STRING]...
     Matches if the current word on the command line starts with one of
     the strings given in brackets.  The STRING is not removed and is
     not part of the completion.

S[STRING]...
     Like s[STRING] except that the STRING is part of the completion.

p[FROM,TO]...
     Matches if the number of the current word is between one of the
     FROM and TO pairs inclusive. The comma and TO are optional; TO
     defaults to the same value as FROM.  The numbers may be negative:
     -N refers to the N'th last word on the line.

c[OFFSET,STRING]...
     Matches if the STRING matches the word offset by OFFSET from the
     current word position.  Usually OFFSET will be negative.

C[OFFSET,PATTERN]...
     Like c but using pattern matching instead.

w[INDEX,STRING]...
     Matches if the word in position INDEX is equal to the
     corresponding STRING.  Note that the word count is made after any
     alias expansion.

W[INDEX,PATTERN]...
     Like w but using pattern matching instead.

n[INDEX,STRING]...
     Matches if the current word contains STRING.  Anything up to and
     including the INDEXth occurrence of this string will not be
     considered part of the completion, but the rest will.  INDEX may
     be negative to count from the end: in most cases, INDEX will be 1
     or -1.  For example,

          compctl -s '`users`' -x 'n[1,@]' -k hosts -- talk

     will usually complete usernames, but if you insert an @ after the
     name, names from the array HOSTS (assumed to contain hostnames,
     though you must make the array yourself) will be completed.  Other
     commands such as rcp can be handled similarly.

N[INDEX,STRING]...
     Like n except that the string will be taken as a character class.
     Anything up to and including the INDEXth occurrence of any of the
     characters in STRING will not be considered part of the completion.

m[MIN,MAX]...
     Matches if the total number of words lies between MIN and MAX
     inclusive.

r[STR1,STR2]...
     Matches if the cursor is after a word with prefix STR1.  If there
     is also a word with prefix STR2 on the command line after the one
     matched by STR1 it matches only if the cursor is before this word.
     If the comma and STR2 are omitted, it matches if the cursor is
     after a word with prefix STR1.

R[STR1,STR2]...
     Like r but using pattern matching instead.

q[STR]...
     Matches the word currently being completed is in single quotes and
     the STR begins with the letter `s', or if completion is done in
     double quotes and STR starts with the letter `d', or if completion
     is done in backticks and STR starts with a `b'.

20.7 Example
============

     compctl -u -x 's[+] c[-1,-f],s[-f+]' \
       -g '~/Mail/*(:t)' - 's[-f],c[-1,-f]' -f -- mail

This is to be interpreted as follows:

If the current command is mail, then

     if ((the current word begins with + and the previous word is -f)
     or (the current word begins with -f+)), then complete the
     non-directory part (the `:t' glob modifier) of files in the
     directory ~/Mail; else

     if the current word begins with -f or the previous word was -f,
     then complete any file; else

     complete user names.

21 Zsh Modules
**************

21.1 Description
================

Some optional parts of zsh are in modules, separate from the core of
the shell.  Each of these modules may be linked in to the shell at
build time, or can be dynamically linked while the shell is running if
the installation supports this feature.  The modules that are bundled
with the zsh distribution are:

zsh/cap
     Builtins for manipulating POSIX.1e (POSIX.6) capability
     (privilege) sets.

zsh/clone
     A builtin that can clone a running shell onto another terminal.

zsh/compctl
     The compctl builtin for controlling completion.

zsh/complete
     The basic completion code.

zsh/complist
     Completion listing extensions.

zsh/computil
     A module with utility builtins needed for the shell function based
     completion system.

zsh/datetime
     Some date/time commands and parameters.

zsh/deltochar
     A ZLE function duplicating EMACS' zap-to-char.

zsh/example
     An example of how to write a module.

zsh/files
     Some basic file manipulation commands as builtins.

zsh/mapfile
     Access to external files via a special associative array.

zsh/mathfunc
     Standard scientific functions for use in mathematical evaluations.

zsh/parameter
     Access to internal hash tables via special associative arrays.

zsh/pcre
     Interface to the PCRE library.

zsh/sched
     A builtin that provides a timed execution facility within the
     shell.

zsh/net/socket
     Manipulation of Unix domain sockets

zsh/stat
     A builtin command interface to the stat system call.

zsh/system
     A builtin interface to various low-level system features.

zsh/net/tcp
     Manipulation of TCP sockets

zsh/termcap
     Interface to the termcap database.

zsh/terminfo
     Interface to the terminfo database.

zsh/zftp
     A builtin FTP client.

zsh/zle
     The Zsh Line Editor, including the bindkey and vared builtins.

zsh/zleparameter
     Access to internals of the Zsh Line Editor via parameters.

zsh/zprof
     A module allowing profiling for shell functions.

zsh/zpty
     A builtin for starting a command in a pseudo-terminal.

zsh/zselect
     Block and return when file descriptors are ready.

zsh/zutil
     Some utility builtins, e.g. the one for supporting configuration
     via styles.

21.2 The zsh/cap Module
=======================

   The zsh/cap module is used for manipulating POSIX.1e (POSIX.6)
capability sets.  If the operating system does not support this
interface, the builtins defined by this module will do nothing.  The
builtins in this module are:

cap [ CAPABILITIES ]
     Change the shell's process capability sets to the specified
     CAPABILITIES, otherwise display the shell's current capabilities.

getcap FILENAME ...
     This is a built-in implementation of the POSIX standard utility.
     It displays the capability sets on each specified FILENAME.

setcap CAPABILITIES FILENAME ...
     This is a built-in implementation of the POSIX standard utility.
     It sets the capability sets on each specified FILENAME to the
     specified CAPABILITIES.

21.3 The zsh/clone Module
=========================

   The zsh/clone module makes available one builtin command:

clone TTY
     Creates a forked instance of the current shell, attached to the
     specified TTY.  In the new shell, the PID, PPID and TTY special
     parameters are changed appropriately.  $! is set to zero in the new
     shell, and to the new shell's PID in the original shell.

     The return value of the builtin is zero in both shells if
     successful, and non-zero on error.

     The target of clone should be an unused terminal, such as an
     unused virtual console or a virtual terminal created by

     xterm -e sh -c 'trap : INT QUIT TSTP; tty; while :; do sleep
     100000000; done'

     Some words of explanation are warranted about this long xterm
     command line: when doing clone on a pseudo-terminal, some other
     session ("session" meant as a unix session group, or SID) is
     already owning the terminal. Hence the cloned zsh cannot acquire
     the pseudo-terminal as a controlling tty. That means two things:

     the job control signals will go to the sh-started-by-xterm process
          group (that's why we disable INT QUIT and TSTP with trap;
     otherwise       the while loop could get suspended or killed)

     the cloned shell will have job control disabled, and the job
     control keys (control-C, control-\ and control-Z) will not work.

     This does not apply when cloning to an `unused' vc.

     Cloning to an used (and unprepared) terminal will result in two
     processes reading simultaneously from the same terminal, with
     input bytes going randomly to either process.

     clone is mostly useful as a shell built-in replacement for openvt.

21.4 The zsh/compctl Module
===========================

   The zsh/compctl module makes available two builtin commands. compctl,
is the old, deprecated way to control completions for ZLE.  See
Completion Using compctl.  The other builtin command, compcall can be
used in user-defined completion widgets, see Completion Widgets.

21.5 The zsh/complete Module
============================

   The zsh/complete module makes available several builtin commands
which can be used in user-defined completion widgets, see
Completion Widgets.

21.6 The zsh/complist Module
============================

   The zsh/complist module offers three extensions to completion
listings: the ability to highlight matches in such a list, the ability
to scroll through long lists and a different style of menu completion.

21.6.1 Colored completion listings
----------------------------------

Whenever one of the parameters ZLS_COLORS or ZLS_COLOURS is set and the
zsh/complist module is loaded or linked into the shell, completion
lists will be colored.  Note, however, that complist will not
automatically be loaded if it is not linked in:  on systems with
dynamic loading, `zmodload zsh/complist' is required.

The parameters ZLS_COLORS and ZLS_COLOURS describe how matches are
highlighted.  To turn on highlighting an empty value suffices, in which
case all the default values given below will be used.  The format of
the value of these parameters is the same as used by the GNU version of
the ls command: a colon-separated list of specifications of the form
`NAME=VALUE'.  The NAME may be one of the following strings, most of
which specify file types for which the VALUE will be used.  The strings
and their default values are:

no 0
     for normal text (i.e. when displaying something other than a
     matched file)

fi 0
     for regular files

di 32
     for directories

ln 36
     for symbolic links

pi 31
     for named pipes (FIFOs)

so 33
     for sockets

bd 44;37
     for block devices

cd 44;37
     for character devices

ex 35
     for executable files

mi NONE
     for a non-existent file (default is the value defined for fi)

lc \e[
     for the left code (see below)

rc m
     for the right code

tc 0
     for the character indicating the file type  printed after
     filenames if the LIST_TYPES option is set

sp 0
     for the spaces printed after matches to align the next column

ec NONE
     for the end code

Apart from these strings, the NAME may also be an asterisk (`*')
followed by any string. The VALUE given for such a string will be used
for all files whose name ends with the string.  The NAME may also be an
equals sign (`=') followed by a pattern.  The VALUE given for this
pattern will be used for all matches (not just filenames) whose display
string are matched by the pattern.  Definitions for both of these take
precedence over the values defined for file types and the form with the
leading asterisk takes precedence over the form with the leading equal
sign.

The last form also allows different parts of the displayed strings to
be colored differently.  For this, the pattern has to use the `(#b)'
globbing flag and pairs of parentheses surrounding the parts of the
strings that are to be colored differently.  In this case the VALUE may
consist of more than one color code separated by equal signs.  The
first code will be used for all parts for which no explicit code is
specified and the following codes will be used for the parts matched by
the sub-patterns in parentheses.  For example, the specification
`=(#b)(?)*(?)=0=3=7' will be used for all matches which are at least
two characters long and will use the code `3' for the first character,
`7' for the last character and `0' for the rest.

All three forms of NAME may be preceded by a pattern in parentheses.
If this is given, the VALUE will be used only for matches in groups
whose names are matched by the pattern given in the parentheses.  For
example, `(g*)m*=43' highlights all matches beginning with `m' in
groups whose names  begin with `g' using the color code `43'.  In case
of the `lc', `rc', and `ec' codes, the group pattern is ignored.

Note also that all patterns are tried in the order in which they appear
in the parameter value until the first one matches which is then used.

When printing a match, the code prints the value of lc, the value for
the file-type or the last matching specification with a `*', the value
of rc, the string to display for the match itself, and then the value
of ec if that is defined or the values of lc, no, and rc if ec is not
defined.

The default values are ISO 6429 (ANSI) compliant and can be used on
vt100 compatible terminals such as xterms.  On monochrome terminals the
default values will have no visible effect.  The colors function from
the contribution can be used to get associative arrays containing the
codes for ANSI terminals (see Other Functions).  For example,
after loading colors, one could use `$colors[red]' to get the code for
foreground color red and `$colors[bg-green]' for the code for
background color green.

If the completion system invoked by compinit is used, these parameters
should not be set directly because the system controls them itself.
Instead, the list-colors style should be used (see Completion System Configuration).

21.6.2 Scrolling in completion listings
---------------------------------------

To enable scrolling through a completion list, the LISTPROMPT parameter
must be set.  Its value will be used as the prompt; if it is the empty
string, a default prompt will be used.  The value may contain escapes
of the form `%x'.  It supports the escapes `%B', `%b', `%S', `%s',
`%U', `%u' and `%{...%}' used also in shell prompts as well as three
pairs of additional sequences: a `%l' or `%L' is replaced by the number
of the last line shown and the total number of lines in the form
`NUMBER/TOTAL'; a `%m' or `%M' is replaced with the number of the last
match shown and the total number of matches; and `%p' or `%P' is
replaced with `Top', `Bottom' or the position of the first line shown
in percent of the total number of lines, respectively.  In each of
these cases the form with the uppercase letter will be replaced with a
string of fixed width, padded to the right with spaces, while the
lowercase form will not be padded.

If the parameter LISTPROMPT is set, the completion code will not ask if
the list should be shown.  Instead it immediately starts displaying the
list, stopping after the first screenful, showing the prompt at the
bottom, waiting for a keypress after temporarily switching to the
listscroll keymap.  Some of the zle functions have a special meaning
while scrolling lists:

send-break
     stops listing discarding the key pressed

accept-line, down-history, down-line-or-history
down-line-or-search, vi-down-line-or-history
     scrolls forward one line

complete-word, menu-complete, expand-or-complete
expand-or-complete-prefix, menu-complete-or-expand
     scrolls forward one screenful

Every other character stops listing and immediately processes the key
as usual.  Any key that is not bound in the listscroll keymap or that
is bound to undefined-key is looked up in the keymap currently selected.

As for the ZLS_COLORS and ZLS_COLOURS parameters, LISTPROMPT should not
be set directly when using the shell function based completion system.
Instead, the list-prompt style should be used.

21.6.3 Menu selection
---------------------

The zsh/complist module also offers an alternative style of selecting
matches from a list, called menu selection, which can be used if the
shell is set up to return to the last prompt after showing a completion
list (see the ALWAYS_LAST_PROMPT option in Options).  It can be
invoked directly by the widget menu-select defined by the module.
Alternatively, the parameter MENUSELECT can be set to an integer, which
gives the minimum number of matches that must be present before menu
selection is automatically turned on.  This second method requires that
menu completion be started, either directly from a widget such as
menu-complete, or due to one of the options MENU_COMPLETE or AUTO_MENU
being set.  If MENUSELECT is set, but is 0, 1 or empty, menu selection
will always be started during an ambiguous menu completion.

When using the completion system based on shell functions, the
MENUSELECT parameter should not be used (like the ZLS_COLORS and
ZLS_COLOURS parameters described above).  Instead, the menu style
should be used with the select=... keyword.

After menu selection is started, the matches will be listed. If there
are more matches than fit on the screen, only the first screenful is
shown.  The matches to insert into the command line can be selected
from this list.  In the list one match is highlighted using the value
for ma from the ZLS_COLORS or ZLS_COLOURS parameter.  The default value
for this is `7' which forces the selected match to be highlighted using
standout mode on a vt100-compatible terminal.  If neither ZLS_COLORS
nor ZLS_COLOURS is set, the same terminal control sequence as for the
`%S' escape in prompts is used.

If there are more matches than fit on the screen and the parameter
MENUPROMPT is set, its value will be shown below the matches.  It
supports the same escape sequences as LISTPROMPT, but the number of the
match or line shown will be that of the one where the mark is placed.
If its value is the empty string, a default prompt will be used.

The MENUSCROLL parameter can be used to specify how the list is
scrolled.  If the parameter is unset, this is done line by line, if it
is set to `0' (zero), the list will scroll half the number of lines of
the screen.  If the value is positive, it gives the number of lines to
scroll and if it is negative, the list will be scrolled the number of
lines of the screen minus the (absolute) value.

As for the ZLS_COLORS, ZLS_COLOURS and LISTPROMPT parameters, neither
MENUPROMPT nor MENUSCROLL should be set directly when using the shell
function based completion system.  Instead, the select-prompt and
select-scroll styles should be used.

The completion code sometimes decides not to show all of the matches in
the list.  These hidden matches are either matches for which the
completion function which added them explicitly requested that they not
appear in the list (using the -n option of the compadd builtin command)
or they are matches which duplicate a string already in the list
(because they differ only in things like prefixes or suffixes that are
not displayed).  In the list used for menu selection, however, even
these matches are shown so that it is possible to select them.  To
highlight such matches the hi and du capabilities in the ZLS_COLORS and
ZLS_COLOURS parameters are supported for hidden matches of the first
and second kind, respectively.

Selecting matches is done by moving the mark around using the zle
movement functions.  When not all matches can be shown on the screen at
the same time, the list will scroll up and down when crossing the top or
bottom line.  The following zle functions have special meaning during
menu selection:

accept-line
     accepts the current match and leaves menu selection

send-break
     leaves menu selection and restores the previous contents of the
     command line

redisplay, clear-screen
     execute their normal function without leaving menu selection

accept-and-hold, accept-and-menu-complete
     accept the currently inserted match and continue selection
     allowing to select the next match to insert into the line

accept-and-infer-next-history
     accepts the current match and then tries completion with menu
     selection again;  in the case of files this allows one to select a
     directory and immediately attempt to complete files in it;  if
     there are no matches, a message is shown and one can use undo to
     go back to completion on the previous level, every other key
     leaves menu selection (including the other zle functions which are
     otherwise special during menu selection)

undo
     removes matches inserted during the menu selection by one of the
     three functions before

down-history, down-line-or-history
vi-down-line-or-history,  down-line-or-search
     moves the mark one line down

up-history, up-line-or-history
vi-up-line-or-history, up-line-or-search
     moves the mark one line up

forward-char, vi-forward-char
     moves the mark one column right

backward-char, vi-backward-char
     moves the mark one column left

forward-word, vi-forward-word
vi-forward-word-end, emacs-forward-word
     moves the mark one screenful down

backward-word, vi-backward-word, emacs-backward-word
     moves the mark one screenful up

vi-forward-blank-word, vi-forward-blank-word-end
     moves the mark to the first line of the next group of matches

vi-backward-blank-word
     moves the mark to the last line of the previous group of matches

beginning-of-history
     moves the mark to the first line

end-of-history
     moves the mark to the last line

beginning-of-buffer-or-history, beginning-of-line
beginning-of-line-hist, vi-beginning-of-line
     moves the mark to the leftmost column

end-of-buffer-or-history, end-of-line
end-of-line-hist, vi-end-of-line
     moves the mark to the rightmost column

complete-word, menu-complete, expand-or-complete
expand-or-complete-prefix, menu-expand-or-complete
     moves the mark to the next match

reverse-menu-complete
     moves the mark to the previous match

vi-insert
     this toggles between normal and interactive mode; in interactive
     mode the keys bound to self-insert and self-insert-unmeta insert
     into the command line as in normal editing mode but without leaving
     menu selection; after each character completion is tried again and
     the list changes to contain only the new matches; the completion
     widgets make the longest unambiguous string be inserted in the
     command line and undo and backward-delete-char go back to the
     previous set of matches

history-incremental-search-forward,
     history-incremental-search-backward this starts incremental
     searches in the list of completions displayed; in this mode,
     accept-line only leaves incremental search, going back to the
     normal menu selection mode

All movement functions wrap around at the edges; any other zle function
not listed leaves menu selection and executes that function.  It is
possible to make widgets in the above list do the same by using the
form of the widget with a `.' in front.  For example, the widget
`.accept-line' has the effect of leaving menu selection and accepting
the entire command line.

During this selection the widget uses the keymap menuselect.  Any key
that is not defined in this keymap or that is bound to undefined-key is
looked up in the keymap currently selected.  This is used to ensure
that the most important keys used during selection (namely the cursor
keys, return, and TAB) have sensible defaults.  However, keys in the
menuselect keymap can be modified directly using the bindkey builtin
command (see The zsh/zle Module). For example, to make the
return key leave menu selection without accepting the match currently
selected one could call

     bindkey -M menuselect '^M' send-break

after loading the zsh/complist module.

21.7 The zsh/computil Module
============================

   The zsh/computil module adds several builtin commands that are used
by some of the completion functions in the completion system based on
shell functions (see Completion System ).  Except for compquote
these builtin commands are very specialised and thus not very
interesting when writing your own completion functions.  In summary,
these builtin commands are:

comparguments
     This is used by the _arguments function to do the argument and
     command line parsing.  Like compdescribe it has an option -i to do
     the parsing and initialize some internal state and various options
     to access the state information to decide what should be completed.

compdescribe
     This is used by the _describe function to build the displays for
     the matches and to get the strings to add as matches with their
     options.  On the first call one of the options -i or -I should be
     supplied as the first argument.  In the first case, display
     strings without the descriptions will be generated, in the second
     case, the string used to separate the matches from their
     descriptions must be given as the second argument and the
     descriptions (if any) will be shown.  All other arguments are like
     the definition arguments to _describe itself.

     Once compdescribe has been called with either the -i or the -I
     option, it can be repeatedly called with the -g option and the
     names of five arrays as its arguments.  This will step through the
     different sets of matches and store the options in the first array,
     the strings with descriptions in the second, the matches for these
     in the third, the strings without descriptions in the fourth, and
     the matches for them in the fifth array.  These are then directly
     given to compadd to register the matches with the completion code.

compfiles
     Used by the _path_files function to optimize complex recursive
     filename generation (globbing).  It does three things.  With the
     -p and -P options it builds the glob patterns to use, including
     the paths already handled and trying to optimize the patterns with
     respect to the prefix and suffix from the line and the match
     specification currently used.  The -i option does the directory
     tests for the ignore-parents style and the -r option tests if a
     component for some of the matches are equal to the string on the
     line and removes all other matches if that is true.

compgroups
     Used by the _tags function to implement the internals of the
     group-order style.  This only takes its arguments as names of
     completion groups and creates the groups for it (all six types:
     sorted and unsorted, both without removing duplicates, with
     removing all duplicates and with removing consecutive duplicates).

compquote [ -p ] NAMES ...
     There may be reasons to write completion functions that have to add
     the matches using the -Q option to compadd and perform quoting
     themselves.  Instead of interpreting the first character of the
     all_quotes key of the compstate special association and using the
     q flag for parameter expansions, one can use this builtin command.
     The arguments are the names of scalar or array parameters and the
     values of these parameters are quoted as needed for the innermost
     quoting level.  If the -p option is given, quoting is done as if
     there is some prefix before the values of the parameters, so that
     a leading equal sign will not be quoted.

     The return value is non-zero in case of an error and zero
     otherwise.

comptags
comptry
     These implement the internals of the tags mechanism.

compvalues
     Like comparguments, but for the _values function.

21.8 The zsh/datetime Module
============================

   The zsh/datetime module makes available one builtin command:

strftime [ -s SCALAR ] FORMAT EPOCHTIME
     Output the date denoted by EPOCHTIME in the FORMAT specified.

     If -s SCALAR is given, assign the date to SCALAR instead of
     printing it.

The zsh/datetime module makes available one parameter:

EPOCHSECONDS
     An integer value representing the number of seconds since the
     epoch.

21.9 The zsh/deltochar Module
=============================

   The zsh/deltochar module makes available two ZLE functions:

delete-to-char
     Read a character from the keyboard, and delete from the cursor
     position up to and including the next (or, with repeat count N,
     the Nth) instance of that character.  Negative repeat counts mean
     delete backwards.

zap-to-char
     This behaves like delete-to-char, except that the final occurrence
     of the character itself is not deleted.

21.10 The zsh/example Module
============================

   The zsh/example module makes available one builtin command:

example [ -flags ] [ ARGS ... ]
     Displays the flags and arguments it is invoked with.

The purpose of the module is to serve as an example of how to write a
module.

21.11 The zsh/files Module
==========================

   The zsh/files module makes some standard commands available as
builtins:

chgrp [ -Rs ] GROUP FILENAME ...
     Changes group of files specified.  This is equivalent to chown with
     a USER-SPEC argument of `:GROUP'.

chown [ -Rs ] USER-SPEC FILENAME ...
     Changes ownership and group of files specified.

     The USER-SPEC can be in four forms:

    USER
          change owner to USER; do not change group

    USER::
          change owner to USER; do not change group

    USER:
          change owner to USER; change group to USER's primary group

    USER:GROUP
          change owner to USER; change group to GROUP

    :GROUP
          do not change owner; change group to GROUP

     In each case, the `:' may instead be a `.'.  The rule is that if
     there is a `:' then the separator is `:', otherwise if there is a
     `.' then the separator is `.', otherwise there is no separator.

     Each of USER and GROUP may be either a username (or group name, as
     appropriate) or a decimal user ID (group ID).  Interpretation as a
     name takes precedence, if there is an all-numeric username (or
     group name).

     The -R option causes chown to recursively descend into directories,
     changing the ownership of all files in the directory after
     changing the ownership of the directory itself.

     The -s option is a zsh extension to chown functionality.  It
     enables paranoid behaviour, intended to avoid security problems
     involving a chown being tricked into affecting files other than
     the ones intended.  It will refuse to follow symbolic links, so
     that (for example) ``chown luser /tmp/foo/passwd'' can't
     accidentally chown /etc/passwd if /tmp/foo happens to be a link to
     /etc.  It will also check where it is after leaving directories,
     so that a recursive chown of a deep directory tree can't end up
     recursively chowning /usr as a result of directories being moved
     up the tree.

ln [ -dfis ] FILENAME DEST
ln [ -dfis ] FILENAME ... DIR
     Creates hard (or, with -s, symbolic) links.  In the first form, the
     specified DESTination is created, as a link to the specified
     FILENAME.  In the second form, each of the FILENAMEs is taken in
     turn, and linked to a pathname in the specified DIRectory that has
     the same last pathname component.

     Normally, ln will not attempt to create hard links to directories.
     This check can be overridden using the -d option.  Typically only
     the super-user can actually succeed in creating hard links to
     directories.  This does not apply to symbolic links in any case.

     By default, existing files cannot be replaced by links.  The -i
     option causes the user to be queried about replacing existing
     files.  The -f option causes existing files to be silently
     deleted, without querying.  -f takes precedence.

mkdir [ -p ] [ -m MODE ] DIR ...
     Creates directories.  With the -p option, non-existing parent
     directories are first created if necessary, and there will be no
     complaint if the directory already exists.  The -m option can be
     used to specify (in octal) a set of file permissions for the
     created directories, otherwise mode 777 modified by the current
     umask (see man page umask(2)) is used.

mv [ -fi ] FILENAME DEST
mv [ -fi ] FILENAME ... DIR
     Moves files.  In the first form, the specified FILENAME is moved
     to the specified DESTination.  In the second form, each of the
     FILENAMEs is taken in turn, and moved to a pathname in the
     specified DIRectory that has the same last pathname component.

     By default, the user will be queried before replacing any file
     that the user cannot write to, but writable files will be silently
     removed.  The -i option causes the user to be queried about
     replacing any existing files.  The -f option causes any existing
     files to be silently deleted, without querying.  -f takes
     precedence.

     Note that this mv will not move files across devices.  Historical
     versions of mv, when actual renaming is impossible, fall back on
     copying and removing files; if this behaviour is desired, use cp
     and rm manually.  This may change in a future version.

rm [ -dfirs ] FILENAME ...
     Removes files and directories specified.

     Normally, rm will not remove directories (except with the -r
     option).  The -d option causes rm to try removing directories with
     unlink (see man page unlink(2)), the same method used for files.
     Typically only the super-user can actually succeed in unlinking
     directories in this way.  -d takes precedence over -r.

     By default, the user will be queried before removing any file that
     the user cannot write to, but writable files will be silently
     removed.  The -i option causes the user to be queried about
     removing any files.  The -f option causes files to be silently
     deleted, without querying, and suppresses all error indications.
     -f takes precedence.

     The -r option causes rm to recursively descend into directories,
     deleting all files in the directory before removing the directory
     with the rmdir system call (see man page rmdir(2)).

     The -s option is a zsh extension to rm functionality.  It enables
     paranoid behaviour, intended to avoid common security problems
     involving a root-run rm being tricked into removing files other
     than the ones intended.  It will refuse to follow symbolic links,
     so that (for example) ``rm /tmp/foo/passwd'' can't accidentally
     remove /etc/passwd if /tmp/foo happens to be a link to /etc.  It
     will also check where it is after leaving directories, so that a
     recursive removal of a deep directory tree can't end up
     recursively removing /usr as a result of directories being moved
     up the tree.

rmdir DIR ...
     Removes empty directories specified.

sync
     Calls the system call of the same name (see man page sync(2)),
     which flushes dirty buffers to disk.  It might return before the
     I/O has actually been completed.

21.12 The zsh/mapfile Module
============================

   The zsh/mapfile module provides one special associative array
parameter of the same name.

mapfile
     This associative array takes as keys the names of files; the
     resulting value is the content of the file.  The value is treated
     identically to any other text coming from a parameter.  The value
     may also be assigned to, in which case the file in question is
     written (whether or not it originally existed); or an element may
     be unset, which will delete the file in question.  For example,
     `vared mapfile[myfile]' works as expected, editing the file
     `myfile'.

     When the array is accessed as a whole, the keys are the names of
     files in the current directory, and the values are empty (to save
     a huge overhead in memory).  Thus ${(k)mapfile} has the same
     affect as the glob operator *(D), since files beginning with a dot
     are not special.  Care must be taken with expressions such as rm
     ${(k)mapfile}, which will delete every file in the current
     directory without the usual `rm *' test.

     The parameter mapfile may be made read-only; in that case, files
     referenced may not be written or deleted.

21.12.1 Limitations
-------------------

Although reading and writing of the file in question is efficiently
handled, zsh's internal memory management may be arbitrarily baroque.
Thus it should not automatically be assumed that use of mapfile
represents a gain in efficiency over use of other mechanisms.  Note in
particular that the whole contents of the file will always reside
physically in memory when accessed (possibly multiple times, due to
standard parameter substitution operations).  In particular, this means
handling of sufficiently long files (greater than the machine's swap
space, or than the range of the pointer type) will be incorrect.

No errors are printed or flagged for non-existent, unreadable, or
unwritable files, as the parameter mechanism is too low in the shell
execution hierarchy to make this convenient.

It is unfortunate that the mechanism for loading modules does not yet
allow the user to specify the name of the shell parameter to be given
the special behaviour.

21.13 The zsh/mathfunc Module
=============================

   The zsh/mathfunc module provides standard mathematical functions for
use when evaluating mathematical formulae.  The syntax agrees with
normal C and FORTRAN conventions, for example,

     (( f = sin(0.3) ))

assigns the sine of 0.3 to the parameter f.

Most functions take floating point arguments and return a floating point
value.  However, any necessary conversions from or to integer type will
be performed automatically by the shell.  Apart from atan with a second
argument and the abs, int and float functions, all functions behave as
noted in the manual page for the corresponding C function, except that
any arguments out of range for the function in question will be
detected by the shell and an error reported.

The following functions take a single floating point argument: acos,
acosh, asin, asinh, atan, atanh, cbrt, ceil, cos, cosh, erf, erfc, exp,
expm1, fabs, floor, gamma, j0, j1, lgamma, log, log10, log1p, logb,
sin, sinh, sqrt, tan, tanh, y0, y1.  The atan function can optionally
take a second argument, in which case it behaves like the C function
atan2.  The ilogb function takes a single floating point argument, but
returns an integer.

The function signgam takes no arguments, and returns an integer, which
is the C variable of the same name, as described in man page gamma(3).
Note that it is therefore only useful immediately after a call to gamma
or lgamma.  Note also that `signgam()' and `signgam' are distinct
expressions.

The following functions take two floating point arguments: copysign,
fmod, hypot, nextafter.

The following take an integer first argument and a floating point second
argument: jn, yn.

The following take a floating point first argument and an integer second
argument: ldexp, scalb.

The function abs does not convert the type of its single argument; it
returns the absolute value of either a floating point number or an
integer.  The functions float and int convert their arguments into a
floating point or integer value (by truncation) respectively.

Note that the C pow function is available in ordinary math evaluation
as the `**' operator and is not provided here.

The function rand48 is available if your system's mathematical library
has the function erand48(3).  It returns a pseudo-random floating point
number between 0 and 1.  It takes a single string optional argument.

If the argument is not present, the random number seed is initialised by
three calls to the rand(3) function -- this produces the same random
numbers as the next three values of $RANDOM.

If the argument is present, it gives the name of a scalar parameter
where the current random number seed will be stored.  On the first
call, the value must contain at least twelve hexadecimal digits (the
remainder of the string is ignored), or the seed will be initialised in
the same manner as for a call to rand48 with no argument.  Subsequent
calls to rand48(PARAM) will then maintain the seed in the parameter
PARAM as a string of twelve hexadecimal digits, with no base signifier.
The random number sequences for different parameters are completely
independent, and are also independent from that used by calls to rand48
with no argument.

For example, consider

     print $(( rand48(seed) ))
     print $(( rand48() ))
     print $(( rand48(seed) ))

Assuming $seed does not exist, it will be initialised by the first
call.  In the second call, the default seed is initialised; note,
however, that because of the properties of rand() there is a
correlation between the seeds used for the two initialisations, so for
more secure uses, you should generate your own 12-byte seed.  The third
call returns to the same sequence of random numbers used in the first
call, unaffected by the intervening rand48().

21.14 The zsh/parameter Module
==============================

   The zsh/parameter module gives access to some of the internal hash
tables used by the shell by defining some special parameters.

options
     The keys for this associative array are the names of the options
     that can be set and unset using the setopt and unsetopt builtins.
     The value of each key is either the string on if the option is
     currently set, or the string off if the option is unset.  Setting
     a key to one of these strings is like setting or unsetting the
     option, respectively. Unsetting a key in this array is like
     setting it to the value off.

commands
     This array gives access to the command hash table. The keys are the
     names of external commands, the values are the pathnames of the
     files that would be executed when the command would be invoked.
     Setting a key in this array defines a new entry in this table in
     the same way as with the hash builtin. Unsetting a key as in `unset
     "commands[foo]"' removes the entry for the given key from the
     command hash table.

functions
     This associative array maps names of enabled functions to their
     definitions. Setting a key in it is like defining a function with
     the name given by the key and the body given by the value.
     Unsetting a key removes the definition for the function named by
     the key.

dis_functions
     Like functions but for disabled functions.

builtins
     This associative array gives information about the builtin commands
     currently enabled. The keys are the names of the builtin commands
     and the values are either `undefined' for builtin commands that
     will automatically be loaded from a module if invoked or `defined'
     for builtin commands that are already loaded.

dis_builtins
     Like builtins but for disabled builtin commands.

reswords
     This array contains the enabled reserved words.

dis_reswords
     Like reswords but for disabled reserved words.

aliases
     This maps the names of the regular aliases currently enabled to
     their expansions.

dis_aliases
     Like aliases but for disabled regular aliases.

galiases
     Like aliases, but for global aliases.

dis_galiases
     Like galiases but for disabled global aliases.

saliases
     Like raliases, but for suffix aliases.

dis_saliases
     Like saliases but for disabled suffix aliases.

parameters
     The keys in this associative array are the names of the parameters
     currently defined. The values are strings describing the type of
     the parameter, in the same format used by the t parameter flag, see
     Parameter Expansion .  Setting or unsetting keys in this
     array is not possible.

modules
     An associative array giving information about modules. The keys
     are the names of the modules loaded, registered to be autoloaded,
     or aliased. The value says which state the named module is in and
     is one of the strings `loaded', `autoloaded', or `alias:NAME',
     where NAME is the name the module is aliased to.

     Setting or unsetting keys in this array is not possible.

dirstack
     A normal array holding the elements of the directory stack. Note
     that the output of the dirs builtin command includes one more
     directory, the current working directory.

history
     This associative array maps history event numbers to the full
     history lines.

historywords
     A special array containing the words stored in the history.

jobdirs
     This associative array maps job numbers to the directories from
     which the job was started (which may not be the current directory
     of the job).

jobtexts
     This associative array maps job numbers to the texts of the
     command lines that were used to start the jobs.

jobstates
     This associative array gives information about the states of the
     jobs currently known. The keys are the job numbers and the values
     are strings of the form `JOB-STATE:MARK:PID=STATE...'. The
     JOB-STATE gives the state the whole job is currently in, one of
     `running', `suspended', or `done'. The MARK is `+' for the current
     job, `-' for the previous job and empty otherwise. This is
     followed by one `PID=STATE' for every process in the job. The PIDs
     are, of course, the process IDs and the STATE describes the state
     of that process.

nameddirs
     This associative array maps the names of named directories to the
     pathnames they stand for.

userdirs
     This associative array maps user names to the pathnames of their
     home directories.

funcstack
     This array contains the names of the functions currently being
     executed. The first element is the name of the function using the
     parameter.

21.15 The zsh/pcre Module
=========================

   The zsh/pcre module makes some commands available as builtins:

pcre_compile [ -aimx ] PCRE
     Compiles a perl-compatible regular expression.

     Option -a will force the pattern to be anchored.  Option -i will
     compile a case-insensitive pattern.  Option -m will compile a
     multi-line pattern; that is, ^ and $ will match newlines within
     the pattern.  Option -x will compile an extended pattern, wherein
     whitespace and # comments are ignored.

pcre_study
     Studies the previously-compiled PCRE which may result in faster
     matching.

pcre_match [ -a ARR ] STRING
     Returns successfully if string matches the previously-compiled
     PCRE.

     If the expression captures substrings within parentheses,
     pcre_match will set the array $MATCH to those substrings, unless
     the -a option is given, in which case it will set the array ARR.

The zsh/pcre module makes available the following test condition:
expr -pcre-match pcre
     Matches a string against a perl-compatible regular expression.

     For example,

     [[ "$text" -pcre-match ^d+$ ]] && print text variable contains
     only "d's".

21.16 The zsh/sched Module
==========================

   The zsh/sched module makes available one builtin command:

sched [+]HH:MM COMMAND ...
sched [ -ITEM ]
     Make an entry in the scheduled list of commands to execute.  The
     time may be specified in either absolute or relative time.  With
     no arguments, prints the list of scheduled commands.  With the
     argument `-ITEM', removes the given item from the list.

21.17 The zsh/net/socket Module
===============================

   The zsh/net/socket module makes available one builtin command:

zsocket [ -altv ] [ -d FD ] [ ARGS ]
     zsocket is implemented as a builtin to allow full use of shell
     command line editing, file I/O, and job control mechanisms.

21.17.1 Outbound Connections
----------------------------

    zsocket [ -v ] [ -d FD ] FILENAME
          Open a new Unix domain connection to FILENAME.  The shell
          parameter REPLY will be set to the file descriptor associated
          with that connection.  Currently, only stream connections are
          supported.

          If -d is specified, its argument will be taken as the target
          file descriptor for the connection.

          In order to elicit more verbose output, use -v.

21.17.2 Inbound Connections
---------------------------

    zsocket -l [ -v ] [ -d FD ] FILENAME
          zsocket -l will open a socket listening on FILENAME.  The
          shell parameter REPLY will be set to the file descriptor
          associated with that listener.

          If -d is specified, its argument will be taken as the target
          file descriptor for the connection.

          In order to elicit more verbose output, use -v.

    zsocket -a [ -tv ] [ -d TARGETFD ] LISTENFD
          zsocket -a will accept an incoming connection to the socket
          associated with LISTENFD.  The shell parameter REPLY will be
          set to the file descriptor associated with the inbound
          connection.

          If -d is specified, its argument will be taken as the target
          file descriptor for the connection.

          If -t is specified, zsocket will return if no incoming
          connection is pending.  Otherwise it will wait for one.

          In order to elicit more verbose output, use -v.

21.18 The zsh/stat Module
=========================

   The zsh/stat module makes available one builtin command:

stat [ -gnNolLtTrs ] [ -f FD ] [ -H HASH ] [ -A ARRAY ] [ -F FMT ] [ +ELEMENT ] [ FILE ... ]
     The command acts as a front end to the stat system call (see man
     page stat(2)).  If the stat call fails, the appropriate system
     error message printed and status 1 is returned.  The fields of
     struct stat give information about the files provided as arguments
     to the command.  In addition to those available from the stat
     call, an extra element `link' is provided.  These elements are:

    device
          The number of the device on which the file resides.

    inode
          The unique number of the file on this device (`_inode_'
          number).

    mode
          The mode of the file; that is, the file's type and access
          permissions.  With the -s option, this will be returned as a
          string corresponding to the first column in the display of
          the ls -l command.

    nlink
          The number of hard links to the file.

    uid
          The user ID of the owner of the file.  With the -s option,
          this is displayed as a user name.

    gid
          The group ID of the file.  With the -s option, this is
          displayed as a group name.

    rdev
          The raw device number.  This is only useful for special
          devices.

    size
          The size of the file in bytes.

    atime
    mtime
    ctime
          The last access, modification and inode change times of the
          file, respectively, as the number of seconds since midnight
          GMT on 1st January, 1970.  With the -s option, these are
          printed as strings for the local time zone; the format can be
          altered with the -F option, and with the -g option the times
          are in GMT.

    blksize
          The number of bytes in one allocation block on the device on
          which the file resides.

    block
          The number of disk blocks used by the file.

    link
          If the file is a link and the -L option is in effect, this
          contains the name of the file linked to, otherwise it is
          empty.  Note that if this element is selected (``stat +link'')
          then the -L option is automatically used.

     A particular element may be selected by including its name
     preceded by a `+' in the option list; only one element is allowed.
     The element may be shortened to any unique set of leading
     characters.  Otherwise, all elements will be shown for all files.

     Options:

    -A ARRAY
          Instead of displaying the results on standard output, assign
          them to an ARRAY, one struct stat element per array element
          for each file in order.  In this case neither the name of the
          element nor the name of the files appears in ARRAY unless the
          -t or -n options were given, respectively.  If -t is given,
          the element name appears as a prefix to the appropriate array
          element; if -n is given, the file name appears as a separate
          array element preceding all the others.  Other formatting
          options are respected.

    -H HASH
          Similar to -A, but instead assign the values to HASH.  The
          keys are the elements listed above.  If the -n option is
          provided then the name of the file is included in the hash
          with key name.

    -f FD
          Use the file on file descriptor FD instead of named files; no
          list of file names is allowed in this case.

    -F FMT
          Supplies a strftime (see man page strftime(3)) string for the
          formatting of the time elements.  The -s option is implied.

    -g
          Show the time elements in the GMT time zone.  The -s option
          is implied.

    -l
          List the names of the type elements (to standard output or an
          array as appropriate) and return immediately; options other
          than -A and arguments are ignored.

    -L
          Perform an lstat (see man page lstat(2)) rather than a stat
          system call.  In this case, if the file is a link, information
          about the link itself rather than the target file is returned.
          This option is required to make the link element useful.

    -n
          Always show the names of files.  Usually these are only shown
          when output is to standard output and there is more than one
          file in the list.

    -N
          Never show the names of files.

    -o
          If a raw file mode is printed, show it in octal, which is
          more useful for human consumption than the default of
          decimal.  A leading zero will be printed in this case.  Note
          that this does not affect whether a raw or formatted file
          mode is shown, which is controlled by the -r and -s options,
          nor whether a mode is shown at all.

    -r
          Print raw data (the default format) alongside string data
          (the -s format); the string data appears in parentheses after
          the raw data.

    -s
          Print mode, uid, gid and the three time elements as strings
          instead of numbers.  In each case the format is like that of
          ls -l.

    -t
          Always show the type names for the elements of struct stat.
          Usually these are only shown when output is to standard
          output and no individual element has been selected.

    -T
          Never show the type names of the struct stat elements.

21.19 The zsh/system Module
===========================

   The zsh/system module makes available three builtin commands and a
parameter.

21.20 Builtins
==============

syserror [ -e ERRVAR ] [ -p PREFIX ] [ ERRNO | ERRNAME ]
     This command prints out the error message associated with ERRNO, a
     system error number, followed by a newline to standard error.

     Instead of the error number, a name ERRNAME, for example ENOENT,
     may be used.  The set of names is the same as the contents of the
     array errnos, see below.

     If the string PREFIX is given, it is printed in front of the error
     message, with no intervening space.

     If ERRVAR is supplied, the entire message, without a newline, is
     assigned to the parameter names ERRVAR and nothing is output.

     A return value of 0 indicates the message was successfully printed
     (although it may not be useful if the error number was out of the
     system's range), a return value of 1 indicates an error in the
     parameters, and a return value of 2 indicates the error name was
     not recognised (no message is printed for this).

sysread [ -c COUNTVAR ] [ -i INFD ] [ -o OUTFD ]
[ -s BUFSIZE ] [ -t TIMEOUT ] [ PARAM ]
     Perform a single system read from file descriptor INFD, or zero if
     that is not given.  The result of the read is stored in PARAM or
     REPLY if that is not given.  If COUNTVAR is given, the number of
     bytes read is assigned to the parameter named by COUNTVAR.

     The maximum number of bytes read is BUFSIZE or 8192 if that is not
     given, however the command returns as soon as any number of bytes
     was successfully read.

     If TIMEOUT is given, it specifies a timeout in seconds, which may
     be zero to poll the file descriptor.  This is handled by the poll
     system call if available, otherwise the select system call if
     available.

     If OUTFD is given, an attempt is made to write all the bytes just
     read to the file descriptor OUTFD.  If this fails, because of a
     system error other than EINTR or because of an internal zsh error
     during an interrupt, the bytes read but not written are stored in
     the parameter named by PARAM if supplied (no default is used in
     this case), and the number of bytes read but not written is stored
     in the parameter named by COUNTVAR if that is supplied.  If it was
     successful, COUNTVAR contains the full number of bytes transferred,
     as usual, and PARAM is not set.

     The error EINTR (interrupted system call) is handled internally so
     that shell interrupts are transparent to the caller.  Any other
     error causes a return.

     The possible return values are
    0
          At least one byte of data was successfully read and, if
          appropriate, written.

    1
          There was an error in the parameters to the command.  This is
          the only error for which a message is printed to standard
          error.

    2
          There was an error on the read, or on polling the input file
          descriptor for a timeout.  The parameter ERRNO gives the
          error.

    3
          Data were successfully read, but there was an error writing
          them to OUTFD.  The parameter ERRNO gives the error.

    4
          The attempt to read timed out.  Note this does not set ERRNO
          as this is not a system error.

    5
          No system error occurred, but zero bytes were read.  This
          usually indicates end of file.  The parameters are set
          according to the usual rules; no write to OUTFD is attempted.

syswrite [ -c COUNTVAR ] [ -o OUTFD ] DATA
     The data (a single string of bytes) are written to the file
     descriptor OUTFD, or 1 if that is not given, using the write
     system call.  Multiple write operations may be used if the first
     does not write all the data.

     If COUNTVAR is given, the number of byte written is stored in the
     parameter named by COUNTVAR; this may not be the full length of
     DATA if an error occurred.

     The error EINTR (interrupted system call) is handled internally by
     retrying; otherwise an error causes the command to return.  For
     example, if the file descriptor is set to non-blocking output, an
     error EAGAIN (on some systems, EWOULDBLOCK) may result in the
     command returning early.

     The return status may be 0 for success, 1 for an error in the
     parameters to the command, or 2 for an error on the write; no
     error message is printed in the last case, but the parameter ERRNO
     will reflect the error that occurred.

21.21 Parameters
================

errnos
     A readonly array of the names of errors defined on the system.
     These are typically macros defined in C by including the system
     header file errno.h.  The index of each name (assuming the option
     KSH_ARRAYS is unset) corresponds to the error number.  Error
     numbers NUM before the last known error which have no name are
     given the name ENUM in the array.

     Note that aliases for errors are not handled; only the canonical
     name is used.

21.22 The zsh/net/tcp Module
============================

   The zsh/net/tcp module makes available one builtin command:

ztcp [ -acflLtv ] [ -d FD ] [ ARGS ]
     ztcp is implemented as a builtin to allow full use of shell
     command line editing, file I/O, and job control mechanisms.

     If ztcp is run with no options, it will output the contents of its
     session table.

     If it is run with only the option -L, it will output the contents
     of the session table in a format suitable for automatic parsing.
     The option is ignored if given with a command to open or close a
     session.  The output consists of a set of lines, one per session,
     each containing the following elements separated by spaces:

    File descriptor
          The file descriptor in use for the connection.  For normal
          inbound (I) and outbound (O) connections this may be read and
          written by the usual shell mechanisms.  However, it should
          only be close with `ztcp -c'.

    Connection type
          A letter indicating how the session was created:

         Z
               A session created with the zftp command.

         L
               A connection opened for listening with `ztcp -l'.

         I
               An inbound connection accepted with `ztcp -a'.

         O
               An outbound connection created with `ztcp HOST ...'.

    The local host
          This is usually set to an all-zero IP address as the address
          of the localhost is irrelevant.

    The local port
          This is likely to be zero unless the connection is for
          listening.

    The remote host
          This is the fully qualified domain name of the peer, if
          available, else an IP address.  It is an all-zero IP address
          for a session opened for listening.

    The remote port
          This is zero for a connection opened for listening.

21.22.1 Outbound Connections
----------------------------

ztcp [ -v ] [ -d FD ] HOST [ PORT ]
     Open a new TCP connection to HOST.  If the PORT is omitted, it
     will default to port 23.  The connection will be added to the
     session table and the shell parameter REPLY will be set to the
     file descriptor associated with that connection.

     If -d is specified, its argument will be taken as the target file
     descriptor for the connection.

     In order to elicit more verbose output, use -v.

21.22.2 Inbound Connections
---------------------------

ztcp -l [ -v ] [ -d FD ] PORT
     ztcp -l will open a socket listening on TCP PORT.  The socket will
     be added to the session table and the shell parameter REPLY will
     be set to the file descriptor associated with that listener.

     If -d is specified, its argument will be taken as the target file
     descriptor for the connection.

     In order to elicit more verbose output, use -v.

ztcp -a [ -tv ] [ -d TARGETFD ] LISTENFD
     ztcp -a will accept an incoming connection to the port associated
     with LISTENFD.  The connection will be added to the session table
     and the shell parameter REPLY will be set to the file descriptor
     associated with the inbound connection.

     If -d is specified, its argument will be taken as the target file
     descriptor for the connection.

     If -t is specified, ztcp will return if no incoming connection is
     pending.  Otherwise it will wait for one.

     In order to elicit more verbose output, use -v.

21.22.3 Closing Connections
---------------------------

ztcp -cf [ -v ] [ FD ]
ztcp -c [ -v ] [ FD ]
     ztcp -c will close the socket associated with FD.  The socket will
     be removed from the session table.  If FD is not specified, ztcp
     will close everything in the session table.

     Normally, sockets registered by zftp (see The zsh/zftp Module
     ) cannot be closed this way.  In order to force such a
     socket closed, use -f.

     In order to elicit more verbose output, use -v.

21.22.4 Example
---------------

Here is how to create a TCP connection between two instances of zsh.  We
need to pick an unassigned port; here we use the randomly chosen 5123.

On host1,
     zmodload zsh/net/tcp
     ztcp -l 5123
     listenfd=$REPLY
     ztcp -a $listenfd
     fd=$REPLY
   The second from last command blocks until there is an incoming
connection.

Now create a connection from host2 (which may, of course, be the same
machine):
     zmodload zsh/net/tcp
     ztcp host1 5123
     fd=$REPLY

Now on each host, $fd contains a file descriptor for talking to the
other.  For example, on host1:
     print This is a message >&$fd
   and on host2:
     read -r line <&$fd; print -r - $line
   prints `This is a message'.

To tidy up, on host1:
     ztcp -c $listenfd
     ztcp -c $fd
   and on host2
     ztcp -c $fd

21.23 The zsh/termcap Module
============================

   The zsh/termcap module makes available one builtin command:

echotc CAP [ ARG ... ]
     Output the termcap value corresponding to the capability CAP, with
     optional arguments.

The zsh/termcap module makes available one parameter:

termcap
     An associative array that maps termcap capability codes to their
     values.

21.24 The zsh/terminfo Module
=============================

   The zsh/terminfo module makes available one builtin command:

echoti CAP [ ARG ]
     Output the terminfo value corresponding to the capability CAP,
     instantiated with ARG if applicable.

The zsh/terminfo module makes available one parameter:

terminfo
     An associative array that maps terminfo capability names to their
     values.

21.25 The zsh/zftp Module
=========================

   The zsh/zftp module makes available one builtin command:

zftp SUBCOMMAND [ ARGS ]
     The zsh/zftp module is a client for FTP (file transfer protocol).
     It is implemented as a builtin to allow full use of shell command
     line editing, file I/O, and job control mechanisms.  Often, users
     will access it via shell functions providing a more powerful
     interface; a set is provided with the zsh distribution and is
     described in Zftp Function System.  However, the zftp
     command is entirely usable in its own right.

     All commands consist of the command name zftp followed by the name
     of a subcommand.  These are listed below.  The return status of
     each subcommand is supposed to reflect the success or failure of
     the remote operation.  See a description of the variable
     ZFTP_VERBOSE for more information on how responses from the server
     may be printed.

21.25.1 Subcommands
-------------------

open HOST[:PORT] [ USER [ PASSWORD [ ACCOUNT ] ] ]
     Open a new FTP session to HOST, which may be the name of a TCP/IP
     connected host or an IP number in the standard dot notation.  If
     the argument is in the form HOST:PORT, open a connection to TCP
     port PORT instead of the standard FTP port 21.  This may be the
     name of a TCP service or a number:  see the description of
     ZFTP_PORT below for more information.

     If IPv6 addresses in colon format are used, the HOST should be
     surrounded by quoted square brackets to distinguish it from the
     PORT, for example '[fe80::203:baff:fe02:8b56]'.  For consistency
     this is allowed with all forms of HOST.

     Remaining arguments are passed to the login subcommand.  Note that
     if no arguments beyond HOST are supplied, open will _not_
     automatically call login.  If no arguments at all are supplied,
     open will use the parameters set by the params subcommand.

     After a successful open, the shell variables ZFTP_HOST, ZFTP_PORT,
     ZFTP_IP and ZFTP_SYSTEM are available; see `Variables' below.

login [ NAME [ PASSWORD [ ACCOUNT ] ] ]
user [ NAME [ PASSWORD [ ACCOUNT ] ] ]
     Login the user NAME with parameters PASSWORD and ACCOUNT.  Any of
     the parameters can be omitted, and will be read from standard
     input if needed (NAME is always needed).  If standard input is a
     terminal, a prompt for each one will be printed on standard error
     and PASSWORD will not be echoed.  If any of the parameters are not
     used, a warning message is printed.

     After a successful login, the shell variables ZFTP_USER,
     ZFTP_ACCOUNT and ZFTP_PWD are available; see `Variables' below.

     This command may be re-issued when a user is already logged in, and
     the server will first be reinitialized for a new user.

params [ HOST [ USER [ PASSWORD [ ACCOUNT ] ] ] ]
params -
     Store the given parameters for a later open command with no
     arguments.  Only those given on the command line will be
     remembered.  If no arguments are given, the parameters currently
     set are printed, although the password will appear as a line of
     stars; the return value is one if no parameters were set, zero
     otherwise.

     Any of the parameters may be specified as a `?', which may need to
     be quoted to protect it from shell expansion.  In this case, the
     appropriate parameter will be read from stdin as with the login
     subcommand, including special handling of PASSWORD.  If the `?' is
     followed by a string, that is used as the prompt for reading the
     parameter instead of the default message (any necessary
     punctuation and whitespace should be included at the end of the
     prompt).  The first letter of the parameter (only) may be quoted
     with a `\'; hence an argument "\\$word" guarantees that the string
     from the shell parameter $word will be treated literally, whether
     or not it begins with a `?'.

     If instead a single `-' is given, the existing parameters, if any,
     are deleted.  In that case, calling open with no arguments will
     cause an error.

     The list of parameters is not deleted after a close, however it
     will be deleted if the zsh/zftp module is unloaded.

     For example,

          zftp params ftp.elsewhere.xx juser '?Password for juser: '

     will store the host ftp.elsewhere.xx and the user juser and then
     prompt the user for the corresponding password with the given
     prompt.

test
     Test the connection; if the server has reported that it has closed
     the connection (maybe due to a timeout), return status 2; if no
     connection was open anyway, return status 1; else return status 0.
     The test subcommand is silent, apart from messages printed by the
     $ZFTP_VERBOSE mechanism, or error messages if the connection
     closes.  There is no network overhead for this test.

     The test is only supported on systems with either the select(2) or
     poll(2) system calls; otherwise the message `not supported on this
     system' is printed instead.

     The test subcommand will automatically be called at the start of
     any other subcommand for the current session when a connection is
     open.

cd DIRECTORY
     Change the remote directory to DIRECTORY.  Also alters the shell
     variable ZFTP_PWD.

cdup
     Change the remote directory to the one higher in the directory
     tree.  Note that cd .. will also work correctly on non-UNIX
     systems.

dir [ ARGS... ]
     Give a (verbose) listing of the remote directory.  The ARGS are
     passed directly to the server. The command's behaviour is
     implementation dependent, but a UNIX server will typically
     interpret ARGS as arguments to the ls command and with no
     arguments return the result of `ls -l'. The directory is listed to
     standard output.

ls [ ARGS ]
     Give a (short) listing of the remote directory.  With no ARGS,
     produces a raw list of the files in the directory, one per line.
     Otherwise, up to vagaries of the server implementation, behaves
     similar to dir.

type [ TYPE ]
     Change the type for the transfer to TYPE, or print the current type
     if TYPE is absent.  The allowed values are `A' (ASCII), `I'
     (Image, i.e. binary), or `B' (a synonym for `I').

     The FTP default for a transfer is ASCII.  However, if zftp finds
     that the remote host is a UNIX machine with 8-bit byes, it will
     automatically switch to using binary for file transfers upon open.
     This can subsequently be overridden.

     The transfer type is only passed to the remote host when a data
     connection is established; this command involves no network
     overhead.

ascii
     The same as type A.

binary
     The same as type I.

mode [ S | B ]
     Set the mode type to stream (S) or block (B).  Stream mode is the
     default; block mode is not widely supported.

remote FILES...
local [ FILES... ]
     Print the size and last modification time of the remote or local
     files.  If there is more than one item on the list, the name of the
     file is printed first.  The first number is the file size, the
     second is the last modification time of the file in the format
     CCYYMMDDhhmmSS consisting of year, month, date, hour, minutes and
     seconds in GMT.  Note that this format, including the length, is
     guaranteed, so that time strings can be directly compared via the
     [[ builtin's < and > operators, even if they are too long to be
     represented as integers.

     Not all servers support the commands for retrieving this
     information.  In that case, the remote command will print nothing
     and return status 2, compared with status 1 for a file not found.

     The local command (but not remote) may be used with no arguments,
     in which case the information comes from examining file descriptor
     zero.  This is the same file as seen by a put command with no
     further redirection.

get FILE [...]
     Retrieve all FILEs from the server, concatenating them and sending
     them to standard output.

put FILE [...]
     For each FILE, read a file from standard input and send that to
     the remote host with the given name.

append FILE [...]
     As put, but if the remote FILE already exists, data is appended to
     it instead of overwriting it.

getat FILE POINT
putat FILE POINT
appendat FILE POINT
     Versions of get, put and append which will start the transfer at
     the given POINT in the remote FILE.  This is useful for appending
     to an incomplete local file.  However, note that this ability is
     not universally supported by servers (and is not quite the
     behaviour specified by the standard).

delete FILE [...]
     Delete the list of files on the server.

mkdir DIRECTORY
     Create a new directory DIRECTORY on the server.

rmdir DIRECTORY
     Delete the directory DIRECTORY  on the server.

rename OLD-NAME NEW-NAME
     Rename file OLD-NAME to NEW-NAME on the server.

site ARGS...
     Send a host-specific command to the server.  You will probably
     only need this if instructed by the server to use it.

quote ARGS...
     Send the raw FTP command sequence to the server.  You should be
     familiar with the FTP command set as defined in RFC959 before doing
     this.  Useful commands may include STAT and HELP.  Note also the
     mechanism for returning messages as described for the variable
     ZFTP_VERBOSE below, in particular that all messages from the
     control connection are sent to standard error.

close
quit
     Close the current data connection.  This unsets the shell
     parameters ZFTP_HOST, ZFTP_PORT, ZFTP_IP, ZFTP_SYSTEM, ZFTP_USER,
     ZFTP_ACCOUNT, ZFTP_PWD, ZFTP_TYPE and ZFTP_MODE.

session [ SESSNAME ]
     Allows multiple FTP sessions to be used at once.  The name of the
     session is an arbitrary string of characters; the default session
     is called `default'.  If this command is called without an
     argument, it will list all the current sessions; with an argument,
     it will either switch to the existing session called SESSNAME, or
     create a new session of that name.

     Each session remembers the status of the connection, the set of
     connection-specific shell parameters (the same set as are unset
     when a connection closes, as given in the description of close),
     and any user parameters specified with the params subcommand.
     Changing to a previous session restores those values; changing to
     a new session initialises them in the same way as if zftp had just
     been loaded.  The name of the current session is given by the
     parameter ZFTP_SESSION.

rmsession [ SESSNAME ]
     Delete a session; if a name is not given, the current session is
     deleted.  If the current session is deleted, the earliest existing
     session becomes the new current session, otherwise the current
     session is not changed.  If the session being deleted is the only
     one, a new session called `default' is created and becomes the
     current session; note that this is a new session even if the
     session being deleted is also called `default'. It is recommended
     that sessions not be deleted while background commands which use
     zftp are still active.

21.25.2 Parameters
------------------

The following shell parameters are used by zftp.  Currently none of
them are special.

ZFTP_TMOUT
     Integer.  The time in seconds to wait for a network operation to
     complete before returning an error.  If this is not set when the
     module is loaded, it will be given the default value 60.  A value
     of zero turns off timeouts.  If a timeout occurs on the control
     connection it will be closed.  Use a larger value if this occurs
     too frequently.

ZFTP_IP
     Readonly.  The IP address of the current connection in dot
     notation.

ZFTP_HOST
     Readonly.  The hostname of the current remote server.  If the host
     was opened as an IP number, ZFTP_HOST contains that instead; this
     saves the overhead for a name lookup, as IP numbers are most
     commonly used when a nameserver is unavailable.

ZFTP_PORT
     Readonly.  The number of the remote TCP port to which the
     connection is open (even if the port was originally specified as a
     named service).  Usually this is the standard FTP port, 21.

     In the unlikely event that your system does not have the
     appropriate conversion functions, this appears in network byte
     order.  If your system is little-endian, the port then consists of
     two swapped bytes and the standard port will be reported as 5376.
     In that case, numeric ports passed to zftp open will also need to
     be in this format.

ZFTP_SYSTEM
     Readonly.  The system type string returned by the server in
     response to an FTP SYST request.  The most interesting case is a
     string beginning "UNIX Type: L8", which ensures maximum
     compatibility with a local UNIX host.

ZFTP_TYPE
     Readonly.  The type to be used for data transfers , either `A' or
     `I'.   Use the type subcommand to change this.

ZFTP_USER
     Readonly.  The username currently logged in, if any.

ZFTP_ACCOUNT
     Readonly.  The account name of the current user, if any.  Most
     servers do not require an account name.

ZFTP_PWD
     Readonly.  The current directory on the server.

ZFTP_CODE
     Readonly.  The three digit code of the last FTP reply from the
     server as a string.  This can still be read after the connection
     is closed, and is not changed when the current session changes.

ZFTP_REPLY
     Readonly.  The last line of the last reply sent by the server.
     This can still be read after the connection is closed, and is not
     changed when the current session changes.

ZFTP_SESSION
     Readonly.  The name of the current FTP session; see the
     description of the session subcommand.

ZFTP_PREFS
     A string of preferences for altering aspects of zftp's behaviour.
     Each preference is a single character.  The following are defined:

    P
          Passive:  attempt to make the remote server initiate data
          transfers.  This is slightly more efficient than sendport
          mode.  If the letter S occurs later in the string, zftp will
          use sendport mode if passive mode is not available.

    S
          Sendport:  initiate transfers by the FTP PORT command.  If
          this occurs before any P in the string, passive mode will
          never be attempted.

    D
          Dumb:  use only the bare minimum of FTP commands.  This
          prevents the variables ZFTP_SYSTEM and ZFTP_PWD from being
          set, and will mean all connections default to ASCII type.  It
          may prevent ZFTP_SIZE from being set during a transfer if the
          server does not send it anyway (many servers do).

     If ZFTP_PREFS is not set when zftp is loaded, it will be set to a
     default of `PS', i.e. use passive mode if available, otherwise
     fall back to sendport mode.

ZFTP_VERBOSE
     A string of digits between 0 and 5 inclusive, specifying which
     responses from the server should be printed.  All responses go to
     standard error.  If any of the numbers 1 to 5 appear in the string,
     raw responses from the server with reply codes beginning with that
     digit will be printed to standard error.  The first digit of the
     three digit reply code is defined by RFC959 to correspond to:

    1.
          A positive preliminary reply.

    2.
          A positive completion reply.

    3.
          A positive intermediate reply.

    4.
          A transient negative completion reply.

    5.
          A permanent negative completion reply.

     It should be noted that, for unknown reasons, the reply `Service
     not available', which forces termination of a connection, is
     classified as 421, i.e. `transient negative', an interesting
     interpretation of the word `transient'.

     The code 0 is special:  it indicates that all but the last line of
     multiline replies read from the server will be printed to standard
     error in a processed format.  By convention, servers use this
     mechanism for sending information for the user to read.  The
     appropriate reply code, if it matches the same response, takes
     priority.

     If ZFTP_VERBOSE is not set when zftp is loaded, it will be set to
     the default value 450, i.e., messages destined for the user and
     all errors will be printed.  A null string is valid and specifies
     that no messages should be printed.

21.25.3 Functions
-----------------

zftp_chpwd
     If this function is set by the user, it is called every time the
     directory changes on the server, including when a user is logged
     in, or when a connection is closed.  In the last case, $ZFTP_PWD
     will be unset; otherwise it will reflect the new directory.

zftp_progress
     If this function is set by the user, it will be called during a
     get, put or append operation each time sufficient data has been
     received from the host.  During a get, the data is sent to
     standard output, so it is vital that this function should write to
     standard error or directly to the terminal, _not_ to standard
     output.

     When it is called with a transfer in progress, the following
     additional shell parameters are set:

    ZFTP_FILE
          The name of the remote file being transferred from or to.

    ZFTP_TRANSFER
          A G for a get operation and a P for a put operation.

    ZFTP_SIZE
          The total size of the complete file being transferred: the
          same as the first value provided by the remote and local
          subcommands for a particular file.  If the server cannot
          supply this value for a remote file being retrieved, it will
          not be set.  If input is from a pipe the value may be
          incorrect and correspond simply to a full pipe buffer.

    ZFTP_COUNT
          The amount of data so far transferred; a number between zero
          and $ZFTP_SIZE, if that is set.  This number is always
          available.

     The function is initially called with ZFTP_TRANSFER set
     appropriately and ZFTP_COUNT set to zero.  After the transfer is
     finished, the function will be called one more time with
     ZFTP_TRANSFER set to GF or PF, in case it wishes to tidy up.  It
     is otherwise never called twice with the same value of ZFTP_COUNT.

     Sometimes the progress meter may cause disruption.  It is up to the
     user to decide whether the function should be defined and to use
     unfunction when necessary.

21.25.4 Problems
----------------

A connection may not be opened in the left hand side of a pipe as this
occurs in a subshell and the file information is not updated in the main
shell.  In the case of type or mode changes or closing the connection
in a subshell, the information is returned but variables are not
updated until the next call to zftp.  Other status changes in subshells
will not be reflected by changes to the variables (but should be
otherwise harmless).

Deleting sessions while a zftp command is active in the background can
have unexpected effects, even if it does not use the session being
deleted.  This is because all shell subprocesses share information on
the state of all connections, and deleting a session changes the
ordering of that information.

On some operating systems, the control connection is not valid after a
fork(), so that operations in subshells, on the left hand side of a
pipeline, or in the background are not possible, as they should be.
This is presumably a bug in the operating system.

21.26 The zsh/zle Module
========================

   The zsh/zle module contains the Zsh Line Editor.  See Zsh Line Editor.

21.27 The zsh/zleparameter Module
=================================

   The zsh/zleparameter module defines two special parameters that can
be used to access internal information of the Zsh Line Editor (see
Zsh Line Editor).

keymaps
     This array contains the names of the keymaps currently defined.

widgets
     This associative array contains one entry per widget defined. The
     name of the widget is the key and the value gives information
     about the widget. It is either the string `builtin' for builtin
     widgets, a string of the form `user:NAME' for user-defined widgets,
     where NAME is the name of the shell function implementing the
     widget, or it is a string of the form `completion:TYPE:NAME', for
     completion widgets. In the last case TYPE is the name of the
     builtin widgets the completion widget imitates in its behavior and
     NAME is the name of the shell function implementing the completion
     widget.

21.28 The zsh/zprof Module
==========================

   When loaded, the zsh/zprof causes shell functions to be profiled.
The profiling results can be obtained with the zprof builtin command
made available by this module.  There is no way to turn profiling off
other than unloading the module.

zprof [ -c ]
     Without the -c option, zprof lists profiling results to standard
     output.  The format is comparable to that of commands like gprof.

     At the top there is a summary listing all functions that were
     called at least once.  This summary is sorted in decreasing order
     of the amount of time spent in each.  The lines contain the number
     of the function in order, which is used in other parts of the list
     in suffixes of the form `[NUM]', then the number of calls made to
     the function.  The next three columns list the time in
     milliseconds spent in the function and its descendents, the average
     time in milliseconds spent in the function and its descendents per
     call and the percentage of time spent in all shell functions used
     in this function and its descendents.  The following three columns
     give the same information, but counting only the time spent in the
     function itself.  The final column shows the name of the function.

     After the summary, detailed information about every function that
     was invoked is listed, sorted in decreasing order of the amount of
     time spent in each function and its descendents.  Each of these
     entries consists of descriptions for the functions that called the
     function described, the function itself, and the functions that
     were called from it.  The description for the function itself has
     the same format as in the summary (and shows the same
     information).  The other lines don't show the number of the
     function at the beginning and have their function named indented to
     make it easier to distinguish the line showing the function
     described in the section from the surrounding lines.

     The information shown in this case is almost the same as in the
     summary, but only refers to the call hierarchy being displayed.
     For example, for a calling function the column showing the total
     running time lists the time spent in the described function and
     its descendents only for the times when it was called from that
     particular calling function.  Likewise, for a called function,
     this columns lists the total time spent in the called function and
     its descendents only for the times when it was called from the
     function described.

     Also in this case, the column showing the number of calls to a
     function also shows a slash and then the total number of
     invocations made to the called function.

     As long as the zsh/zprof module is loaded, profiling will be done
     and multiple invocations of the zprof builtin command will show the
     times and numbers of calls since the module was loaded.  With the
     -c option, the zprof builtin command will reset its internal
     counters and will not show the listing.  )

21.29 The zsh/zpty Module
=========================

   The zsh/zpty module offers one builtin:

zpty [ -e ] [ -b ] NAME [ ARG ... ]
     The arguments following NAME are concatenated with spaces between,
     then executed as a command, as if passed to the eval builtin.  The
     command runs under a newly assigned pseudo-terminal; this is
     useful for running commands non-interactively which expect an
     interactive environment.  The NAME is not part of the command, but
     is used to refer to this command in later calls to zpty.

     With the -e option, the pseudo-terminal is set up so that input
     characters are echoed.

     With the -b option, input to and output from the pseudo-terminal
     are made non-blocking.

zpty -d [ NAMES ... ]
     The second form, with the -d option, is used to delete commands
     previously started, by supplying a list of their NAMEs.  If no
     NAMES are given, all commands are deleted.  Deleting a command
     causes the HUP signal to be sent to the corresponding process.

zpty -w [ -n ] NAME [ STRINGS ... ]
     The -w option can be used to send the to command NAME the given
     STRINGS as input (separated by spaces).  If the -n option is _not_
     given, a newline is added at the end.

     If no STRINGS are provided, the standard input is copied to the
     pseudo-terminal; this may stop before copying the full input if the
     pseudo-terminal is non-blocking.

     Note that the command under the pseudo-terminal sees this input as
     if it were typed, so beware when sending special tty driver
     characters such as word-erase, line-kill, and end-of-file.

zpty -r [ -t ] NAME [ PARAM [ PATTERN ] ]
     The -r option can be used to read the output of the command NAME.
     With only a NAME argument, the output read is copied to the
     standard output.  Unless the pseudo-terminal is non-blocking,
     copying continues until the command under the pseudo-terminal
     exits; when non-blocking, only as much output as is immediately
     available is copied.  The return value is zero if any output is
     copied.

     When also given a PARAM argument, at most one line is read and
     stored in the parameter named PARAM.  Less than a full line may be
     read if the pseudo-terminal is non-blocking.  The return value is
     zero if at least one character is stored in PARAM.

     If a PATTERN is given as well, output is read until the whole
     string read matches the PATTERN, even in the non-blocking case.
     The return value is zero if the string read matches the pattern,
     or if the command has exited but at least one character could
     still be read.  As of this writing, a maximum of one megabyte of
     output can be consumed this way; if a full megabyte is read
     without matching the pattern, the return value is non-zero.

     In all cases, the return value is non-zero if nothing could be
     read, and is 2 if this is because the command has finished.

     If the -r option is combined with the -t option, zpty tests
     whether output is available before trying to read.  If no output is
     available, zpty immediately returns the value 1.

zpty -t NAME
     The -t option without the -r option can be used to test whether
     the command NAME is still running.  It returns a zero value if the
     command is running and a non-zero value otherwise.

zpty [ -L ]
     The last form, without any arguments, is used to list the commands
     currently defined.  If the -L option is given, this is done in the
     form of calls to the zpty builtin.

21.30 The zsh/zselect Module
============================

   The zsh/zselect module makes available one builtin command:

zselect [ -rwe -t TIMEOUT -a ARRAY ] [ FD ... ]
     The zselect builtin is a front-end to the `select' system call,
     which blocks until a file descriptor is ready for reading or
     writing, or has an error condition, with an optional timeout.  If
     this is not available on your system, the command prints an error
     message and returns status 2 (normal errors return status 1).  For
     more information, see your systems documentation for man page
     select(3).  Note there is no connection with the shell builtin of
     the same name.

     Arguments and options may be intermingled in any order.  Non-option
     arguments are file descriptors, which must be decimal integers.  By
     default, file descriptors are to be tested for reading, i.e.
     zselect will return when data is available to be read from the
     file descriptor, or more precisely, when a read operation from the
     file descriptor will not block.  After a -r, -w and -e, the given
     file descriptors are to be tested for reading, writing, or error
     conditions.  These options and an arbitrary list of file
     descriptors may be given in any order.

     (The presence of an `error condition' is not well defined in the
     documentation for many implementations of the select system call.
     According to recent versions of the POSIX specification, it is
     really an _exception_ condition, of which the only standard
     example is out-of-band data received on a socket.  So zsh users
     are unlikely to find the -e option useful.)

     The option `-t TIMEOUT' specifies a timeout in hundredths of a
     second.  This may be zero, in which case the file descriptors will
     simply be polled and zselect will return immediately.  It is
     possible to call zselect with no file descriptors and a non-zero
     timeout for use as a finer-grained replacement for `sleep'; not,
     however, the return status is always 1 for a timeout.

     The option `-a ARRAY' indicates that array should be set to
     indicate the file descriptor(s) which are ready.  If the option is
     not given, the array reply will be used for this purpose.  The
     array will contain a string similar to the arguments for zselect.
     For example,

          zselect -t 0 -r 0 -w 1

     might return immediately with status 0 and $reply containing `-r 0
     -w 1' to show that both file descriptors are ready for the
     requested operations.

     The option `-A ASSOC' indicates that the associative array assoc
     should be set to indicate the file descriptor(s) which are ready.
     This option overrides the option -a, nor will reply be modified.
     The keys of assoc are the file descriptors, and the corresponding
     values are any of the characters `rwe' to indicate the condition.

     The command returns 0 if some file descriptors are ready for
     reading.  If the operation timed out, or a timeout of 0 was given
     and no file descriptors were ready, or there was an error, it
     returns status 1 and the array will not be set (nor modified in
     any way).  If there was an error in the select operation the
     appropriate error message is printed.

21.31 The zsh/zutil Module
==========================

   The zsh/zutil module only adds some builtins:

zstyle [ -L ]
zstyle [ -e | - | -- ] PATTERN STYLE STRINGS ...
zstyle -d [ PATTERN [ STYLES ... ] ]
zstyle -g NAME [ PATTERN [ STYLE ] ]
zstyle -abs CONTEXT STYLE NAME [ SEP ]
zstyle -Tt CONTEXT STYLE [ STRINGS ...]
zstyle -m CONTEXT STYLE PATTERN
     This builtin command is used to define and lookup styles.  Styles
     are pairs of names and values, where the values consist of any
     number of strings.  They are stored together with patterns and
     lookup is done by giving a string, called the `context', which is
     compared to the patterns.  The definition stored for the first
     matching pattern will be returned.

     For ordering of comparisons, patterns are searched from most
     specific to least specific, and patterns that are equally specific
     keep the order in which they were defined.  A pattern is
     considered to be more specific than another if it contains more
     components (substrings separated by colons) or if the patterns for
     the components are more specific, where simple strings are
     considered to be more specific than patterns and complex patterns
     are considered to be more specific than the pattern `*'.

     The first form (without arguments) lists the definitions in the
     order zstyle will test them. If the -L option is given, listing is
     done in the form of calls to zstyle.  Forms with arguments:

    zstyle [ - | -- | -e ] PATTERN STYLE STRINGS ...
          Defines the given STYLE for the PATTERN with the STRINGS as
          the value.  If the -e option is given, the STRINGS will be
          concatenated (separated by spaces) and the resulting string
          will be evaluated (in the same way as it is done by the eval
          builtin command) when the style is looked up.  In this case
          the parameter `reply' must be assigned to set the strings
          returned after the evaluation.  Before evaluating the value,
          reply is unset, and if it is still unset after the
          evaluation, the style is treated as if it were not set.

    zstyle -d [ PATTERN [ STYLES ... ] ]
          Delete style definitions. Without arguments all definitions
          are deleted, with a PATTERN all definitions for that pattern
          are deleted and if any STYLES are given, then only those
          styles are deleted for the PATTERN.

    zstyle -g NAME [ PATTERN [ STYLE ] ]
          Retrieve a style definition. The NAME is used as the name of
          an array in which the results are stored. Without any further
          arguments, all PATTERNS defined are returned. With a PATTERN
          the styles defined for that pattern are returned and with
          both a PATTERN and a STYLE, the value strings of that
          combination is returned.

     The other forms can be used to look up or test patterns.

    zstyle -s CONTEXT STYLE NAME [ SEP ]
          The parameter NAME is set to the value of the style
          interpreted as a string.  If the value contains several
          strings they are concatenated with spaces (or with the SEP
          string if that is given) between them.

    zstyle -b CONTEXT STYLE NAME
          The value is stored in NAME as a boolean, i.e. as the string
          `yes' if the value has only one string and that string is
          equal to one of `yes', `true', `on', or `1'. If the value is
          any other string or has more than one string, the parameter
          is set to `no'.

    zstyle -a CONTEXT STYLE NAME
          The value is stored in NAME as an array. If NAME is declared
          as an associative array,  the first, third, etc. strings are
          used as the keys and the other strings are used as the values.

    zstyle -t CONTEXT STYLE [ STRINGS ...]
    zstyle -T CONTEXT STYLE [ STRINGS ...]
          Test the value of a style, i.e. the -t option only returns a
          status (sets $?).  Without any STRINGS the return status is
          zero if the style is defined for at least one matching
          pattern, has only one string in its value, and that is equal
          to one of `true', `yes', `on' or `1'. If any STRINGS are
          given the status is zero if and only if at least one of the
          STRINGS is equal to at least one of the strings in the value.
          If the style is not defined, the status is 2.

          The -T option tests the values of the style like -t, but it
          returns zero (rather than 2) if the style is not defined for
          any matching pattern.

    zstyle -m CONTEXT STYLE PATTERN
          Match a value. Returns status zero if the PATTERN matches at
          least one of the strings in the value.

zformat -f PARAM FORMAT SPECS ...
zformat -a ARRAY SEP SPECS ...
     This builtin provides two different forms of formatting. The first
     form is selected with the -f option. In this case the FORMAT
     string will be modified by replacing sequences starting with a
     percent sign in it with strings from the SPECS.  Each SPEC should
     be of the form `CHAR:STRING' which will cause every appearance of
     the sequence `%CHAR' in FORMAT to be replaced by the STRING.  The
     `%' sequence may also contain optional minimum and maximum field
     width specifications between the `%' and the `CHAR' in the form
     `%MIN.MAXc', i.e. the minimum field width is given first and if
     the maximum field width is used, it has to be preceded by a dot.
     Specifying a minimum field width makes the result be padded with
     spaces to the right if the STRING is shorter than the requested
     width.  Padding to the left can be achieved by giving a negative
     minimum field width.  If a maximum field width is specified, the
     STRING will be truncated after that many characters.  After all
     `%' sequences for the given SPECS have been processed, the
     resulting string is stored in the parameter PARAM.

     The %-escapes also understand ternary expressions in the form used
     by prompts.  The % is followed by a `(' and then an ordinary
     format specifier character as described above.  There may be a set
     of digits either before or after the `('; these specify a test
     number, which defaults to zero.  Negative numbers are also
     allowed.  An arbitrary delimiter character follows the format
     specifier, which is followed by a piece of `true' text, the
     delimiter character again, a piece of `false' text, and a closing
     parenthesis.  The complete expression (without the digits) thus
     looks like `%(X.TEXT1.TEXT2)', except that the `.' character is
     arbitrary.  The value given for the format specifier in the
     CHAR:STRING expressions is evaluated as a mathematical expression,
     and compared with the test number.  If they are the same, TEXT1 is
     output, else TEXT2 is output.  A parenthesis may be escaped in
     TEXT2 as %).  Either of TEXT1 or TEXT2 may contain nested
     %-escapes.

     For example:

          zformat -f REPLY "The answer is '%3(c.yes.no)'." c:3

     outputs "The answer is 'yes'." to REPLY since the value for the
     format specifier c is 3, agreeing with the digit argument to the
     ternary expression.

     The second form, using the -a option, can be used for aligning
     strings.  Here, the SPECS are of the form `LEFT:RIGHT' where
     `LEFT' and `RIGHT' are arbitrary strings.  These strings are
     modified by replacing the colons by the SEP string and padding the
     LEFT strings with spaces to the right so that the SEP strings in
     the result (and hence the RIGHT strings after them) are all
     aligned if the strings are printed below each other.  All strings
     without a colon are left unchanged and all strings with an empty
     RIGHT string have the trailing colon removed.  In both cases the
     lengths of the strings are not used to determine how the other
     strings are to be aligned.  The resulting strings are stored in
     the ARRAY.

zregexparse
     This implements some internals of the _regex_arguments function.

zparseopts [ -D ] [ -K ] [ -E ] [ -a ARRAY ] [ -A ASSOC ] SPECS
     This builtin simplifies the parsing of options in positional
     parameters, i.e. the set of arguments given by $*.  Each SPEC
     describes one option and must be of the form `OPT[=ARRAY]'.  If an
     option described by OPT is found in the positional parameters it
     is copied into the ARRAY specified with the -a option; if the
     optional `=ARRAY' is given, it is instead copied into that array.

     Note that it is an error to give any SPEC without an `=ARRAY'
     unless one of the -a or -A options is used.

     Unless the -E option is given, parsing stops at the first string
     that isn't described by one of the SPECS.  Even with -E, parsing
     always stops at a positional parameter equal to `-' or `--'.

     The OPT description must be one of the following.  Any of the
     special characters can appear in the option name provided it is
     preceded by a backslash.

    NAME
    NAME+
          The NAME is the name of the option without the leading `-'.
          To specify a GNU-style long option, one of the usual two
          leading `-' must be included in NAME; for example, a `-file'
          option is represented by a NAME of `-file'.

          If a `+' appears after NAME, the option is appended to ARRAY
          each time it is found in the positional parameters; without
          the `+' only the _last_ occurrence of the option is preserved.

          If one of these forms is used, the option takes no argument,
          so parsing stops if the next positional parameter does not
          also begin with `-' (unless the -E option is used).

    NAME:
    NAME:-
    NAME::
          If one or two colons are given, the option takes an argument;
          with one colon, the argument is mandatory and with two colons
          it is optional.  The argument is appended to the ARRAY after
          the option itself.

          An optional argument is put into the same array element as
          the option name (note that this makes empty strings as
          arguments indistinguishable).  A mandatory argument is added
          as a separate element unless the `:-' form is used, in which
          case the argument is put into the same element.

          A `+' as described above may appear between the NAME and the
          first colon.

     The options of zparseopts itself are:

    -a ARRAY
          As described above, this names the default array in which to
          store the recognised options.

    -A ASSOC
          If this is given, the options and their values are also put
          into an associative array with the option names as keys and
          the arguments (if any) as the values.

    -D
          If this option is given, all options found are removed from
          the positional parameters of the calling shell or shell
          function, up to but not including any not described by the
          SPECS.  This is similar to using the shift builtin.

    -K
          With this option, the arrays specified with the -a and -A
          options and with the `=ARRAY' forms are kept unchanged when
          none of the SPECS for them is used.  This allows assignment
          of default values to them before calling zparseopts.

    -E
          This changes the parsing rules to _not_ stop at the first
          string that isn't described by one of the SPECs.  It can be
          used to test for or (if used together with -D) extract
          options and their arguments, ignoring all other options and
          arguments that may be in the positional parameters.

     For example,

          set -- -a -bx -c y -cz baz -cend
          zparseopts a=foo b:=bar c+:=bar

     will have the effect of

          foo=(-a)
          bar=(-b x -c y -c z)

     The arguments from `baz' on will not be used.

     As an example for the -E option, consider:

          set -- -a x -b y -c z arg1 arg2
          zparseopts -E -D b:=bar

     will have the effect of

          bar=(-b y)
          set -- -a x -c z arg1 arg2

     I.e., the option -b and its arguments are taken from the
     positional parameters and put into the array bar.

22 TCP Function System
**********************

22.1 Description
================

A module zsh/net/tcp is provided to provide network I/O over TCP/IP
from within the shell; see its description in Zsh Modules .
This manual page describes a function suite based on the module.  If
the module is installed, the functions are usually installed at the
same time, in which case they will be available for autoloading in the
default function search path.  In addition to the zsh/net/tcp module,
the zsh/zselect module is used to implement timeouts on read
operations.  For troubleshooting tips, consult the corresponding advice
for the zftp functions described in Zftp Function System .

There are functions corresponding to the basic I/O operations open,
close, read and send, named tcp_open etc., as well as a function
tcp_expect for pattern match analysis of data read as input.  The
system makes it easy to receive data from and send data to multiple
named sessions at once.  In addition, it can be linked with the shell's
line editor in such a way that input data is automatically shown at the
terminal.  Other facilities available including logging, filtering and
configurable output prompts.

To use the system where it is available, it should be enough to
`autoload -U tcp_open' and run tcp_open as documented below to start a
session.  The tcp_open function will autoload the remaining functions.

22.2 TCP User Functions
=======================

22.2.1 Basic I/O
----------------

tcp_open [-qz] HOST PORT [ SESS ]
tcp_open [-qz] [ -s SESS | -l SESS,... ] ...
tcp_open [-qz] [-a FD | -f FD ] [ SESS ]
     Open a new session.  In the first and simplest form, open a TCP
     connection to host HOST at port PORT; numeric and symbolic forms
     are understood for both.

     If SESS is given, this becomes the name of the session which can be
     used to refer to multiple different TCP connections.  If SESS is
     not given, the function will invent a numeric name value (note
     this is _not_ the same as the file descriptor to which the session
     is attached).  It is recommended that session names not include
     `funny' characters, where funny characters are not well-defined
     but certainly do not include alphanumerics or underscores, and
     certainly do include whitespace.

     In the second case, one or more sessions to be opened are given by
     name.  A single session name is given after -s and a
     comma-separated list after -l; both options may be repeated as
     many times as necessary.  The host and port are read from the file
     .ztcp_sessions in the same directory as the user's zsh
     initialisation files, i.e. usually the home directory, but
     $ZDOTDIR if that is set.  The file consists of lines each giving a
     session name and the corresponding host and port, in that order
     (note the session name comes first, not last), separated by
     whitespace.

     The third form allows passive and fake TCP connections.  If the
     option -a is used, its argument is a file descriptor open for
     listening for connections.  No function front-end is provided to
     open such a file descriptor, but a call to `ztcp -l PORT' will
     create one with the file descriptor stored in the parameter
     $REPLY.  The listening port can be closed with `ztcp -c FD'.  A
     call to `tcp_open -a FD' will block until a remote TCP connection
     is made to PORT on the local machine.  At this point, a session is
     created in the usual way and is largely indistinguishable from an
     active connection created with one of the first two forms.

     If the option -f is used, its argument is a file descriptor which
     is used directly as if it were a TCP session.  How well the
     remainder of the TCP function system copes with this depends on
     what actually underlies this file descriptor.  A regular file is
     likely to be unusable; a FIFO (pipe) of some sort will work
     better, but note that it is not a good idea for two different
     sessions to attempt to read from the same FIFO at once.

     If the option -q is given with any of the three forms, tcp_open
     will not print informational messages, although it will in any
     case exit with an appropriate status.

     If the line editor (zle) is in use, which is typically the case if
     the shell is interactive, tcp_open installs a handler inside zle
     which will check for new data at the same time as it checks for
     keyboard input.  This is convenient as the shell consumes no CPU
     time while waiting; the test is performed by the operating system.
     Giving the option -z to any of the forms of tcp_open prevents the
     handler from being installed, so data must be read explicitly.
     Note, however, this is not necessary for executing complete sets
     of send and read commands from a function, as zle is not active at
     this point.  Generally speaking, the handler is only active when
     the shell is waiting for input at a command prompt or in the vared
     builtin.  The option has no effect if zle is not active; `[[ -o
     zle]]' will test for this.

     The first session to be opened becomes the current session and
     subsequent calls to tcp_open do not change it.  The current
     session is stored in the parameter $TCP_SESS; see below for more
     detail about the parameters used by the system.

tcp_close [-qn] [ -a | -l SESS,... | SESS ... ]
     Close the named sessions, or the current session if none is given,
     or all open sessions if -a is given.  The options -l and -s are
     both handled for consistency with tcp_open, although the latter is
     redundant.

     If the session being closed is the current one, $TCP_SESS is unset,
     leaving no current session, even if there are other sessions still
     open.

     If the session was opened with tcp_open -f, the file descriptor is
     closed so long as it is in the range 0 to 9 accessible directly
     from the command line.  If the option -n is given, no attempt will
     be made to close file descriptors in this case.  The -n option is
     not used for genuine ztcp session; the file descriptors are always
     closed with the session.

     If the option -q is given, no informational messages will be
     printed.

tcp_read [-bdq] [ -t TO ] [ -T TO ]
[ -a | -u FD ... | -l SESS,... | -s SESS ...]
     Perform a read operation on the current session, or on a list of
     sessions if any are given with -u, -l or -s, or all open sessions
     if the option -a is given.  Any of the -u, -l or -s options may be
     repeated or mixed together.  The -u option specifies a file
     descriptor directly (only those managed by this system are
     useful), the other two specify sessions as described for tcp_open
     above.

     The function checks for new data available on all the sessions
     listed.  Unless the -b option is given, it will not block waiting
     for new data.  Any one line of data from any of the available
     sessions will be read, stored in the parameter $TCP_LINE, and
     displayed to standard output unless $TCP_SILENT contains a
     non-empty string.  When printed to standard output the string
     $TCP_PROMPT will be shown at the start of the line; the default
     form for this includes the name of the session being read.  See
     below for more information on these parameters.  In this mode,
     tcp_read can be called repeatedly until it returns status 2 which
     indicates all pending input from all specified sessions has been
     handled.

     With the option -b, equivalent to an infinite timeout, the function
     will block until a line is available to read from one of the
     specified sessions.  However, only a single line is returned.

     The option -d indicates that all pending input should be drained.
     In this case tcp_read may process multiple lines in the manner
     given above; only the last is stored in $TCP_LINE, but the
     complete set is stored in the array $tcp_lines.  This is cleared
     at the start of each call to tcp_read.

     The options -t and -T specify a timeout in seconds, which may be a
     floating point number for increased accuracy.  With -t the timeout
     is applied before each line read.  With -T, the timeout applies to
     the overall operation, possibly including multiple read operations
     if the option -d is present; without this option, there is no
     distinction between -t and -T.

     The function does not print informational messages, but if the
     option -q is given, no error message is printed for a non-existent
     session.

     A return value of 2 indicates a timeout or no data to read.  Any
     other non-zero return value indicates some error condition.

     See tcp_log for how to control where data is sent by tcp_read.

tcp_send [-nq] [ -s SESS | -l SESS,... ] DATA ...
tcp_send [-nq] -a DATA ...
     Send the supplied data strings to all the specified sessions in
     turn.  The underlying operation differs little from a `print -r'
     to the session's file descriptor, although it attempts to prevent
     the shell from dying owing to a SIGPIPE caused by an attempt to
     write to a defunct session.

     The option -n prevents tcp_send from putting a newline at the end
     of the data strings.

     The remaining options all behave as for tcp_read.

     The data arguments are not further processed once they have been
     passed to tcp_send; they are simply passed down to print -r.

     If the parameter $TCP_OUTPUT is a non-empty string and logging is
     enabled then the data sent to each session will be echoed to the
     log file(s) with $TCP_OUTPUT in front where appropriate, much in
     the manner of $TCP_PROMPT.

22.2.2 Session Management
-------------------------

tcp_alias [-q] ALIAS=SESS ...
tcp_alias [-q] [ ALIAS ] ...
tcp_alias -d [-q] ALIAS ...
     This function is not particularly well tested.

     The first form creates an alias for a session name; ALIAS can then
     be used to refer to the existing session SESS.  As many aliases
     may be listed as required.

     The second form lists any aliases specified, or all aliases if
     none.

     The third form deletes all the aliases listed.  The underlying
     sessions are not affected.

     The option -q suppresses an inconsistently chosen subset of error
     messages.

tcp_log [-asc] [ -n | -N ] [ LOGFILE ]
     With an argument LOGFILE, all future input from tcp_read will be
     logged to the named file.  Unless -a (append) is given, this file
     will first be truncated or created empty.  With no arguments, show
     the current status of logging.

     With the option -s, per-session logging is enabled.  Input from
     tcp_read is output to the file LOGFILE.SESS.  As the session is
     automatically discriminated by the filename, the contents are raw
     (no $TCP_PROMPT).  The option  -a applies as above.  Per-session
     logging and logging of all data in one file are not mutually
     exclusive.

     The option -c closes all logging, both complete and per-session
     logs.

     The options -n and -N respectively turn off or restore output of
     data read by tcp_read to standard output; hence `tcp_log -cn' turns
     off all output by tcp_read.

     The function is purely a convenient front end to setting the
     parameters $TCP_LOG, $TCP_LOG_SESS, $TCP_SILENT, which are
     described below.

tcp_rename OLD NEW
     Rename session OLD to session NEW.  The old name becomes invalid.

tcp_sess [ SESS [ COMMAND  ... ] ]
     With no arguments, list all the open sessions and associated file
     descriptors.  The current session is marked with a star.  For use
     in functions, direct access to the parameters $tcp_by_name,
     $tcp_by_fd and $TCP_SESS is probably more convenient; see below.

     With a SESS argument, set the current session to SESS.  This is
     equivalent to changing $TCP_SESS directly.

     With additional arguments, temporarily set the current session
     while executing the string command ....  The first argument is
     re-evaluated so as to expand aliases etc., but the remaining
     arguments are passed through as the appear to tcp_sess.  The
     original session is restored when tcp_sess exits.

22.2.3 Advanced I/O
-------------------

tcp_command SEND-OPTIONS ... SEND-ARGUMENTS ...
     This is a convenient front-end to tcp_send.  All arguments are
     passed to tcp_send, then the function pauses waiting for data.
     While data is arriving at least every $TCP_TIMEOUT (default 0.3)
     seconds, data is handled and printed out according to the current
     settings.  Status 0 is always returned.

     This is generally only useful for interactive use, to prevent the
     display becoming fragmented by output returned from the
     connection.  Within a programme or function it is generally better
     to handle reading data by a more explicit method.

tcp_expect [ -q ] [ -p VAR ] [ -t  TO | -T TO]
    [ -a | -s SESS ... | -l SESS,... ] PATTERN ...
     Wait for input matching any of the given PATTERNs from any of the
     specified sessions.  Input is ignored until an input line matches
     one of the given patterns; at this point status zero is returned,
     the matching line is stored in $TCP_LINE, and the full set of
     lines read during the call to tcp_expect is stored in the array
     $tcp_expect_lines.

     Sessions are specified in the same way as tcp_read: the default is
     to use the current session, otherwise the sessions specified by -a,
     -s, or -l are used.

     Each PATTERN is a standard zsh extended-globbing pattern; note
     that it needs to be quoted to avoid it being expanded immediately
     by filename generation.  It must match the full line, so to match
     a substring there must be a `*' at the start and end.  The line
     matched against includes the $TCP_PROMPT added by tcp_read.  It is
     possible to include the globbing flags `#b' or `#m' in the
     patterns to make backreferences available in the parameters
     $MATCH, $match, etc., as described in the base zsh documentation
     on pattern matching.

     Unlike tcp_read, the default behaviour of tcp_expect is to block
     indefinitely until the required input is found.  This can be
     modified by specifying a timeout with -t or -T; these function as
     in tcp_read, specifying a per-read or overall timeout,
     respectively, in seconds, as an integer or floating-point number.
     As tcp_read, the function returns status 2 if a timeout occurs.

     The function returns as soon as any one of the patterns given
     match.  If the caller needs to know which of the patterns matched,
     the option -p VAR can be used; on return, $var is set to the
     number of the pattern using ordinary zsh indexing, i.e. the first
     is 1, and so on.  Note the absence of a `$' in front of VAR.  To
     avoid clashes, the parameter cannot begin with `_expect'.

     The option -q is passed directly down to tcp_read.

     As all input is done via tcp_read, all the usual rules about
     output of lines read apply.  One exception is that the parameter
     $tcp_lines will only reflect the line actually matched by
     tcp_expect; use $tcp_expect_lines for the full set of lines read
     during the function call.

tcp_proxy
     This is a simple-minded function to accept a TCP connection and
     execute a command with I/O redirected to the connection.  Extreme
     caution should be taken as there is no security whatsoever and
     this can leave your computer open to the world.  Ideally, it
     should only be used behind a firewall.

     The first argument is a TCP port on which the function will listen.

     The remaining arguments give a command and its arguments to
     execute with standard input, standard output and standard error
     redirected to the file descriptor on which the TCP session has
     been accepted.  If no command is given, a new zsh is started.
     This gives everyone on your network direct access to your account,
     which in many cases will be a bad thing.

     The command is run in the background, so tcp_proxy can then accept
     new connections.  It continues to accept new connections until
     interrupted.

tcp_spam [-ertv] [ -a | -s  SESS | -l SESS,... ] CMD ...
     Execute `CMD ...' for each session in turn.  Note this executes
     the command and arguments; it does not send the command line as
     data unless the -t (transmit) option is given.

     The sessions may be selected explicitly with the standard -a, -s or
     -l options, or may be chosen implicitly.  If none of the three
     options is given the rules are: first, if the array $tcp_spam_list
     is set, this is taken as the list of sessions, otherwise all
     sessions are taken.  Second, any sessions given in the array
     $tcp_no_spam_list are removed from the list of sessions.

     Normally, any sessions added by the `-a' flag or when all sessions
     are chosen implicitly are spammed in alphabetic order; sessions
     given by the $tcp_spam_list array or on the command line are
     spammed in the order given.  The -r flag reverses the order
     however it was arrived it.

     The -v flag specifies that a $TCP_PROMPT will be output before each
     session.  This is output after any modification to TCP_SESS by the
     user-defined tcp_on_spam function described below.  (Obviously that
     function is able to generate its own output.)

     If the option -e is present, the line given as CMD ... is executed
     using eval, otherwise it is executed without any further
     processing.

tcp_talk
     This is a fairly simple-minded attempt to force input to the line
     editor to go straight to the default TCP_SESSION.

     An escape string, $TCP_TALK_ESCAPE, default `:', is used to allow
     access to normal shell operation.  If it is on its own at the
     start of the line, or followed only by whitespace, the line editor
     returns to normal operation.  Otherwise, the string and any
     following whitespace are skipped and the remainder of the line
     executed as shell input without any change of the line editor's
     operating mode.

     The current implementation is somewhat deficient in terms of use
     of the command history.  For this reason, many users will prefer
     to use some form of alternative approach for sending data easily
     to the current session.  One simple approach is to alias some
     special character (such as `%') to `tcp_command -'.

tcp_wait
     The sole argument is an integer or floating point number which
     gives the seconds to delay.  The shell will do nothing for that
     period except wait for input on all TCP sessions by calling
     tcp_read -a.  This is similar to the interactive behaviour at the
     command prompt when zle handlers are installed.

22.2.4 `One-shot' file transfer
-------------------------------

tcp_point PORT
tcp_shoot HOST PORT
     This pair of functions provide a simple way to transfer a file
     between two hosts within the shell.  Note, however, that bulk data
     transfer is currently done using cat.  tcp_point reads any data
     arriving at PORT and sends it to standard output; tcp_shoot
     connects to PORT on HOST and sends its standard input.  Any unused
     PORT may be used; the standard mechanism for picking a port is to
     think of a random four-digit number above 1024 until one works.

     To transfer a file from host woodcock to host springes, on
     springes:

          tcp_point 8091 >output_file

     and on woodcock:

          tcp_shoot springes 8091 <input_file

     As these two functions do not require tcp_open to set up a TCP
     connection first, they may need to be autoloaded separately.

22.3 TCP User-defined Functions
===============================

Certain functions, if defined by the user, will be called by the
function system in certain contexts.  This facility depends on the
module zsh/parameter, which is usually available in interactive shells
as the completion system depends on it.  None of the functions need be
defined; they simply provide convenient hooks when necessary.

Typically, these are called after the requested action has been taken,
so that the various parameters will reflect the new state.

tcp_on_alias ALIAS FD
     When an alias is defined, this function will be called with two
     arguments: the name of the alias, and the file descriptor of the
     corresponding session.

tcp_on_close SESS FD
     This is called with the name of a session being closed and the file
     descriptor which corresponded to that session.  Both will be
     invalid by the time the function is called.

tcp_on_open SESS FD
     This is called after a new session has been defined with the
     session name and file descriptor as arguments.

tcp_on_rename OLDSESS FD NEWSESS
     This is called after a session has been renamed with the three
     arguments old session name, file descriptor, new session name.

tcp_on_spam SESS COMMAND ...
     This is called once for each session spammed, just _before_ a
     command is executed for a session by tcp_spam.  The arguments are
     the session name followed by the command list to be executed.  If
     tcp_spam was called with the option -t, the first command will be
     tcp_send.

     This function is called after $TCP_SESS is set to reflect the
     session to be spammed, but before any use of it is made.  Hence it
     is possible to alter the value of $TCP_SESS within this function.
     For example, the session arguments to tcp_spam could include extra
     information to be stripped off and processed in tcp_on_spam.

     If the function sets the parameter $REPLY to `done', the command
     line is not executed; in addition, no prompt is printed for the -v
     option to tcp_spam.

tcp_on_unalias ALIAS FD
     This is called with the name of an alias and the corresponding
     session's file descriptor after an alias has been deleted.

22.4 TCP Utility Functions
==========================

The following functions are used by the TCP function system but will
rarely if ever need to be called directly.

tcp_fd_handler
     This is the function installed by tcp_open for handling input from
     within the line editor, if that is required.  It is in the format
     documented for the builtin `zle -F' in Zle Builtins .

     While active, the function sets the parameter TCP_HANDLER_ACTIVE
     to 1.  This allows shell code called internally (for example, by
     setting tcp_on_read) to tell if is being called when the shell is
     otherwise idle at the editor prompt.

tcp_output [ -q ] -P PROMPT -F FD -S SESS
     This function is used for both logging and handling output to
     standard output, from within tcp_read and (if $TCP_OUTPUT is set)
     tcp_send.

     The PROMPT to use is specified by -P; the default is the empty
     string.  It can contain:
    %c
          Expands to 1 if the session is the current session, otherwise
          0.  Used with ternary expresions such as `%(c.-.+)' to output
          `+' for the current session and `-' otherwise.

    %f
          Replaced by the session's file descriptor.

    %s
          Replaced by the session name.

    %%
          Replaced by a single `%'.

     The option -q suppresses output to standard output, but not to any
     log files which are configured.

     The -S and -F options are used to pass in the session name and file
     descriptor for possible replacement in the prompt.

22.5 TCP User Parameters
========================

Parameters follow the usual convention that uppercase is used for
scalars and integers, while lowercase is used for normal and
associative array.  It is always safe for user code to read these
parameters.  Some parameters may also be set; these are noted
explicitly.  Others are included in this group as they are set by the
function system for the user's benefit, i.e. setting them is typically
not useful but is benign.

It is often also useful to make settable parameters local to a function.
For example, `local TCP_SILENT=1' specifies that data read during the
function call will not be printed to standard output, regardless of the
setting outside the function.  Likewise, `local TCP_SESS=SESS' sets a
session for the duration of a function, and `local TCP_PROMPT='
specifies that no prompt is used for input during the function.

tcp_expect_lines
     Array.  The set of lines read during the last call to tcp_expect,
     including the last ($TCP_LINE).

tcp_filter
     Array. May be set directly.  A set of extended globbing patterns
     which, if matched in tcp_output, will cause the line not to be
     printed to standard output.  The patterns should be defined as
     described for the arguments to tcp_expect.  Output of line to log
     files is not affected.

TCP_HANDLER_ACTIVE
     Scalar.  Set to 1 within tcp_fd_handler to indicate to functions
     called recursively that they have been called during an editor
     session.  Otherwise unset.

TCP_LINE
     The last line read by tcp_read, and hence also tcp_expect.

TCP_LINE_FD
     The file descriptor from which $TCP_LINE was read.
     ${tcp_by_fd[$TCP_LINE_FD]} will give the corresponding session
     name.

tcp_lines
     Array. The set of lines read during the last call to tcp_read,
     including the last ($TCP_LINE).

TCP_LOG
     May be set directly, although it is also controlled by tcp_log.
     The name of a file to which output from all sessions will be sent.
     The output is proceeded by the usual $TCP_PROMPT.  If it is not an
     absolute path name, it will follow the user's current directory.

TCP_LOG_SESS
     May be set directly, although it is also controlled by tcp_log.
     The prefix for a set of files to which output from each session
     separately will be sent; the full filename is ${TCP_LOG_SESS}.SESS.
     Output to each file is raw; no prompt is added.  If it is not an
     absolute path name, it will follow the user's current directory.

tcp_no_spam_list
     Array.  May be set directly.  See tcp_spam for how this is used.

TCP_OUTPUT
     May be set directly.  If a non-empty string, any data sent to a
     session by tcp_send will be logged.  This parameter gives the
     prompt to be used in a file specified by $TCP_LOG but not in a
     file generated from $TCP_LOG_SESS.  The prompt string has the same
     format as TCP_PROMPT and the same rules for its use apply.

TCP_PROMPT
     May be set directly.  Used as the prefix for data read by tcp_read
     which is printed to standard output or to the log file given by
     $TCP_LOG, if any.  Any `%s', `%f' or `%%' occurring in the string
     will be replaced by the name of the session, the session's
     underlying file descriptor, or a single `%', respectively.  The
     expression `%c' expands to 1 if the session being read is the
     current session, else 0; this is most useful in ternary
     expressions such as `%(c.-.+)' which outputs `+' if the session is
     the current one, else `-'.

TCP_READ_DEBUG
     May be set directly.  If this has non-zero length, tcp_read will
     give some limited diagnostics about data being read.

TCP_SECONDS_START
     This value is created and initialised to zero by tcp_open.

     The functions tcp_read and tcp_expect use the shell's SECONDS
     parameter for their own timing purposes.  If that parameter is not
     of floating point type on entry to one of the functions, it will
     create a local parameter SECONDS which is floating point and set
     the parameter TCP_SECONDS_START to the previous value of $SECONDS.
     If the parameter is already floating point, it is used without a
     local copy being created and TCP_SECONDS_START is not set.  As the
     global value is zero, the shell elapsed time is guaranteed to be
     the sum of $SECONDS and $TCP_SECONDS_START.

     This can be avoided by setting SECONDS globally to a floating point
     value using `typeset -F SECONDS'; then the TCP functions will never
     make a local copy and never set TCP_SECONDS_START to a non-zero
     value.

TCP_SESS
     May be set directly.  The current session; must refer to one of the
     sessions established by tcp_open.

TCP_SILENT
     May be set directly, although it is also controlled by tcp_log.
     If of non-zero length, data read by tcp_read will not be written to
     standard output, though may still be written to a log file.

tcp_spam_list
     Array.  May be set directly.  See the description of the function
     tcp_spam for how this is used.

TCP_TALK_ESCAPE
     May be set directly.  See the description of the function tcp_talk
     for how this is used.

TCP_TIMEOUT
     May be set directly.  Currently this is only used by the function
     tcp_command, see above.

22.6 TCP User-defined Parameters
================================

The following parameters are not set by the function system, but have a
special effect if set by the user.

tcp_on_read
     This should be an associative array; if it is not, the behaviour is
     undefined.  Each key is the name of a shell function or other
     command, and the corresponding value is a shell pattern (using
     EXTENDED_GLOB).  Every line read from a TCP session directly or
     indirectly using tcp_read (which includes lines read by
     tcp_expect) is compared against the pattern.  If the line matches,
     the command given in the key is called with two arguments: the
     name of the session from which the line was read, and the line
     itself.

     If any function called to handle a line returns a non-zero status,
     the line is not output.  Thus a tcp_on_read handler containing only
     the instruction `return 1' can be used to suppress output of
     particular lines (see, however, tcp_filter above).  However, the
     line is still stored in TCP_LINE and tcp_lines; this occurs after
     all tcp_on_read processing.

22.7 TCP Utility Parameters
===========================

These parameters are controlled by the function system; they may be read
directly, but should not usually be set by user code.

tcp_aliases
     Associative array.  The keys are the names of sessions established
     with tcp_open; each value is a space-separated list of aliases
     which refer to that session.

tcp_by_fd
     Associative array.  The keys are session file descriptors; each
     value is the name of that session.

tcp_by_name
     Associative array.  The keys are the names of sessions; each value
     is the file descriptor associated with that session.

22.8 TCP Examples
=================

Here is a trivial example using a remote calculator.

TO create a calculator server on port 7337 (see the dc manual page for
quite how infuriating the underlying command is):

     tcp_proxy 7337 dc

To connect to this from the same host with a session also named `dc':

     tcp_open localhost 7337 dc

To send a command to the remote session and wait a short while for
output (assuming dc is the current session):

     tcp_command 2 4 + p

To close the session:

     tcp_close

The tcp_proxy needs to be killed to be stopped.  Note this will not
usually kill any connections which have already been accepted, and also
that the port is not immediately available for reuse.

The following chunk of code puts a list of sessions into an xterm
header, with the current session followed by a star.

     print -n "\033]2;TCP:" ${(k)tcp_by_name:/$TCP_SESS/$TCP_SESS\*} "\a"

22.9 TCP Bugs
=============

The function tcp_read uses the shell's normal read builtin.  As this
reads a complete line at once, data arriving without a terminating
newline can cause the function to block indefinitely.

Though the function suite works well for interactive use and for data
arriving in small amounts, the performance when large amounts of data
are being exchanged is likely to be extremely poor.

23 Zftp Function System
***********************

23.1 Description
================

This describes the set of shell functions supplied with the source
distribution as an interface to the zftp builtin command, allowing you
to perform FTP operations from the shell command line or within
functions or scripts.  The interface is similar to a traditional FTP
client (e.g. the ftp command itself, see man page ftp(1)), but as it is
entirely done within the shell all the familiar completion, editing and
globbing features, and so on, are present, and macros are particularly
simple to write as they are just ordinary shell functions.

The prerequisite is that the zftp command, as described in The zsh/zftp Module
, must be available in the version of zsh installed
at your site.  If the shell is configured to load new commands at run
time, it probably is: typing `zmodload zsh/zftp' will make sure (if
that runs silently, it has worked).  If this is not the case, it is
possible zftp was linked into the shell anyway: to test this, type
`which zftp' and if zftp is available you will get the message `zftp:
shell built-in command'.

Commands given directly with zftp builtin may be interspersed between
the functions in this suite; in a few cases, using zftp directly may
cause some of the status information stored in shell parameters to
become invalid.  Note in particular the description of the variables
$ZFTP_TMOUT, $ZFTP_PREFS and $ZFTP_VERBOSE for zftp.

23.2 Installation
=================

You should make sure all the functions from the Functions/Zftp
directory of the source distribution are available; they all begin with
the two letters `zf'.  They may already have been installed on your
system; otherwise, you will need to find them and copy them.  The
directory should appear as one of the elements of the $fpath array
(this should already be the case if they were installed), and at least
the function zfinit should be autoloaded; it will autoload the rest.
Finally, to initialize the use of the system you need to call the
zfinit function.  The following code in your .zshrc will arrange for
this; assume the functions are stored in the directory ~/myfns:

     fpath=(~/myfns $fpath)
     autoload -U zfinit
     zfinit

Note that zfinit assumes you are using the zmodload method to load the
zftp command.  If it is already built into the shell, change zfinit to
zfinit -n.  It is helpful (though not essential) if the call to zfinit
appears after any code to initialize the new completion system, else
unnecessary compctl commands will be given.

23.3 Functions
==============

The sequence of operations in performing a file transfer is essentially
the same as that in a standard FTP client.  Note that, due to a quirk
of the shell's getopts builtin, for those functions that handle options
you must use `--' rather than `-' to ensure the remaining arguments are
treated literally (a single `-' is treated as an argument).

23.3.1 Opening a connection
---------------------------

zfparams [ HOST [ USER [ PASSWORD ... ] ] ]
     Set or show the parameters for a future zfopen with no arguments.
     If no arguments are given, the current parameters are displayed
     (the password will be shown as a line of asterisks).  If a host is
     given, and either the USER or PASSWORD is not, they will be
     prompted for; also, any parameter given as `?' will be prompted
     for, and if the `?' is followed by a string, that will be used as
     the prompt.  As zfopen calls zfparams to store the parameters,
     this usually need not be called directly.

     A single argument `-' will delete the stored parameters.  This will
     also cause the memory of the last directory (and so on) on the
     other host to be deleted.

zfopen [ -1 ] [ HOST [ USER [ PASSWORD [ ACCOUNT ] ] ] ]
     If HOST is present, open a connection to that host under username
     USER with password PASSWORD (and, on the rare occasions when it is
     necessary, account ACCOUNT).  If a necessary parameter is missing
     or given as `?' it will be prompted for.  If HOST is not present,
     use a previously stored set of parameters.

     If the command was successful, and the terminal is compatible with
     xterm or is sun-cmd, a summary will appear in the title bar,
     giving the local host:directory and the remote host:directory;
     this is handled by the function zftp_chpwd, described below.

     Normally, the HOST, USER and PASSWORD are internally recorded for
     later re-opening, either by a zfopen with no arguments, or
     automatically (see below).  With the option `-1', no information is
     stored.  Also, if an open command with arguments failed, the
     parameters will not be retained (and any previous parameters will
     also be deleted).  A zfopen on its own, or a zfopen -1, never
     alters the stored parameters.

     Both zfopen and zfanon (but not zfparams) understand URLs of the
     form ftp://HOST/PATH... as meaning to connect to the HOST, then
     change directory to PATH (which must be a directory, not a file).
     The `ftp://' can be omitted; the trailing `/' is enough to trigger
     recognition of the PATH.  Note prefixes other than `ftp:' are not
     recognized, and that all characters after the first slash beyond
     HOST are significant in PATH.

zfanon [ -1 ] HOST
     Open a connection HOST for anonymous FTP.  The username used is
     `anonymous'.  The password (which will be reported the first time)
     is generated as USER@HOST; this is then stored in the shell
     parameter $EMAIL_ADDR which can alternatively be set manually to a
     suitable string.

23.3.2 Directory management
---------------------------

zfcd [ DIR ]
zfcd -
zfcd OLD NEW
     Change the current directory on the remote server:  this is
     implemented to have many of the features of the shell builtin cd.

     In the first form with DIR present, change to the directory DIR.
     The command `zfcd ..' is treated specially, so is guaranteed to
     work on non-UNIX servers (note this is handled internally by
     zftp).  If DIR is omitted, has the effect of `zfcd ~'.

     The second form changes to the directory previously current.

     The third form attempts to change the current directory by
     replacing the first occurrence of the string OLD with the string
     NEW in the current directory.

     Note that in this command, and indeed anywhere a remote filename is
     expected, the string which on the local host corresponds to `~' is
     converted back to a `~' before being passed to the remote machine.
     This is convenient because of the way expansion is performed on
     the command line before zfcd receives a string.  For example,
     suppose the command is `zfcd ~/foo'.  The shell will expand this
     to a full path such as `zfcd /home/user2/pws/foo'.  At this stage,
     zfcd recognises the initial path as corresponding to `~' and will
     send the directory to the remote host as ~/foo, so that the `~'
     will be expanded by the server to the correct remote host
     directory.  Other named directories of the form `~name' are not
     treated in this fashion.

zfhere
     Change directory on the remote server to the one corresponding to
     the current local directory, with special handling of `~' as in
     zfcd.  For example, if the current local directory is ~/foo/bar,
     then zfhere performs the effect of `zfcd ~/foo/bar'.

zfdir [ -rfd ] [ - ] [ DIR-OPTIONS ] [ DIR ]
     Produce a long directory listing.  The arguments DIR-OPTIONS and
     DIR are passed directly to the server and their effect is
     implementation dependent, but specifying a particular remote
     directory DIR is usually possible.  The output is passed through a
     pager given by the environment variable $PAGER, or `more' if that
     is not set.

     The directory is usually cached for re-use.  In fact, two caches
     are maintained.  One is for use when there is no DIR-OPTIONS or
     DIR, i.e. a full listing of the current remote directory; it is
     flushed when the current remote directory changes.  The other is
     kept for repeated use of zfdir with the same arguments; for
     example, repeated use of `zfdir /pub/gnu' will only require the
     directory to be retrieved on the first call.  Alternatively, this
     cache can be re-viewed with the -r option.  As relative
     directories will confuse zfdir, the -f option can be used to force
     the cache to be flushed before the directory is listed.  The
     option -d will delete both caches without showing a directory
     listing; it will also delete the cache of file names in the
     current remote directory, if any.

zfls [ LS-OPTIONS ] [ DIR ]
     List files on the remote server.  With no arguments, this will
     produce a simple list of file names for the current remote
     directory.  Any arguments are passed directly to the server.  No
     pager and no caching is used.

23.3.3 Status commands
----------------------

zftype [ TYPE ]
     With no arguments, show the type of data to be transferred,
     usually ASCII or binary.  With an argument, change the type: the
     types `A' or `ASCII' for ASCII data and `B' or `BINARY', `I' or
     `IMAGE' for binary data are understood case-insensitively.

zfstat [ -v ]
     Show the status of the current or last connection, as well as the
     status of some of zftp's status variables.  With the -v option, a
     more verbose listing is produced by querying the server for its
     version of events, too.

23.3.4 Retrieving files
-----------------------

The commands for retrieving files all take at least two options. -G
suppresses remote filename expansion which would otherwise be performed
(see below for a more detailed description of that).  -t attempts to
set the modification time of the local file to that of the remote file:
this requires version 5 of perl, see the description of the function
zfrtime below for more information.

zfget [ -Gtc ] FILE1 ...
     Retrieve all the listed files FILE1 ... one at a time from the
     remote server.  If a file contains a `/', the full name is passed
     to the remote server, but the file is stored locally under the
     name given by the part after the final `/'.  The option -c (cat)
     forces all files to be sent as a single stream to standard output;
     in this case the -t option has no effect.

zfuget [ -Gvst ] FILE1 ...
     As zfget, but only retrieve files where the version on the remote
     server is newer (has a later modification time), or where the
     local file does not exist.  If the remote file is older but the
     files have different sizes, or if the sizes are the same but the
     remote file is newer, the user will usually be queried.  With the
     option -s, the command runs silently and will always retrieve the
     file in either of those two cases.  With the option -v, the
     command prints more information about the files while it is
     working out whether or not to transfer them.

zfcget [ -Gt ] FILE1 ...
     As zfget, but if any of the local files exists, and is shorter than
     the corresponding remote file, the command assumes that it is the
     result of a partially completed transfer and attempts to transfer
     the rest of the file.  This is useful on a poor connection which
     keeps failing.

     Note that this requires a commonly implemented, but non-standard,
     version of the FTP protocol, so is not guaranteed to work on all
     servers.

zfgcp [ -Gt ] REMOTE-FILE LOCAL-FILE
zfgcp [ -Gt ] RFILE1 ... LDIR
     This retrieves files from the remote server with arguments behaving
     similarly to the cp command.

     In the first form, copy REMOTE-FILE from the server to the local
     file LOCAL-FILE.

     In the second form, copy all the remote files RFILE1 ... into the
     local directory LDIR retaining the same basenames.  This assumes
     UNIX directory semantics.

23.3.5 Sending files
--------------------

zfput [ -r ] FILE1 ...
     Send all the FILE1 ... given separately to the remote server.  If a
     filename contains a `/', the full filename is used locally to find
     the file, but only the basename is used for the remote file name.

     With the option -r, if any of the FILES are directories they are
     sent recursively with all their subdirectories, including files
     beginning with `.'.  This requires that the remote machine
     understand UNIX file semantics, since `/' is used as a directory
     separator.

zfuput [ -vs ] FILE1 ...
     As zfput, but only send files which are newer than their local
     equivalents, or if the remote file does not exist.  The logic is
     the same as for zfuget, but reversed between local and remote
     files.

zfcput FILE1 ...
     As zfput, but if any remote file already exists and is shorter
     than the local equivalent, assume it is the result of an
     incomplete transfer and send the rest of the file to append to the
     existing part.  As the FTP append command is part of the standard
     set, this is in principle more likely to work than zfcget.

zfpcp LOCAL-FILE REMOTE-FILE
zfpcp LFILE1 ... RDIR
     This sends files to the remote server with arguments behaving
     similarly to the cp command.

     With two arguments, copy LOCAL-FILE to the server as REMOTE-FILE.

     With more than two arguments, copy all the local files LFILE1 ...
     into the existing remote directory RDIR retaining the same
     basenames.  This assumes UNIX directory semantics.

     A problem arises if you attempt to use zfpcp LFILE1 RDIR, i.e. the
     second form of copying but with two arguments, as the command has
     no simple way of knowing if RDIR corresponds to a directory or a
     filename.  It attempts to resolve this in various ways.  First, if
     the RDIR argument is `.' or `..' or ends in a slash, it is assumed
     to be a directory.  Secondly, if the operation of copying to a
     remote file in the first form failed, and the remote server sends
     back the expected failure code 553 and a reply including the
     string `Is a directory', then zfpcp will retry using the second
     form.

23.3.6 Closing the connection
-----------------------------

zfclose
     Close the connection.

23.3.7 Session management
-------------------------

zfsession [ -lvod ] [ SESSNAME ]
     Allows you to manage multiple FTP sessions at once.  By default,
     connections take place in a session called `default'; by giving the
     command `zfsession SESSNAME' you can change to a new or existing
     session with a name of your choice.  The new session remembers its
     own connection, as well as associated shell parameters, and also
     the host/user parameters set by zfparams.  Hence you can have
     different sessions set up to connect to different hosts, each
     remembering the appropriate host, user and password.

     With no arguments, zfsession prints the name of the current
     session; with the option -l it lists all sessions which currently
     exist, and with the option -v it gives a verbose list showing the
     host and directory for each session, where the current session is
     marked with an asterisk.  With -o, it will switch to the most
     recent previous session.

     With -d, the given session (or else the current one) is removed;
     everything to do with it is completely forgotten.  If it was the
     only session, a new session called `default' is created and made
     current.  It is safest not to delete sessions while background
     commands using zftp are active.

zftransfer SESS1:FILE1 SESS2:FILE2
     Transfer files between two sessions; no local copy is made.  The
     file is read from the session SESS1 as FILE1 and written to session
     SESS2 as file FILE2; FILE1 and FILE2 may be relative to the
     current directories of the session.  Either SESS1 or SESS2 may be
     omitted (though the colon should be retained if there is a
     possibility of a colon appearing in the file name) and defaults to
     the current session; FILE2 may be omitted or may end with a slash,
     in which case the basename of FILE1 will be added.  The sessions
     SESS1 and SESS2 must be distinct.

     The operation is performed using pipes, so it is required that the
     connections still be valid in a subshell, which is not the case
     under versions of some operating systems, presumably due to a
     system bug.

23.3.8 Bookmarks
----------------

The two functions zfmark and zfgoto allow you to `bookmark' the present
location (host, user and directory) of the current FTP connection for
later use.  The file to be used for storing and retrieving bookmarks is
given by the parameter $ZFTP_BMFILE; if not set when one of the two
functions is called, it will be set to the file .zfbkmarks in the
directory where your zsh startup files live (usually ~).

zfmark [ BOOKMARK ]
     If given an argument, mark the current host, user and directory
     under the name BOOKMARK for later use by zfgoto.  If there is no
     connection open, use the values for the last connection
     immediately before it was closed; it is an error if there was
     none.  Any existing bookmark under the same name will be silently
     replaced.

     If not given an argument, list the existing bookmarks and the
     points to which they refer in the form USER@HOST:DIRECTORY; this
     is the format in which they are stored, and the file may be edited
     directly.

zfgoto [ -n ] BOOKMARK
     Return to the location given by BOOKMARK, as previously set by
     zfmark.  If the location has user `ftp' or `anonymous', open the
     connection with zfanon, so that no password is required.  If the
     user and host parameters match those stored for the current
     session, if any, those will be used, and again no password is
     required.  Otherwise a password will be prompted for.

     With the option -n, the bookmark is taken to be a nickname stored
     by the ncftp program in its bookmark file, which is assumed to be
     ~/.ncftp/bookmarks.  The function works identically in other ways.
     Note that there is no mechanism for adding or modifying ncftp
     bookmarks from the zftp functions.

23.3.9 Other functions
----------------------

Mostly, these functions will not be called directly (apart from
zfinit), but are described here for completeness.  You may wish to
alter zftp_chpwd and zftp_progress, in particular.

zfinit [ -n ]
     As described above, this is used to initialize the zftp function
     system.  The -n option should be used if the zftp command is
     already built into the shell.

zfautocheck [ -dn ]
     This function is called to implement automatic reopening
     behaviour, as described in more detail below.  The options must
     appear in the first argument; -n prevents the command from
     changing to the old directory, while -d prevents it from setting
     the variable do_close, which it otherwise does as a flag for
     automatically closing the connection after a transfer.  The host
     and directory for the last session are stored in the variable
     $zflastsession, but the internal host/user/password parameters
     must also be correctly set.

zfcd_match PREFIX SUFFIX
     This performs matching for completion of remote directory names.
     If the remote server is UNIX, it will attempt to persuade the
     server to list the remote directory with subdirectories marked,
     which usually works but is not guaranteed.  On other hosts it
     simply calls zfget_match and hence completes all files, not just
     directories.  On some systems, directories may not even look like
     filenames.

zfget_match PREFIX SUFFIX
     This performs matching for completion of remote filenames.  It
     caches files for the current directory (only) in the shell
     parameter $zftp_fcache.  It is in the form to be called by the -K
     option of compctl, but also works when called from a widget-style
     completion function with PREFIX and SUFFIX set appropriately.

zfrglob VARNAME
     Perform remote globbing, as describes in more detail below.
     VARNAME is the name of a variable containing the pattern to be
     expanded; if there were any matches, the same variable will be set
     to the expanded set of filenames on return.

zfrtime LFILE RFILE [ TIME ]
     Set the local file LFILE to have the same modification time as the
     remote file RFILE, or the explicit time TIME in FTP format
     CCYYMMDDhhmmSS for the GMT timezone.

     Currently this requires perl version 5 to perform the conversion
     from GMT to local time.  This is unfortunately difficult to do
     using shell code alone.

zftp_chpwd
     This function is called every time a connection is opened, or
     closed, or the remote directory changes.  This version alters the
     title bar of an xterm-compatible or sun-cmd terminal emulator to
     reflect the local and remote hostnames and current directories.
     It works best when combined with the function chpwd.  In
     particular, a function of the form

          chpwd() {
            if [[ -n $ZFTP_USER ]]; then
              zftp_chpwd
            else
              # usual chpwd e.g put host:directory in title bar
            fi
          }

     fits in well.

zftp_progress
     This function shows the status of the transfer.  It will not write
     anything unless the output is going to a terminal; however, if you
     transfer files in the background, you should turn off progress
     reports by hand using `zstyle ':zftp:*' progress none'.  Note also
     that if you alter it, any output _must_ be to standard error, as
     standard output may be a file being received.  The form of the
     progress meter, or whether it is used at all, can be configured
     without altering the function, as described in the next section.

zffcache
     This is used to implement caching of files in the current
     directory for each session separately.  It is used by zfget_match
     and zfrglob.

23.4 Miscellaneous Features
===========================

23.4.1 Configuration
--------------------

Various styles are available using the standard shell style mechanism,
described in The zsh/zutil Module. Briefly, the command `zstyle
':zftp:*' STYLE VALUE ...'.  defines the STYLE to have value VALUE;
more than one value may be given, although that is not useful in the
cases described here.  These values will then be used throughout the
zftp function system.  For more precise control, the first argument,
which gives a context in which the style applies, can be modified to
include a particular function, as for example `:zftp:zfget': the style
will then have the given value only in the zfget function.  Values for
the same style in different contexts may be set; the most specific
function will be used, where strings are held to be more specific than
patterns, and longer patterns and shorter patterns.  Note that only the
top level function name, as called by the user, is used; calling of
lower level functions is transparent to the user.  Hence modifications
to the title bar in zftp_chpwd use the contexts :zftp:zfopen,
:zftp:zfcd, etc., depending where it was called from.  The following
styles are understood:

progress
     Controls the way that zftp_progress reports on the progress of a
     transfer.  If empty, unset, or `none', no progress report is made;
     if `bar' a growing bar of inverse video is shown; if `percent' (or
     any other string, though this may change in future), the
     percentage of the file transferred is shown.  The bar meter
     requires that the width of the terminal be available via the
     $COLUMNS parameter (normally this is set automatically).  If the
     size of the file being transferred is not available, bar and
     percent meters will simply show the number of bytes transferred so
     far.

     When zfinit is run, if this style is not defined for the context
     :zftp:*, it will be set to `bar'.

update
     Specifies the minimum time interval between updates of the
     progress meter in seconds.  No update is made unless new data has
     been received, so the actual time interval is limited only by
     $ZFTP_TIMEOUT.

     As described for progress, zfinit will force this to default to 1.

remote-glob
     If set to `1', `yes' or `true', filename generation (globbing) is
     performed on the remote machine instead of by zsh itself; see
     below.

titlebar
     If set to `1', `yes' or `true', zftp_chpwd will put the remote
     host and remote directory into the titlebar of terminal emulators
     such as xterm or sun-cmd that allow this.

     As described for progress, zfinit will force this to default to 1.

chpwd
     If set to `1' `yes' or `true', zftp_chpwd will call the function
     chpwd when a connection is closed.  This is useful if the remote
     host details were put into the terminal title bar by zftp_chpwd
     and your usual chpwd also modifies the title bar.

     When zfinit is run, it will determine whether chpwd exists and if
     so it will set the default value for the style to 1 if none exists
     already.

Note that there is also an associative array zfconfig which contains
values used by the function system.  This should not be modified or
overwritten.

23.4.2 Remote globbing
----------------------

The commands for retrieving files usually perform filename generation
(globbing) on their arguments; this can be turned off by passing the
option -G to each of the commands.  Normally this operates by
retrieving a complete list of files for the directory in question, then
matching these locally against the pattern supplied.  This has the
advantage that the full range of zsh patterns (respecting the setting
of the option EXTENDED_GLOB) can be used.  However, it means that the
directory part of a filename will not be expanded and must be given
exactly.  If the remote server does not support the UNIX directory
semantics, directory handling is problematic and it is recommended that
globbing only be used within the current directory.  The list of files
in the current directory, if retrieved, will be cached, so that
subsequent globs in the same directory without an intervening zfcd are
much faster.

If the remote-glob style (see above) is set, globbing is instead
performed on the remote host: the server is asked for a list of matching
files.  This is highly dependent on how the server is implemented,
though typically UNIX servers will provide support for basic glob
patterns.  This may in some cases be faster, as it avoids retrieving
the entire list of directory contents.

23.4.3 Automatic and temporary reopening
----------------------------------------

As described for the zfopen command, a subsequent zfopen with no
parameters will reopen the connection to the last host (this includes
connections made with the zfanon command).  Opened in this fashion, the
connection starts in the default remote directory and will remain open
until explicitly closed.

Automatic re-opening is also available.  If a connection is not
currently open and a command requiring a connection is given, the last
connection is implicitly reopened.  In this case the directory which
was current when the connection was closed again becomes the current
directory (unless, of course, the command given changes it).  Automatic
reopening will also take place if the connection was close by the
remote server for whatever reason (e.g. a timeout).  It is not
available if the -1 option to zfopen or zfanon was used.

Furthermore, if the command issued is a file transfer, the connection
will be closed after the transfer is finished, hence providing a
one-shot mode for transfers.  This does not apply to directory changing
or listing commands; for example a zfdir may reopen a connection but
will leave it open.  Also, automatic closure will only ever happen in
the same command as automatic opening, i.e a zfdir directly followed by
a zfget will never close the connection automatically.

Information about the previous connection is given by the zfstat
function.  So, for example, if that reports:

     Session:        default
     Not connected.
     Last session:   ftp.bar.com:/pub/textfiles

then the command zfget file.txt will attempt to reopen a connection to
ftp.bar.com, retrieve the file /pub/textfiles/file.txt, and immediately
close the connection again.  On the other hand, zfcd ..  will open the
connection in the directory /pub and leave it open.

Note that all the above is local to each session; if you return to a
previous session, the connection for that session is the one which will
be reopened.

23.4.4 Completion
-----------------

Completion of local and remote files, directories, sessions and
bookmarks is supported.  The older, compctl-style completion is defined
when zfinit is called; support for the new widget-based completion
system is provided in the function Completion/Zsh/Command/_zftp, which
should be installed with the other functions of the completion system
and hence should automatically be available.

24 User Contributions
*********************

24.1 Description
================

The Zsh source distribution includes a number of items contributed by
the user community.  These are not inherently a part of the shell, and
some may not be available in every zsh installation.  The most
significant of these are documented here.  For documentation on other
contributed items such as shell functions, look for comments in the
function source files.

24.2 Utilities
==============

24.2.1 Accessing On-Line Help
-----------------------------

The key sequence ESC h is normally bound by ZLE to execute the run-help
widget (see Zsh Line Editor).  This invokes the run-help
command with the command word from the current input line as its
argument.  By default, run-help is an alias for the man command, so
this often fails when the command word is a shell builtin or a
user-defined function.  By redefining the run-help alias, one can
improve the on-line help provided by the shell.

The helpfiles utility, found in the Util directory of the distribution,
is a Perl program that can be used to process the zsh manual to produce
a separate help file for each shell builtin and for many other shell
features as well.  The autoloadable run-help function, found in
Functions/Misc, searches for these helpfiles and performs several other
tests to produce the most complete help possible for the command.

There may already be a directory of help files on your system; look in
/usr/share/zsh or /usr/local/share/zsh and subdirectories below those,
or ask your system administrator.

To create your own help files with helpfiles, choose or create a
directory where the individual command help files will reside.  For
example, you might choose ~/zsh_help.  If you unpacked the zsh
distribution in your home directory, you would use the commands:

     mkdir ~/zsh_help
     cd ~/zsh_help
     man zshall | colcrt - | \
     perl ~/zsh-4.2.5/Util/helpfiles

Next, to use the run-help function, you need to add lines something
like the following to your .zshrc or equivalent startup file:

     unalias run-help
     autoload run-help
     HELPDIR=~/zsh_help

The HELPDIR parameter tells run-help where to look for the help files.
If your system already has a help file directory installed, set HELPDIR
to the path of that directory instead.

Note that in order for `autoload run-help' to work, the run-help file
must be in one of the directories named in your fpath array (see
Parameters Used By The Shell).  This should already be the case if
you have a standard zsh installation; if it is not, copy
Functions/Misc/run-help to an appropriate directory.

24.2.2 Recompiling Functions
----------------------------

If you frequently edit your zsh functions, or periodically update your
zsh installation to track the latest developments, you may find that
function digests compiled with the zcompile builtin are frequently out
of date with respect to the function source files.  This is not usually
a problem, because zsh always looks for the newest file when loading a
function, but it may cause slower shell startup and function loading.
Also, if a digest file is explicitly used as an element of fpath, zsh
won't check whether any of its source files has changed.

The zrecompile autoloadable function, found in Functions/Misc, can be
used to keep function digests up to date.

zrecompile [ -qt ] [ NAME ... ]
zrecompile [ -qt ] -p ARGS [ -- ARGS ... ]
     This tries to find *.zwc files and automatically re-compile them
     if at least one of the original files is newer than the compiled
     file.  This works only if the names stored in the compiled files
     are full paths or are relative to the directory that contains the
     .zwc file.

     In the first form, each NAME is the name of a compiled file or a
     directory containing *.zwc files that should be checked.  If no
     arguments are given, the directories and *.zwc files in fpath are
     used.

     When -t is given, no compilation is performed, but a return status
     of zero (true) is set if there are files that need to be
     re-compiled and non-zero (false) otherwise.  The -q option quiets
     the chatty output that describes what zrecompile is doing.

     Without the -t option, the return status is zero if all files that
     needed re-compilation could be compiled and non-zero if
     compilation for at least one of the files failed.

     If the -p option is given, the ARGS are interpreted as one or more
     sets of arguments for zcompile, separated by `--'.  For example:

          zrecompile -p \
                     -R ~/.zshrc -- \
                     -M ~/.zcompdump -- \
                     ~/zsh/comp.zwc ~/zsh/Completion/*/_*

     This compiles ~/.zshrc into ~/.zshrc.zwc if that doesn't exist or
     if it is older than ~/.zshrc. The compiled file will be marked for
     reading instead of mapping. The same is done for ~/.zcompdump and
     ~/.zcompdump.zwc, but this compiled file is marked for mapping. The
     last line re-creates the file ~/zsh/comp.zwc if any of the files
     matching the given pattern is newer than it.

     Without the -p option, zrecompile does not create function digests
     that do not already exist, nor does it add new functions to the
     digest.

The following shell loop is an example of a method for creating function
digests for all functions in your fpath, assuming that you have write
permission to the directories:

     for ((i=1; i <= $#fpath; ++i)); do
       dir=$fpath[i]
       zwc=${dir:t}.zwc
       if [[ $dir == (.|..) || $dir == (.|..)/* ]]; then
         continue
       fi
       files=($dir/*(N-.))
       if [[ -w $dir:h && -n $files ]]; then
         files=(${${(M)files%/*/*}#/})
         if ( cd $dir:h &&
              zrecompile -p -U -z $zwc $files ); then
           fpath[i]=$fpath[i].zwc
         fi
       fi
     done

The -U and -z options are appropriate for functions in the default zsh
installation fpath; you may need to use different options for your
personal function directories.

Once the digests have been created and your fpath modified to refer to
them, you can keep them up to date by running zrecompile with no
arguments.

24.2.3 Keyboard Definition
--------------------------

The large number of possible combinations of keyboards, workstations,
terminals, emulators, and window systems makes it impossible for zsh to
have built-in key bindings for every situation.  The zkbd utility,
found in Functions/Misc, can help you quickly create key bindings for
your configuration.

Run zkbd either as an autoloaded function, or as a shell script:

     zsh -f ~/zsh-4.2.5/Functions/Misc/zkbd

When you run zkbd, it first asks you to enter your terminal type; if
the default it offers is correct, just press return.  It then asks you
to press a number of different keys to determine characteristics of your
keyboard and terminal; zkbd warns you if it finds anything out of the
ordinary, such as a Delete key that sends neither ^H nor ^?.

The keystrokes read by zkbd are recorded as a definition for an
associative array named key, written to a file in the subdirectory
.zkbd within either your HOME or ZDOTDIR directory.  The name of the
file is composed from the TERM, VENDOR and OSTYPE parameters, joined by
hyphens.

You may read this file into your .zshrc or another startup file with
the "source" or "." commands, then reference the key parameter in
bindkey commands, like this:

     source ${ZDOTDIR:-$HOME}/.zkbd/$TERM-$VENDOR-$OSTYPE
     [[ -n ${key[Left]} ]] && bindkey "${key[Left]}" backward-char
     [[ -n ${key[Right]} ]] && bindkey "${key[Right]}" forward-char
     # etc.

Note that in order for `autoload zkbd' to work, the zkdb file must be
in one of the directories named in your fpath array (see
Parameters Used By The Shell).  This should already be the case if
you have a standard zsh installation; if it is not, copy
Functions/Misc/zkbd to an appropriate directory.

24.2.4 Dumping Shell State
--------------------------

Occasionally you may encounter what appears to be a bug in the shell,
particularly if you are using a beta version of zsh or a development
release.  Usually it is sufficient to send a description of the problem
to one of the zsh mailing lists (see Mailing Lists), but
sometimes one of the zsh developers will need to recreate your
environment in order to track the problem down.

The script named reporter, found in the Util directory of the
distribution, is provided for this purpose.  (It is also possible to
autoload reporter, but reporter is not installed in fpath by default.)
This script outputs a detailed dump of the shell state, in the form of
another script that can be read with `zsh -f' to recreate that state.

To use reporter, read the script into your shell with the `.'  command
and redirect the output into a file:

     . ~/zsh-4.2.5/Util/reporter > zsh.report

You should check the zsh.report file for any sensitive information such
as passwords and delete them by hand before sending the script to the
developers.  Also, as the output can be voluminous, it's best to wait
for the developers to ask for this information before sending it.

You can also use reporter to dump only a subset of the shell state.
This is sometimes useful for creating startup files for the first time.
Most of the output from reporter is far more detailed than usually is
necessary for a startup file, but the aliases, options, and zstyles
states may be useful because they include only changes from the
defaults.  The bindings state may be useful if you have created any of
your own keymaps, because reporter arranges to dump the keymap creation
commands as well as the bindings for every keymap.

As is usual with automated tools, if you create a startup file with
reporter, you should edit the results to remove unnecessary commands.
Note that if you're using the new completion system, you should _not_
dump the functions state to your startup files with reporter; use the
compdump function instead (see Completion System).

reporter [ STATE ... ]
     Print to standard output the indicated subset of the current shell
     state.  The STATE arguments may be one or more of:

    all
          Output everything listed below.

    aliases
          Output alias definitions.

    bindings
          Output ZLE key maps and bindings.

    completion
          Output old-style compctl commands.  New completion is covered
          by functions and zstyles.

    functions
          Output autoloads and function definitions.

    limits
          Output limit commands.

    options
          Output setopt commands.

    styles
          Same as zstyles.

    variables
          Output shell parameter assignments, plus export commands for
          any environment variables.

    zstyles
          Output zstyle commands.

     If the STATE is omitted, all is assumed.

     With the exception of `all', every STATE can be abbreviated by any
     prefix, even a single letter; thus a is the same as aliases, z is
     the same as zstyles, etc.